/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, PointUtil } from "igniteui-angular-core";
import { INativeCell_$type } from "./INativeCell";
import { RenderingContext } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { CanvasPlaceholderView } from "./CanvasPlaceholderView";
import { DeviceUtils } from "igniteui-angular-core";
import { Random } from "igniteui-angular-core";
import { FontUtil } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export class CanvasGridCellBase extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.q = true;
        this.o = true;
        this.k = null;
        this.bj = null;
        this.bw = null;
        this.l = false;
        this.an = 1;
        this.ar = 5;
        this.at = 5;
        this.as = 5;
        this.aq = 5;
        this.cs = null;
        this.af = 0;
        this.ah = 0;
        this.ag = 0;
        this.ae = 0;
        this.cz = new Rectangle();
        this.cw = new Line();
        this.cy = new Line();
        this.cx = new Line();
        this.cv = new Line();
        this.ax = 0;
        this.az = 0;
        this.a0 = 0;
        this.a1 = 0;
        this.bl = null;
        this.j = null;
        this.aj = 0;
        this.ai = 0;
        this.al = 0;
        this.ak = 0;
        this.s = true;
        this.ay = NaN;
        this.cr = new TextBlock();
        this.cu = Color.u(255, 0, 0, 0);
        this.r = true;
        this.ap = 0;
        this.a2 = 0;
        this.ct = Color.u(255, 255, 255, 255);
        this.m = false;
        this.g = null;
        this.c = 0;
        this.e = 0;
        this.bv = 1;
        this.aw = 0;
        this.av = 0;
        this.i = ((() => {
            let $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 12;
            return $ret;
        })());
        this.p = true;
        this.bo = -1;
        this.bt = 0;
        this.bu = 0;
        this.n = false;
        this.bm = 0;
        this.b = 0;
        this.ao = NaN;
        this.h = null;
        this.bq = -1;
        this.am = NaN;
        this.f = 1;
        this.au = 1;
        this.bj = a;
    }
    get x() {
        return this.o;
    }
    set x(a) {
        this.o = a;
    }
    ch(a) {
        this.k = a;
    }
    b2() {
        this.o = true;
        if (this.k != null) {
            this.k();
        }
    }
    get isCanvasBased() {
        return true;
    }
    get bk() {
        return this.bj;
    }
    ci(a) {
        this.bw = a;
        this.o = true;
        this.q = true;
    }
    get templateContext() {
        return this.j.g();
    }
    get t() {
        return this.l;
    }
    set t(a) {
        this.l = a;
    }
    get_z() {
        return false;
    }
    get z() {
        return this.get_z();
    }
    b9(a, b, c, d, e) {
        this.o = true;
        this.cs = a;
        this.af = b;
        this.ah = c;
        this.ag = d;
        this.ae = e;
        this.q = true;
    }
    ca(a) {
        this.o = true;
        this.an = a;
        this.cr._opacity = this.an;
    }
    get a9() {
        return this.ar;
    }
    get bb() {
        return this.at;
    }
    get ba() {
        return this.as;
    }
    get a8() {
        return this.aq;
    }
    get a4() {
        return this.af;
    }
    get a6() {
        return this.ah;
    }
    get a5() {
        return this.ag;
    }
    get a3() {
        return this.ae;
    }
    get bd() {
        return this.ax;
    }
    get bf() {
        return this.az;
    }
    get bg() {
        return this.a1;
    }
    get_aa() {
        return false;
    }
    get aa() {
        return this.get_aa();
    }
    by(a, b, c, d, e, f) {
        let g = true;
        let h = true;
        let i = false;
        if (this.aa) {
            g = false;
            h = false;
            i = false;
        }
        this.bz(a, b, c, d, e, f, g, h, i);
    }
    get resized() {
        return this.s;
    }
    ensureCorrectSize() {
        this.s = this.u(this.au);
        return this.s;
    }
    bz(a, b, c, d, e, f, g, h, i) {
        if (!this.r) {
            return;
        }
        if (this.bv != 1) {
            a.ad(this.bv);
        }
        this.au = f;
        if (!i) {
            this.b0();
            this.ensureCorrectSize();
        }
        if (this.x || this.s || i) {
            this.x = false;
            let j = this.j;
            if (this.p || this.s || (this.i != null && this.i.g != this.bo)) {
                this.p = false;
                this.bo = this.i.g;
                j.ac(this.i);
            }
            if (f != 1) {
                this.j.z();
                this.j.aa(f, f);
            }
            if (g) {
                this.b3();
            }
            if (h) {
                this.b4(this.j);
            }
            if (f != 1) {
                this.j.y();
            }
        }
        if (!i) {
            let k = Math.round((d - b) * f);
            let l = Math.round((e - c) * f);
            if (this.aj == this.al && this.ai == this.ak) {
                a.m(this.bl.getNativeElement(), 1, k, l, this.aj, this.ai);
            }
            else {
                a.n(this.bl.getNativeElement(), 1, 0, 0, this.aj, this.ai, k, l, this.aj, this.ai);
            }
        }
        if (this.bv != 1) {
            a.ad(1);
        }
    }
    b3() {
        if (!this.m) {
            this.j.k(0, 0, this.al, this.ak);
        }
        this.cz.n = 0;
        this.cz.o = 0;
        this.cz.width = this.a2;
        this.cz.height = this.ap;
        this.j.v(this.cz);
        if (this.cs != null) {
            if (this.af > 0) {
                this.cw.am = 0;
                this.cw.ak = this.af / 2;
                this.cw.an = this.ap;
                this.cw.al = this.af / 2;
                this.cw._stroke = this.cs;
                this.cw.ac = this.af;
                this.j.r(this.cw);
            }
            if (this.ag > 0) {
                this.cx.am = 0;
                this.cx.ak = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cx.an = this.ap;
                this.cx.al = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cx._stroke = this.cs;
                this.cx.ac = this.ag;
                this.j.r(this.cx);
            }
            if (this.ah > 0) {
                this.cy.am = this.ah / 2;
                this.cy.ak = this.af;
                this.cy.an = this.ah / 2;
                this.cy.al = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cy._stroke = this.cs;
                this.cy.ac = this.ah;
                this.j.r(this.cy);
            }
            if (this.ae > 0) {
                this.cv.am = Math.max(0, this.ap - (this.ae / 2));
                this.cv.ak = this.af;
                this.cv.an = Math.max(0, this.ap - (this.ae / 2));
                this.cv.al = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cv._stroke = this.cs;
                this.cv.ac = this.ae;
                this.j.r(this.cv);
            }
        }
    }
    cg(a) {
        this.au = a;
    }
    renderStandardContent() {
        this.bz(this.j, 0, 0, 0, 0, this.au, false, true, true);
    }
    renderStandardBackground() {
        this.bz(this.j, 0, 0, 0, 0, this.au, true, false, true);
    }
    b4(a) {
        if (this.q) {
            this.cq();
            this.q = false;
        }
        if (this.cr.ak != null) {
            this.cr.n = this.ax;
            this.cr.o = this.a0;
            this.j.w(this.cr);
        }
    }
    b0() {
        if (this.bl == null) {
            this.bl = this.bj.createElement("canvas");
            let a = this.bj.get2DCanvasContext(this.bl);
            let b = ((() => {
                let $ret = new CanvasViewRenderer();
                $ret.h$d = a;
                return $ret;
            })());
            this.j = new RenderingContext(b, a);
            this.q = true;
        }
    }
    u(a) {
        let b = Math.round(this.a2 * a);
        let c = Math.round(this.ap * a);
        this.aj = b;
        this.ai = c;
        let d = this.bc(b);
        let e = this.bc(c);
        if (d != this.al || e != this.ak) {
            this.bl.setAttribute("width", d + "px");
            this.bl.setAttribute("height", e + "px");
            this.al = d;
            this.ak = e;
            this.aj = b;
            this.ai = c;
            return true;
        }
        return false;
    }
    bc(a) {
        return a;
    }
    cf(a, b, c, d) {
        this.o = true;
        this.ar = a;
        this.at = b;
        this.as = c;
        this.aq = d;
        this.q = true;
    }
    get be() {
        return this.ay;
    }
    set be(a) {
        this.ay = a;
    }
    cj(a) {
        this.o = true;
        this.cu = a;
        this.cr.am = ((() => {
            let $ret = new Brush();
            $ret.color = this.cu;
            return $ret;
        })());
    }
    get_y() {
        return false;
    }
    get y() {
        return this.get_y();
    }
    get ab() {
        return this.r;
    }
    set ab(a) {
        this.o = true;
        this.r = a;
    }
    get a7() {
        return this.ap;
    }
    get bi() {
        return this.a2;
    }
    cc(a) {
        this.o = true;
        this.ap = a;
        this.cz.height = this.ap;
    }
    cl(a) {
        this.o = true;
        this.a2 = a;
        this.cz.width = this.a2;
        this.q = true;
    }
    bx() {
        if (!this.z) {
            return;
        }
        this.l = true;
        this.g = new CanvasPlaceholderView();
        this.c = 0;
        this.e = 1;
        this.g.l = Color.u(120, 120, 120, 120);
        this.g.h = 0;
    }
    b8(a) {
        this.o = true;
        this.ct = a;
        this.m = this.ct.l == 255;
        this.cz._fill = ((() => {
            let $ret = new Brush();
            $ret.color = this.ct;
            return $ret;
        })());
    }
    ce(a) {
        this.o = true;
        this.bv = a;
    }
    cp(a) {
        if (!this.z) {
            return;
        }
        this.o = true;
        this.g.h = (a * 0.20000000298023224);
    }
    b1(a, b, c, d) {
        if (this.g != null) {
            let e = this.aw;
            let f = this.av;
            if (this.e == 1) {
                b = truncate((b + (d / 2) - (f / 2)));
            }
            else if (this.e == 2) {
                b = truncate((b + (d) - (f)));
            }
            if (this.c == 1) {
                a = truncate((a + (c / 2) - (e / 2)));
            }
            else if (this.c == 2) {
                a = truncate((a + (c) - (e)));
            }
        }
    }
    cb(a) {
        this.i = a;
        this.p = true;
        this.o = true;
        this.q = true;
    }
    co(a) {
        if (!this.z) {
            return;
        }
        this.o = true;
        let b = DeviceUtils.f(12);
        if (a.x != null && !isNaN_(a.x.d)) {
            b = a.x.d;
        }
        if (this.av != b) {
            this.av = b;
        }
        let c = a.e2 * 0.2;
        let d = a.dt * 0.6;
        if (this.aw >= c && this.aw <= d) {
            return;
        }
        let e = (CanvasGridCellBase.bs.nextDouble() * (d - c) + c);
        if (this.aw != e) {
            this.aw = e;
        }
    }
    cm(a, b) {
        if (!this.z) {
            return;
        }
        this.o = true;
        this.c = a;
        this.e = b;
    }
    cn(a) {
        if (!this.z) {
            return;
        }
        this.o = true;
    }
    b7(a) {
        this.a = a;
    }
    get d() {
        return this.b;
    }
    cd(a) {
        this.b = a;
        this.o = true;
        this.q = true;
    }
    cq() {
        if (this.bw == null) {
            return;
        }
        if (this.j == null) {
            return;
        }
        if (this.p || (this.i != null && this.i.g != this.bo)) {
            this.p = false;
            this.bo = this.i.g;
            this.j.ac(this.i);
        }
        let a;
        if (this.h != this.i || this.bq != this.i.g) {
            this.h = this.i;
            this.bq = this.i.g;
            this.ao = FontUtil.getCurrentFontHeight(this.bj, this.i);
        }
        a = this.ao;
        let b = 0;
        let c = 0;
        let d = this.a2;
        let e = this.ap;
        d -= (this.af + this.ar + this.ag + this.as);
        e -= (this.ah + this.at + this.ae + this.aq);
        d = Math.max(d, 0);
        e = Math.max(e, 0);
        let f = d;
        if (!isNaN_(this.ay) && this.ay < d) {
            f = this.ay;
        }
        let g = this.bh(this.cr, this.bw, f, this.j);
        switch (this.b) {
            case 0:
                b = this.ar + this.af;
                break;
            case 3:
            case 1:
                b = this.ar + this.af + ((d / 2) - (g / 2));
                break;
            case 2:
                b = Math.max(0, (this.a2 - (this.as + this.ag))) - g;
                break;
        }
        switch (this.f) {
            case 0:
                c = this.at + this.ah;
                break;
            case 3:
            case 1:
                c = this.at + this.ah + ((e / 2) - (a / 2));
                break;
            case 2:
                c = Math.max(0, (this.ap - (this.aq + this.ae))) - a;
                break;
        }
        this.ax = b;
        this.az = this.ax + g;
        this.a0 = c;
        this.a1 = this.a0 + (a / 2);
        this.o = true;
    }
    bh(a, b, c, d) {
        let e = b;
        let f = e.length;
        let g = ("\u2026");
        if (isNaN_(this.am)) {
            this.am = d.f(g);
        }
        if (c <= this.am) {
            a.ak = g;
            return this.am;
        }
        let h = d.f(e);
        if (h <= c) {
            a.ak = b;
            return h;
        }
        let i = c / h;
        let j = truncate(Math.ceil(f * i));
        let k = e.substr(0, j) + g;
        let l = d.f(k);
        if (l > c) {
            f = j;
        }
        else {
            j = j + 1;
            k = e.substr(0, j) + g;
            l = d.f(k);
            if (l > c) {
                f = j;
            }
        }
        while (h > c && f > 0) {
            f--;
            e = e.substr(0, f) + g;
            h = d.f(e);
        }
        a.ak = e;
        return h;
    }
    ck(a) {
        this.f = a;
        this.o = true;
        this.q = true;
    }
    ad(a) {
        return a.isClickActionDesired;
    }
    onContactStarted(a, b) {
        if (this.a != null && this.ad(this.a)) {
            this.bt = a.pageX;
            this.bu = a.pageY;
            this.a.mouseDownCell(this.bt, this.bu);
        }
    }
    onContactMoved(a, b) {
        if (this.a != null && this.ad(this.a)) {
            let c = a.pageX;
            let d = a.pageY;
            if (this.a.isMouseDown) {
                if (b) {
                    if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bp || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bp) {
                        this.a.mouseUpCell(c, d);
                    }
                    else {
                        a.stopPropagation();
                    }
                }
                else {
                    if (PointUtil.equals(this.a.mousePosition, null)) {
                        this.a.mouseUpCell(c, d);
                    }
                    else {
                        if (Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bn || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bn) {
                            this.a.isControlPressed = a.ctrlKey;
                            this.a.dragStarted();
                        }
                    }
                }
            }
        }
    }
    onContactCompleted(a, b) {
        if (this.a != null && this.ad(this.a)) {
            let c = a.pageX;
            let d = a.pageY;
            if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bp || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bp || this.a.isDrag) {
                this.a.mouseUpCell(c, d);
            }
            if (this.a.isCellDown()) {
                this.a.isControlPressed = a.ctrlKey;
                this.a.isShiftPressed = a.shiftKey;
                this.a.clickCell();
                this.a.mouseUpCell(a.pageX, a.pageY);
            }
        }
    }
}
CanvasGridCellBase.$t = markType(CanvasGridCellBase, 'CanvasGridCellBase', Base.$, [INativeCell_$type]);
CanvasGridCellBase.bs = new Random(0);
CanvasGridCellBase.bp = 10;
CanvasGridCellBase.bn = 3;
//# sourceMappingURL=CanvasGridCellBase.js.map