/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { StringBuilder } from "igniteui-angular-core";
import { stringIsNullOrEmpty, stringEndsWith } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export class CellModelExport extends Base {
    constructor() {
        super(...arguments);
        this.p = 0;
        this.q = 0;
        this.l = 0;
        this.m = 0;
        this.i = 0;
        this.o = 0;
        this.k = 0;
        this.g = 0;
        this.j = 0;
        this.a = null;
        this.c = 0;
        this.d = 0;
        this.y = null;
        this.b = null;
        this.u = null;
        this.v = null;
        this.w = null;
        this.h = 0;
        this.s = null;
        this.t = null;
        this.n = 0;
        this.e = 0;
        this.r = 0;
        this.f = false;
        this.x = null;
    }
    z() {
        let a = new StringBuilder(0);
        a.l("{ ");
        a.l("type : \"" + this.aa + "\", ");
        a.l("x : " + this.p + ", ");
        a.l("y : " + this.q + ", ");
        a.l("snappedX : " + this.l + ", ");
        a.l("snappedY : " + this.m + ", ");
        a.l("height : " + this.i + ", ");
        a.l("width : " + this.o + ", ");
        a.l("lineBreakMode: \"" + this.x + "\", ");
        a.l("selectedStatus : " + this.k + ", ");
        a.l("activationStatus : " + this.g + ", ");
        a.l("virtualizationPercentage : " + this.n + ", ");
        a.l("backgroundBrushData : " + this.a.serialize() + ", ");
        a.l("opacity : " + this.j + ", ");
        if (this.c != null) {
            a.l("horizontalAlignment : " + this.c + ", ");
        }
        if (this.d != null) {
            a.l("verticalAlignment : " + this.d + ", ");
        }
        a.l("renderValue : \"" + this.y + "\", ");
        if (this.b != null) {
            a.l("textColor : " + this.b.serialize() + ", ");
        }
        if (!stringIsNullOrEmpty(this.u)) {
            a.l("fontStyle : \"" + this.u + "\", ");
        }
        if (!stringIsNullOrEmpty(this.v)) {
            a.l("fontVariant : \"" + this.v + "\", ");
        }
        if (!stringIsNullOrEmpty(this.w)) {
            a.l("fontWeight : \"" + this.w + "\", ");
        }
        if (!stringIsNullOrEmpty(this.s)) {
            a.l("fontFamily : \"" + this.s + "\", ");
        }
        if (!stringIsNullOrEmpty(this.t)) {
            a.l("fontStretch : \"" + this.t + "\", ");
        }
        if (!isNaN_(this.h)) {
            a.l("fontSize : " + this.h + ", ");
        }
        a.l("sortDirection : " + this.e + ", ");
        a.l("indent : " + this.r + ", ");
        a.l("isCollapsable : " + this.f.toString().toLowerCase() + ", ");
        this.ab(a);
        let b = a.toString();
        if (stringEndsWith(b, ", ")) {
            b = b.substr(0, b.length - 2);
        }
        b += "} ";
        return b;
    }
    get_aa() {
        return "Cell";
    }
    get aa() {
        return this.get_aa();
    }
    ab(a) {
    }
}
CellModelExport.$t = markType(CellModelExport, 'CellModelExport');
//# sourceMappingURL=CellModelExport.js.map