/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ColumnSummaryDescription } from "./ColumnSummaryDescription";
import { SummaryDescription } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ColumnSummaryDescriptionCollection extends Base {
    constructor() {
        super();
        this.f = new SyncableObservableCollection$2(ColumnSummaryDescription.$, SummaryDescription.$, 0);
        this.a = null;
        let a = this.f;
        a.compare = (b, c) => b.t == c.propertyName && b.e == c.operand && b.c == c.calculator;
        a.createFrom = (b) => {
            let c = new ColumnSummaryDescription(1, b.propertyName);
            c.e = b.operand;
            c.c = b.calculator;
            return c;
        };
        a.createTo = (b) => {
            let c = new SummaryDescription(1, b.t);
            c.operand = b.e;
            c.calculator = b.c;
            return c;
        };
    }
    get b() {
        return this.a;
    }
    set b(a) {
        if (a == null) {
            this.f.syncTarget = null;
            this.a = null;
            return;
        }
        this.a = a;
        this.f.syncTarget = this.a.g();
    }
    g(a) {
        return this.f.add(a);
    }
    n(a, b) {
        this.f.add1(a, b);
    }
    m() {
        this.f.clear();
    }
    get(a) {
        return this.f.get(a);
    }
    j(a) {
        return this.f.indexOf(a);
    }
    h(a) {
        return this.f.remove1(a);
    }
    d(a) {
        return this.f.remove(a);
    }
    set(a, b) {
        return this.f.set(a, b);
    }
    size() {
        return this.f.size();
    }
    l(a) {
        this.f.addListener(a);
    }
    o(a) {
        this.f.removeListener(a);
    }
    get i() {
        return this.f.all;
    }
}
ColumnSummaryDescriptionCollection.$t = markType(ColumnSummaryDescriptionCollection, 'ColumnSummaryDescriptionCollection');
//# sourceMappingURL=ColumnSummaryDescriptionCollection.js.map