/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, PointUtil } from "igniteui-angular-core";
import { INativeCell_$type } from "./INativeCell";
import { GridExpansionIndicator } from "./GridExpansionIndicator";
import { PlaceholderView } from "./PlaceholderView";
import { Color } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { Random } from "igniteui-angular-core";
import { intDivide, truncate, isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export class GridCellBase extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.t = null;
        this.v = null;
        this.w = null;
        this.e = null;
        this.ah = 0;
        this.ae = 24;
        this.ag = 0;
        this.af = 0;
        this.ak = 0;
        this.i = false;
        this.j = false;
        this.g = false;
        this.am = 0;
        this.ao = 0;
        this.an = 0;
        this.al = 0;
        this.aa = 0;
        this.ac = 0;
        this.ab = 0;
        this.z = 0;
        this.bw = null;
        this.ai = 0;
        this.aq = 0;
        this.aj = 0;
        this.f = null;
        this.c = 0;
        this.d = 0;
        this.s = 0;
        this.r = 0;
        this.k = false;
        this.aw = 0;
        this.ax = 0;
        this.y = 0;
        this.h = false;
        this.t = a;
        this.v = this.t.createElement("div");
        this.v.setRawStyleProperty("position", "absolute");
        this.v.setRawStyleProperty("overflow", "hidden");
        this.v.setRawStyleProperty("box-sizing", "border-box");
        let b = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        let c = (window.PointerEvent || window.navigator.pointerEnabled);
        let d = (window.TouchEvent);
        if ((b || c)) {
            this.v.listen("pointerdown", runOn(this, this.ba));
            this.v.listen("pointerup", runOn(this, this.bd));
            this.v.listen("pointermove", runOn(this, this.bc));
            this.v.listen("pointerleave", runOn(this, this.bb));
        }
        else {
            this.v.listen("mousedown", runOn(this, this.a3));
            this.v.listen("mouseup", runOn(this, this.a6));
            this.v.listen("mousemove", runOn(this, this.a5));
            this.v.listen("mouseleave", runOn(this, this.a4));
            this.v.listen("touchstart", runOn(this, this.bo));
            this.v.listen("touchend", runOn(this, this.bq));
            this.v.listen("touchmove", runOn(this, this.bp));
        }
    }
    get b() {
        return this.a;
    }
    get u() {
        return this.t;
    }
    get x() {
        return this.v;
    }
    get at() {
        return this.ah;
    }
    get ar() {
        return this.af;
    }
    get as() {
        return this.ag;
    }
    get au() {
        return this.ak;
    }
    set au(a) {
        let b = this.ak;
        this.ak = a;
        if (b != this.ak) {
            this.a9("Indent", b, this.ak);
        }
    }
    get m() {
        return this.i;
    }
    set m(a) {
        let b = this.i;
        this.i = a;
        if (b != this.i) {
            this.a9("IsCollapsable", b, this.i);
        }
    }
    get n() {
        return this.j;
    }
    set n(a) {
        let b = this.j;
        this.j = a;
        if (b != this.j) {
            this.a9("IsExpanded", b, this.j);
        }
    }
    a2() {
        this.ag = 10;
        this.af = this.au * 24;
        this.ah = 24;
        if (this.w == null) {
            this.w = this.t.createElement("div");
            this.w.setRawStyleProperty("display", "inline-block");
            this.w.setRawStyleProperty("vertical-align", "middle");
            this.w.setRawStyleProperty("width", this.ah + "px");
            this.w.setRawStyleProperty("height", this.ah + "px");
            this.w.setRawStyleProperty("cursor", "pointer");
            this.w.setRawStyleProperty("position", "absolute");
            this.w.setRawXPosition(this.am + this.af);
            this.w.setRawYPosition(intDivide(this.ai, 2) - intDivide(this.ae, 2));
        }
        if (this.e == null) {
            let a = this.t.getSubRenderer(this.w);
            this.e = new GridExpansionIndicator();
            this.e.ab(a);
            this.e.y(24, 24);
        }
        if (this.w.parent() == null) {
            this.v.append(this.w);
        }
    }
    be() {
        this.ah = 0;
        this.ag = 0;
        if (this.w != null) {
            if (this.w.parent() != null) {
                this.w.remove();
            }
        }
    }
    get l() {
        return this.g;
    }
    set l(a) {
        this.g = a;
    }
    get_p() {
        return false;
    }
    get p() {
        return this.get_p();
    }
    bl(a, b, c, d) {
        this.am = a;
        this.ao = b;
        this.an = c;
        this.al = d;
        this.v.setRawStyleProperty("padding-left", a.toString() + "px");
        this.v.setRawStyleProperty("padding-top", b.toString() + "px");
        this.v.setRawStyleProperty("padding-right", c.toString() + "px");
        this.v.setRawStyleProperty("padding-bottom", d.toString() + "px");
    }
    bh(a, b, c, d, e) {
        this.aa = b;
        this.ac = c;
        this.ab = d;
        this.z = e;
        this.bw = a;
        if (a == null) {
            this.v.setRawStyleProperty("border", "");
        }
        else {
            this.v.setRawStyleProperty("border-color", a._fill);
            this.v.setRawStyleProperty("border-left-width", b.toString() + "px");
            this.v.setRawStyleProperty("border-top-width", c.toString() + "px");
            this.v.setRawStyleProperty("border-right-width", d.toString() + "px");
            this.v.setRawStyleProperty("border-bottom-width", e.toString() + "px");
            this.v.setRawStyleProperty("border-style", "solid");
        }
    }
    get_o() {
        return false;
    }
    get o() {
        return this.get_o();
    }
    bi(a, b) {
        if (this.ai != a || this.aj != b) {
            this.ai = a;
            this.aj = b;
            let c = Math.max(0, this.ai - this.aj);
            this.v.setRawStyleProperty("height", a.toString() + "px");
            this.v.setRawStyleProperty("line-height", c.toString() + "px");
            if (this.w != null) {
                this.w.setRawYPosition(intDivide(this.ai, 2) - intDivide(this.ah, 2));
            }
        }
    }
    bn(a, b) {
        if (this.aq != a) {
            this.aq = a;
            this.v.setRawStyleProperty("width", a.toString() + "px");
        }
    }
    a1() {
        if (!this.p) {
            return;
        }
        this.g = true;
        this.f = new PlaceholderView(this.t);
        this.c = 0;
        this.d = 1;
        this.f.l = Color.u(120, 120, 120, 120);
        this.f.i = 0;
        this.v.append(this.f.g);
    }
    bg(a) {
        this.v.setRawStyleProperty("background-color", a.colorString);
    }
    bk(a) {
        this.v.setRawStyleProperty("opacity", a.toString());
    }
    bv(a) {
        if (!this.p) {
            return;
        }
        this.f.i = (a * 0.20000000298023224);
    }
    bt(a, b, c, d) {
        if (this.f != null) {
            let e = this.s;
            let f = this.r;
            if (this.d == 1) {
                b = truncate((b + (d / 2) - (f / 2)));
            }
            else if (this.d == 2) {
                b = truncate((b + (d) - (f)));
            }
            if (this.c == 1) {
                a = truncate((a + (c / 2) - (e / 2)));
            }
            else if (this.c == 2) {
                a = truncate((a + (c) - (e)));
            }
            this.f.g.setRawXPosition(a);
            this.f.g.setRawYPosition(b);
        }
    }
    a8(a, b, c) {
    }
    bu(a) {
        if (!this.p) {
            return;
        }
        let b = DeviceUtils.f(12);
        if (a.x != null && !isNaN_(a.x.d)) {
            b = a.x.d;
        }
        if (this.r != b) {
            this.r = b;
            this.f.d = (b);
        }
        let c = a.e2 * 0.2;
        let d = a.dt * 0.6;
        if (this.s >= c && this.s <= d && !this.k) {
            return;
        }
        this.k = false;
        let e = (GridCellBase.av.nextDouble() * (d - c) + c);
        if (this.s != e) {
            this.s = e;
            this.f.e = e;
        }
        this.bt(this.am + this.af + this.ah, this.ao, this.aq - (this.am + this.an), this.ai - (this.ao + this.al));
    }
    br(a, b) {
        if (!this.p) {
            return;
        }
        this.c = a;
        this.d = b;
        this.k = true;
    }
    bs(a) {
        if (!this.p) {
            return;
        }
        if (a != null) {
            this.f.l = a.color;
        }
    }
    bf(a) {
        this.a = a;
    }
    bj(a, b) {
        switch (b) {
            case 0:
                this.x.setRawStyleProperty("text-align", "left");
                break;
            case 1:
                this.x.setRawStyleProperty("text-align", "center");
                break;
            case 2:
                this.x.setRawStyleProperty("text-align", "right");
                break;
            case 3:
                this.x.setRawStyleProperty("text-align", "center");
                break;
        }
    }
    bm(a, b) {
        switch (b) {
            case 0:
                a.setRawStyleProperty("vertical-align", "top");
                break;
            case 1:
                a.setRawStyleProperty("vertical-align", "center");
                break;
            case 2:
                a.setRawStyleProperty("vertical-align", "bottom");
                break;
            case 3:
                a.setRawStyleProperty("vertical-align", "center");
                break;
        }
    }
    q(a) {
        return a.isClickActionDesired;
    }
    a3(a) {
        this.onContactStarted(a, false);
    }
    a6(a) {
        this.onContactCompleted(a, false);
    }
    a5(a) {
        this.onContactMoved(a, false);
    }
    a4(a) {
        this.a7(a, false);
    }
    ba(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.bo(e_);
        }
        else {
            this.a3(e_);
        }
    }
    bc(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.bp(e_);
        }
        else {
            this.a5(e_);
        }
    }
    bd(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.bq(e_);
        }
        else {
            this.a6(e_);
        }
    }
    bb(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a != "touch") {
            this.a4(e_);
        }
    }
    bo(a) {
        this.onContactStarted(a, true);
    }
    bp(a) {
        this.onContactMoved(a, true);
    }
    bq(a) {
        this.onContactCompleted(a, true);
    }
    onContactStarted(e_, a) {
        let b = false;
        if (this.m) {
            let indicator_ = this.e.q();
            b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
        }
        this.h = false;
        if (b) {
            this.h = true;
        }
        else {
            if (this.a != null && this.q(this.a)) {
                this.aw = e_.pageX;
                this.ax = e_.pageY;
                this.a.mouseDownCell(this.aw, this.ax);
            }
        }
    }
    onContactMoved(a, b) {
        if (this.a != null) {
            let c = a.pageX;
            let d = a.pageY;
            if (this.q(this.a)) {
                if (this.a.isMouseDown) {
                    if (b) {
                        if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ap || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ap) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            a.stopPropagation();
                        }
                    }
                    else {
                        if (PointUtil.equals(this.a.mousePosition, null)) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            if (Math.abs(c - this.a.mousePosition.x) > GridCellBase.ad || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ad) {
                                this.a.isControlPressed = a.ctrlKey;
                                this.a.dragStarted();
                            }
                        }
                    }
                }
            }
            if (this.a.isHoverActionDesired) {
                this.a.mouseIsOver(c, d);
            }
        }
    }
    onContactCompleted(e_, a) {
        let b = false;
        if (this.m) {
            let indicator_ = this.e.q();
            b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
        }
        if (this.h && b) {
            this.b.clickExpansionIndicator();
        }
        else {
            if (this.a != null && this.q(this.a)) {
                let c = e_.pageX;
                let d = e_.pageY;
                if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ap || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ap || this.a.isDrag) {
                    this.a.mouseUpCell(c, d);
                }
                if (this.a.isCellDown()) {
                    this.a.isControlPressed = e_.ctrlKey;
                    this.a.isShiftPressed = e_.shiftKey;
                    this.a.clickCell();
                    this.a.mouseUpCell(e_.pageX, e_.pageY);
                }
            }
        }
        this.h = false;
    }
    a7(a, b) {
        if (this.a != null && this.a.isLeaveActionDesired) {
            let c = a.pageX;
            let d = a.pageY;
            this.a.mouseLeaveCell(c, d);
        }
    }
    a9(a, b, c) {
        switch (a) {
            case "Indent":
                this.af = this.au * 24;
                this.ag = this.au > 0 ? 10 : 0;
                if (this.w != null) {
                    this.w.setRawXPosition(this.am + this.af);
                    this.w.setRawYPosition(intDivide(this.ai, 2) - intDivide(this.ae, 2));
                }
                break;
            case "IsCollapsable":
                if (this.m) {
                    this.a2();
                }
                else {
                    this.be();
                }
                break;
            case "IsExpanded":
                if (this.e != null) {
                    this.e.g = this.n;
                }
                break;
        }
    }
}
GridCellBase.$t = markType(GridCellBase, 'GridCellBase', Base.$, [INativeCell_$type]);
GridCellBase.av = new Random(0);
GridCellBase.ap = 10;
GridCellBase.ad = 3;
//# sourceMappingURL=GridCellBase.js.map