/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Point_$type, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, EnumUtil, runOn, delegateCombine } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { Brush } from "igniteui-angular-core";
import { TransformGroup } from "igniteui-angular-core";
import { TranslateTransform } from "igniteui-angular-core";
import { RotateTransform } from "igniteui-angular-core";
import { DoubleAnimator } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { ColumnSortDirection_$type } from "./ColumnSortDirection";
import { EasingFunctions } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { Geometry } from "igniteui-angular-core";
import { SortIndicatorRenderCompletedEventArgs } from "./SortIndicatorRenderCompletedEventArgs";
/**
 * @hidden
 */
export class GridSortIndicatorView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.d = new List$1(Path.$, 0);
        this.i = 0;
        this.h = 0;
        this.b = 0;
        this.m = null;
        this.c = null;
        this.l = null;
        this.f = 0;
        this.e = 0;
        this.g = 1;
        this.k = 0;
        this.j = 0;
        this.a = a;
    }
    s() {
        if (this.m == null || this.c == null) {
            return;
        }
        if (this.i != this.k || this.h != this.j || this.b != this.a.f) {
            this.d.clear();
            switch (this.a.f) {
                case 0:
                    this.n();
                    break;
                case 1:
                    this.o();
                    break;
                case 2:
                    this.p();
                    break;
            }
            this.i = this.k;
            this.h = this.j;
            this.b = this.a.f;
        }
        switch (this.a.f) {
            case 0:
                this.u();
                break;
            case 1:
                this.v();
                break;
            case 2:
                this.w();
                break;
        }
        let a = Math.round(this.k * this.g);
        let b = Math.round(this.j * this.g);
        if (this.f != a || this.e != b) {
            this.m.setAttribute("width", a.toString());
            this.m.setAttribute("height", b.toString());
            this.m.setStyleProperty("width", this.k.toString() + "px");
            this.m.setStyleProperty("height", this.j.toString() + "px");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.f = truncate(Math.round(a));
            this.e = truncate(Math.round(b));
        }
        if (this.c.d && this.g != 1) {
            this.c.z();
            this.c.aa(this.g, this.g);
        }
        this.c.k(0, 0, this.k, this.j);
        this.c.z();
        this.c.aa(this.a.u(), this.a.u());
        for (let c = 0; c < this.d.count; c++) {
            this.c.j(this.d._inner[c].j);
            let d = this.x();
            if (this.a.ax != null) {
                d = this.a.ax;
            }
            this.d._inner[c]._stroke = d;
            this.c.s(this.d._inner[c]);
        }
        this.c.y();
        if (this.c.d && this.g != 1) {
            this.c.y();
        }
        this.a.aq();
    }
    t() {
        this.s();
    }
    n() {
        this.a.al(this.k, this.j, this.d);
    }
    u() {
        if (this.d.count != 1) {
            return;
        }
        this.d._inner[0]._opacity = this.a.q;
        let a = { $type: Point_$type, x: this.k / 2, y: this.j / 2 };
        let b = new TransformGroup();
        b.j.add(((() => {
            let $ret = new TranslateTransform();
            $ret.j = -a.x;
            $ret.k = -a.y;
            return $ret;
        })()));
        b.j.add(((() => {
            let $ret = new RotateTransform();
            $ret.j = this.a.p;
            return $ret;
        })()));
        b.j.add(((() => {
            let $ret = new TranslateTransform();
            $ret.j = a.x;
            $ret.k = a.y;
            return $ret;
        })()));
        this.d._inner[0].j = b;
    }
    o() {
        this.a.am(this.k, this.j, this.d);
    }
    v() {
        if (this.d.count != 4) {
            return;
        }
        this.d._inner[0]._opacity = this.a.q;
        this.d._inner[1]._opacity = this.a.q;
        this.d._inner[2]._opacity = this.a.w;
        this.d._inner[3]._opacity = this.a.w;
    }
    p() {
        this.a.an(this.k, this.j, this.d);
    }
    w() {
        this.d._inner[0]._opacity = this.a.q;
        this.d._inner[1]._opacity = this.a.w;
    }
    q(a) {
        if (a == null) {
            this.m = null;
            this.l = null;
            this.c = null;
            return;
        }
        this.g = (isNaN_(this.a.v) ? this.a.o : this.a.v);
        let b = a;
        this.l = b;
        this.a.j.u(this.l);
        this.a.i.u(this.l);
        this.l.rootWrapper.addClass("ui-radialgauge-container");
        let c = this.g;
        let d = Math.round(b.rootWrapper.width());
        let e = Math.round(b.rootWrapper.height());
        let f = d * c;
        let g = e * c;
        this.l.rootWrapper.setStyleProperty("position", "relative");
        let h = this.l.createElement("canvas");
        h.setStyleProperty("position", "absolute");
        this.l.append(h);
        this.f = truncate(Math.round(f));
        this.e = truncate(Math.round(g));
        h.setAttribute("width", f.toString());
        h.setAttribute("height", g.toString());
        h.setStyleProperty("width", d.toString() + "px");
        h.setStyleProperty("height", e.toString() + "px");
        this.k = d;
        this.j = e;
        this.m = h;
        let i = this.l.get2DCanvasContext(this.m);
        this.c = new RenderingContext(new CanvasViewRenderer(), i);
        if (isNaN_(this.a.v)) {
            this.a.o = window.devicePixelRatio;
            this.g = this.a.o;
        }
        this.s();
    }
    r(a, b) {
        if (isNaN_(this.a.v)) {
            this.a.o = window.devicePixelRatio;
            this.g = this.a.o;
        }
        this.k = a;
        this.j = b;
        this.s();
    }
    x() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(138, 0, 0, 0);
            return $ret;
        })());
    }
}
GridSortIndicatorView.$t = markType(GridSortIndicatorView, 'GridSortIndicatorView');
/**
 * @hidden
 */
export class GridSortIndicator extends Base {
    constructor() {
        super();
        this.aa = null;
        this.a = 0;
        this.aw = null;
        this.k = true;
        this.propertyChanged = null;
        this.g = null;
        this.h = null;
        this.n = NaN;
        this.m = 1;
        this.e = 0;
        this.q = 0;
        this.p = 0;
        this.w = 0;
        this.s = 0;
        this.r = 0;
        this.y = 0;
        this.x = 0;
        this.t = 0;
        this.z = 0;
        this.c = null;
        this.renderCompleted = null;
        this.q = 0;
        this.w = 0.5;
        this.p = 180;
        this.c = new GridSortIndicatorView(this);
        this.g = new DoubleAnimator(0, 1, 400);
        this.h = new DoubleAnimator(0, 1, 400);
        this.g.b = EasingFunctions.cubicEase;
        this.h.b = EasingFunctions.cubicEase;
        let a = this.g;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.aj));
        let b = this.h;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.ak));
    }
    get ab() {
        return this.aa;
    }
    set ab(a) {
        this.aa = a;
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.ap("SortDirection", enumGetBox(ColumnSortDirection_$type, b), enumGetBox(ColumnSortDirection_$type, this.a));
        }
    }
    get ax() {
        return this.aw;
    }
    set ax(a) {
        let b = this.aw;
        this.aw = a;
        if (b != this.aw) {
            this.ap("IconColor", b, this.aw);
        }
    }
    get l() {
        return this.k;
    }
    set l(a) {
        let b = this.k;
        this.k = a;
        if (b != this.k) {
            this.ap("IsAnimationEnabled", b, this.k);
        }
    }
    get i() {
        return this.g;
    }
    get j() {
        return this.h;
    }
    get v() {
        return this.n;
    }
    set v(a) {
        let b = this.n;
        this.n = a;
        this.ap("PixelScalingRatio", b, this.n);
    }
    get o() {
        return this.m;
    }
    set o(a) {
        let b = this.m;
        this.m = a;
        this.ap("ActualPixelScalingRatio", b, this.m);
    }
    get f() {
        return this.e;
    }
    set f(a) {
        let b = this.e;
        this.e = a;
        if (b != this.e) {
            this.ap("SortIndicatorStyle", enumGetBox(SortIndicatorStyle_$type, b), enumGetBox(SortIndicatorStyle_$type, this.e));
        }
    }
    ap(a, b, c) {
        this.at(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    at(a, b, c) {
        switch (a) {
            case "PixelScalingRatio":
                this.o = this.v;
                break;
            case "ActualPixelScalingRatio":
                this.c.t();
                break;
            case "IconColor":
                this.c.t();
                break;
            case "SortIndicatorStyle":
                switch (this.f) {
                    case 0:
                        this.ar(this.b, false);
                        break;
                    case 1:
                    case 2:
                        this.as(this.b, false);
                        break;
                }
                break;
            case "SortDirection":
                switch (this.f) {
                    case 0:
                        this.ar(EnumUtil.getEnumValue(ColumnSortDirection_$type, c), this.l);
                        break;
                    case 1:
                    case 2:
                        this.as(EnumUtil.getEnumValue(ColumnSortDirection_$type, c), this.l);
                        break;
                }
                break;
        }
    }
    ak(a, b) {
        switch (this.f) {
            case 0:
                this.q = this.s + this.h.o * (this.y - this.s);
                break;
            case 1:
            case 2:
                this.q = this.s + this.h.o * (this.y - this.s);
                this.w = this.t + this.h.o * (this.z - this.t);
                break;
        }
        this.c.t();
    }
    aj(a, b) {
        this.p = this.r + this.g.o * (this.x - this.r);
        this.c.t();
    }
    ar(a, b) {
        this.s = this.q;
        this.r = this.p;
        if (this.l || this.g.f() || this.h.f()) {
            this.g.w();
            this.h.w();
        }
        if (a == 0) {
            this.y = 0;
            this.x = 180;
        }
        else {
            this.y = 1;
            if (a == 1) {
                this.x = 180;
            }
            else {
                this.x = 0;
            }
        }
        if (b) {
            this.g.v();
            this.h.v();
        }
        else {
            this.p = this.x;
            this.q = this.y;
            this.c.t();
        }
    }
    as(a, b) {
        this.s = this.q;
        this.t = this.w;
        if (this.l || this.h.f()) {
            this.h.w();
        }
        switch (a) {
            case 0:
                this.y = 0.4;
                this.z = 0.4;
                break;
            case 1:
                this.y = 1;
                this.z = 0.2;
                break;
            case 2:
                this.y = 0.2;
                this.z = 1;
                break;
        }
        if (b) {
            this.h.v();
        }
        else {
            this.q = this.y;
            this.w = this.z;
            this.c.t();
        }
    }
    u() {
        switch (this.f) {
            case 0: return 1;
            case 1: return 0.71;
            case 2: return 1;
        }
        return 1;
    }
    au(a) {
        this.c.q(a);
    }
    av(a) {
        this.j.u(a);
        this.i.u(a);
    }
    ac() {
        return this.c.m.getNativeElement();
    }
    ao(a, b) {
        this.c.r(a, b);
    }
    al(a, b, c) {
        let d = Math.min(a, b);
        let e = { $type: Point_$type, x: a / 2, y: b / 2 };
        let f = d * 0.8;
        let g = f / 2;
        let h = g / 2;
        let i = new PathFigure();
        i._startPoint = { $type: Point_$type, x: e.x, y: e.y - g };
        let j = new LineSegment(1);
        j.c = { $type: Point_$type, x: e.x, y: e.y + g };
        i._segments.add(j);
        let k = new PathFigure();
        k._startPoint = { $type: Point_$type, x: e.x - g, y: (e.y + g) - g };
        let l = new LineSegment(1);
        l.c = { $type: Point_$type, x: e.x, y: e.y + g };
        let m = new LineSegment(1);
        m.c = { $type: Point_$type, x: e.x + g, y: (e.y + g) - g };
        k._segments.add(l);
        k._segments.add(m);
        let n = new PathGeometry();
        n.c.add(i);
        n.c.add(k);
        let o = new Path();
        o.ak = n;
        o._stroke = this.c.x();
        o.ac = 1;
        c.add(o);
    }
    am(a, b, c) {
        let d = Geometry.a("M3.792172, 7.800278 L7.983785, 3.635676 L12.148387, 7.800278L12.148387, 7.800278");
        let e = Geometry.a("M7.97027972,4.10930186 L7.97027972,13.8116223 L7.97027972,4.10930186 Z");
        let f = Geometry.a("M11.851613, 16.199722 L16.043224, 20.364325  L20.207829, 16.199722");
        let g = Geometry.a("M16.043224,10.1883777 L16.043224,19.8906981 L16.043224,10.1883777 Z");
        c.add(((() => {
            let $ret = new Path();
            $ret.ak = d;
            $ret.aj = 2;
            $ret.stroke = this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((() => {
            let $ret = new Path();
            $ret.ak = e;
            $ret.aj = 2;
            $ret.stroke = this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((() => {
            let $ret = new Path();
            $ret.ak = f;
            $ret.aj = 2;
            $ret.stroke = this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((() => {
            let $ret = new Path();
            $ret.ak = g;
            $ret.aj = 2;
            $ret.stroke = this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
    }
    an(a, b, c) {
        let d = { $type: Point_$type, x: a / 2, y: b / 2 };
        let e = { $type: Point_$type, x: d.x - 3.5, y: d.y - 1.5 };
        let f = { $type: Point_$type, x: d.x - 3.5, y: d.y + 1.5 };
        let g = Geometry.a("M" + e.x.toString() + ", " + e.y.toString() + " l 3.5,-3.5 3.5,3.5");
        let h = Geometry.a("M" + f.x.toString() + ", " + f.y.toString() + " l 3.5,3.5 3.5,-3.5");
        c.add(((() => {
            let $ret = new Path();
            $ret.ak = g;
            $ret.aj = 2;
            $ret.stroke = this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((() => {
            let $ret = new Path();
            $ret.ak = h;
            $ret.aj = 2;
            $ret.stroke = this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
    }
    aq() {
        if (this.renderCompleted != null) {
            this.renderCompleted(this, new SortIndicatorRenderCompletedEventArgs());
        }
    }
}
GridSortIndicator.$t = markType(GridSortIndicator, 'GridSortIndicator', Base.$, [INotifyPropertyChanged_$type]);
//# sourceMappingURL=GridSortIndicatorView_combined.js.map