/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
export class GridStyleRepository extends Base {
    static get al() {
        if (GridStyleRepository.t == null) {
            GridStyleRepository.t = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(255, 230, 230, 230);
                return $ret;
            })());
        }
        return GridStyleRepository.t;
    }
    static get ah() {
        if (GridStyleRepository.p == null) {
            let a = "#CCCCCC";
            GridStyleRepository.p = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.p;
    }
    static get z() {
        if (GridStyleRepository.h == null) {
            let a = "#999999";
            GridStyleRepository.h = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.h;
    }
    static get an() {
        if (GridStyleRepository.v == null) {
            GridStyleRepository.v = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(222, 0, 0, 0);
                return $ret;
            })());
        }
        return GridStyleRepository.v;
    }
    static get w() {
        if (GridStyleRepository.e == null) {
            GridStyleRepository.e = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(222, 0, 0, 0);
                return $ret;
            })());
        }
        return GridStyleRepository.e;
    }
    static get d() {
        if (GridStyleRepository.b == null) {
            GridStyleRepository.b = new FontInfo();
            GridStyleRepository.b.d = DeviceUtils.f(13);
            GridStyleRepository.b.n = "Verdana";
        }
        return GridStyleRepository.b;
    }
    static get c() {
        if (GridStyleRepository.a == null) {
            GridStyleRepository.a = new FontInfo();
            GridStyleRepository.a.d = DeviceUtils.f(12);
            GridStyleRepository.a.n = "Verdana";
        }
        return GridStyleRepository.a;
    }
    static get af() {
        if (GridStyleRepository.n == null) {
            GridStyleRepository.n = new Brush();
            GridStyleRepository.n.color = Color.u(255, 238, 238, 238);
        }
        return GridStyleRepository.n;
    }
    static get x() {
        if (GridStyleRepository.f == null) {
            GridStyleRepository.f = ((() => {
                let $ret = new Brush();
                $ret.fill = "White";
                return $ret;
            })());
        }
        return GridStyleRepository.f;
    }
    static get aj() {
        if (GridStyleRepository.r == null) {
            GridStyleRepository.r = ((() => {
                let $ret = new Brush();
                $ret.fill = "White";
                return $ret;
            })());
        }
        return GridStyleRepository.r;
    }
    static get am() {
        if (GridStyleRepository.u == null) {
            GridStyleRepository.u = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(138, 0, 0, 0);
                return $ret;
            })());
        }
        return GridStyleRepository.u;
    }
    static get ak() {
        if (GridStyleRepository.s == null) {
            GridStyleRepository.s = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(138, 0, 0, 0);
                return $ret;
            })());
        }
        return GridStyleRepository.s;
    }
    static get ad() {
        if (GridStyleRepository.l == null) {
            let a = "#DDDDDD";
            GridStyleRepository.l = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.l;
    }
    static get ac() {
        if (GridStyleRepository.k == null) {
            GridStyleRepository.k = ((() => {
                let $ret = new Brush();
                $ret.fill = "#f5f5dc";
                return $ret;
            })());
        }
        return GridStyleRepository.k;
    }
    static get ag() {
        if (GridStyleRepository.o == null) {
            let a = "#F5F5F5";
            GridStyleRepository.o = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.o;
    }
    static get aa() {
        if (GridStyleRepository.i == null) {
            let a = "White";
            GridStyleRepository.i = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.i;
    }
    static get ab() {
        if (GridStyleRepository.j == null) {
            let a = "#E0E0E0";
            GridStyleRepository.j = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.j;
    }
    static get ae() {
        if (GridStyleRepository.m == null) {
            let a = "#F4F4F4";
            GridStyleRepository.m = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.m;
    }
    static get ai() {
        if (GridStyleRepository.q == null) {
            let a = "#0099FF";
            GridStyleRepository.q = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.q;
    }
    static get y() {
        if (GridStyleRepository.g == null) {
            let a = "#F50000";
            GridStyleRepository.g = ((() => {
                let $ret = new Brush();
                $ret.fill = a;
                return $ret;
            })());
        }
        return GridStyleRepository.g;
    }
}
GridStyleRepository.$t = markType(GridStyleRepository, 'GridStyleRepository');
GridStyleRepository.t = null;
GridStyleRepository.p = null;
GridStyleRepository.h = null;
GridStyleRepository.v = null;
GridStyleRepository.e = null;
GridStyleRepository.b = null;
GridStyleRepository.a = null;
GridStyleRepository.n = null;
GridStyleRepository.f = null;
GridStyleRepository.r = null;
GridStyleRepository.u = null;
GridStyleRepository.s = null;
GridStyleRepository.l = null;
GridStyleRepository.k = null;
GridStyleRepository.o = null;
GridStyleRepository.i = null;
GridStyleRepository.j = null;
GridStyleRepository.m = null;
GridStyleRepository.q = null;
GridStyleRepository.g = null;
//# sourceMappingURL=GridStyleRepository.js.map