/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CellModelExport } from "./CellModelExport";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class NumericCellModelExport extends CellModelExport {
    constructor() {
        super(...arguments);
        this.ac = 0;
        this.ad = 0;
        this.ae = 0;
    }
    get_aa() {
        return "NumericCell";
    }
    ab(a) {
        super.ab(a);
        a.l("numericValue : " + this.ac + ", ");
        a.l("maxDecimalPlaces : " + this.ad + ", ");
        a.l("minDecimalPlaces : " + this.ae + ", ");
    }
}
NumericCellModelExport.$t = markType(NumericCellModelExport, 'NumericCellModelExport', CellModelExport.$);
//# sourceMappingURL=NumericCellModelExport.js.map