/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class SectionHeaderCell extends GridCellBase {
    constructor(a) {
        super(a);
        this.bx = null;
        this.bx = a.createElement("span");
        this.x.setRawStyleProperty("text-align", "left");
        this.x.setRawStyleProperty("vertical-align", "middle");
        this.x.setRawStyleProperty("overflow", "hidden");
        this.x.setRawStyleProperty("white-space", "nowrap");
        this.x.setRawStyleProperty("text-overflow", "ellipsis");
        this.x.append(this.bx);
    }
    get by() {
        return this.bx;
    }
    get_p() {
        return true;
    }
    a9(a, b, c) {
        super.a9(a, b, c);
        if (a == "Indent") {
            this.bx.setRawStyleProperty("margin-left", this.ar + this.at + 10 + "px");
        }
        if (a == "IsCollapsable") {
            if (this.m) {
                this.bx.setRawStyleProperty("margin-left", this.ar + this.at + 10 + "px");
            }
            else {
                this.bx.setRawStyleProperty("margin-left", "0px");
            }
        }
    }
}
SectionHeaderCell.$t = markType(SectionHeaderCell, 'SectionHeaderCell', GridCellBase.$);
//# sourceMappingURL=SectionHeaderCell.js.map