/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CellModelExport } from "./CellModelExport";
import { enumGetBox, markType } from "igniteui-angular-core";
import { SummaryOperand_$type } from "igniteui-angular-core";
/**
 * @hidden
 */
export class SectionHeaderCellModelExport extends CellModelExport {
    constructor() {
        super(...arguments);
        this.ad = null;
        this.ae = null;
        this.ac = null;
        this.aj = null;
        this.ag = null;
        this.ai = null;
        this.ah = null;
        this.af = null;
        this.ak = null;
    }
    get_aa() {
        return "SectionHeaderCell";
    }
    ab(a) {
        super.ab(a);
        let b = "groupNames : [ ";
        let c = "groupValues : [ ";
        for (let d = 0; d < this.ad.length; d++) {
            b += "\"" + this.ad[d] + "\", ";
            c += "\"" + this.ae[d] + "\", ";
        }
        let e = "summaryNames : [ ";
        let f = "summaryValues : [ ";
        let g = "summaryOperands : [ ";
        let h = "summaryFormattedText : [ ";
        if (this.ag != null) {
            for (let i = 0; i < this.ag.length; i++) {
                e += "\"" + this.ag[i] + "\", ";
                f += "\"" + this.ai[i] + "\", ";
                g += "\"" + enumGetBox(SummaryOperand_$type, this.ah[i]) + "\", ";
                h += "\"" + this.af[i] + "\", ";
            }
        }
        a.l(b + " ], ");
        a.l(c + " ], ");
        a.l("formattedText : \"" + this.aj + "\", ");
        a.l(e + " ], ");
        a.l(f + " ], ");
        a.l(g + " ], ");
        a.l(h + " ], ");
        a.l("fullSummaryFormattedText : \"" + this.ak + "\", ");
    }
}
SectionHeaderCellModelExport.$t = markType(SectionHeaderCellModelExport, 'SectionHeaderCellModelExport', CellModelExport.$);
//# sourceMappingURL=SectionHeaderCellModelExport.js.map