/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Header } from "./Header";
import { TemplateHeaderCellModel } from "./TemplateHeaderCellModel";
import { markType } from "igniteui-angular-core";
import { TemplateHeaderCellUpdatingEventArgs } from "./TemplateHeaderCellUpdatingEventArgs";
/**
 * @hidden
 */
export class TemplateHeader extends Header {
    constructor() {
        super();
        this.cellUpdating = null;
    }
    l(a) {
        return new TemplateHeaderCellModel();
    }
    b8(a, b, c) {
        let d = "template-header-" + a.al.toString();
        return d;
    }
    ck(a, b, c, d) {
        super.ck(a, b, c, d);
        let e = a;
        let f = b.as(a.i);
        e.ij = f.fp;
        e.k = f.eb;
        e.im = f.ez && b.fs;
    }
    et(a, b) {
        if (this.cellUpdating != null) {
            this.cellUpdating(this, ((() => {
                let $ret = new TemplateHeaderCellUpdatingEventArgs();
                $ret.cellInfo = a;
                $ret.content = b;
                return $ret;
            })()));
        }
    }
}
TemplateHeader.$t = markType(TemplateHeader, 'TemplateHeader', Header.$);
//# sourceMappingURL=TemplateHeader.js.map