/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TemplateCellModel } from "./TemplateCellModel";
import { CellModel } from "./CellModel";
import { markType } from "igniteui-angular-core";
import { TemplateHeaderCellModelExport } from "./TemplateHeaderCellModelExport";
/**
 * @hidden
 */
export class TemplateHeaderCellModel extends TemplateCellModel {
    constructor() {
        super(...arguments);
        this.il = false;
    }
    get im() {
        return this.il;
    }
    set im(a) {
        let b = this.il;
        this.il = a;
        if (this.il != b) {
            this.hl("IsFilterUIVisible", TemplateHeaderCellModel.io, b, this.il);
        }
    }
    hs(a, b) {
        super.hs(a, b);
        if (a == "IsFilterUIVisible") {
            this.im = b;
        }
    }
    fa(a) {
        if (a == "IsFilterUIVisible") {
            return this.im;
        }
        return super.fa(a);
    }
    b(a) {
        if (a == null) {
            a = new TemplateHeaderCellModelExport();
        }
        a = super.b(a);
        let b = a;
        b.ac = this.ij;
        return b;
    }
}
TemplateHeaderCellModel.$t = markType(TemplateHeaderCellModel, 'TemplateHeaderCellModel', TemplateCellModel.$);
TemplateHeaderCellModel.io = CellModel.ds("IsFilterUIVisible");
//# sourceMappingURL=TemplateHeaderCellModel.js.map