/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { GridSortIndicator } from "./GridSortIndicator";
import { runOn, delegateCombine, markType } from "igniteui-angular-core";
import { GridFilterDialog } from "./GridFilterDialog";
/**
 * @hidden
 */
export class TextHeaderCell extends GridCellBase {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.by = null;
        this.bx = null;
        this.b3 = null;
        this.b6 = -1;
        this.b5 = -1;
        this.b2 = null;
        this.b0 = false;
        this.b1 = a.createElement("span");
        this.x.setRawStyleProperty("text-align", "left");
        this.x.setRawStyleProperty("vertical-align", "middle");
        this.b1.setRawStyleProperty("display", "inline-block");
        this.b1.setRawStyleProperty("line-height", "normal");
        this.b1.setRawStyleProperty("vertical-align", "middle");
        this.b1.setRawStyleProperty("overflow", "hidden");
        this.b1.setRawStyleProperty("white-space", "nowrap");
        this.b1.setRawStyleProperty("text-overflow", "ellipsis");
        this.x.append(this.b1);
        let b = a.createElement("div");
        b.setRawStyleProperty("display", "none");
        b.setRawStyleProperty("width", "15px");
        b.setRawStyleProperty("height", "15px");
        this.b2 = b;
        let c = a.getSubRenderer(b);
        this.bx = new GridFilterDialog();
        this.bx.ao(c);
        this.x.append(b);
        this.bx.ai(15, 15);
        b = a.createElement("div");
        b.setRawStyleProperty("display", "inline-block");
        b.setRawStyleProperty("vertical-align", "middle");
        b.setRawStyleProperty("width", "16px");
        b.setRawStyleProperty("height", "16px");
        b.setRawStyleProperty("margin", "0 0 0 5px");
        this.b3 = b;
        c = a.getSubRenderer(b);
        this.by = new GridSortIndicator();
        this.by.au(c);
        this.x.append(b);
        this.by.ao(16, 16);
        let d = this.bx;
        d.dialogOpening = delegateCombine(d.dialogOpening, runOn(this, this.b7));
        let e = this.bx;
        e.filterChanging = delegateCombine(e.filterChanging, runOn(this, this.b9));
        let f = this.bx;
        f.filterChanged = delegateCombine(f.filterChanged, runOn(this, this.b8));
    }
    get b4() {
        return this.b1;
    }
    get bz() {
        return this.by;
    }
    q(a) {
        return true;
    }
    bn(a, b) {
        super.bn(a, b);
        a -= 21;
        if (this.b0) {
            a -= 15;
        }
        let c = Math.max(0, a - b);
        if (c != this.b6) {
            this.b6 = c;
            this.b1.setRawStyleProperty("max-width", c.toString() + "px");
        }
    }
    bi(a, b) {
        super.bi(a, b);
        let c = Math.max(0, a - b);
        if (this.b5 != c) {
            this.b5 = c;
            this.b1.setRawStyleProperty("max-height", c.toString() + "px");
        }
    }
    b8(a, b) {
        this.b.columnFilterChanged(b.a);
    }
    b9(a, b) {
        this.b.columnFilterChanging(b.a);
    }
    b7(a, b) {
        if (this.b != null) {
            b.a = this.b.getColumnFilterCondition();
            b.b = this.b.getColumnPropertyType();
        }
    }
    a8(a, b, c) {
        super.a8(a, b, c);
        if (c == 2) {
            this.x.removeChild(this.b3);
            this.x.removeChild(this.b2);
            this.b1.before(this.b2);
            this.b2.before(this.b3);
            this.b3.setRawStyleProperty("margin", "0 5px 0 0");
        }
        else {
            this.x.removeChild(this.b3);
            this.x.removeChild(this.b1);
            this.b2.before(this.b1);
            this.b2.before(this.b3);
            this.b3.setRawStyleProperty("margin", "0 0 0 5px");
        }
    }
    get_o() {
        return true;
    }
}
TextHeaderCell.$t = markType(TextHeaderCell, 'TextHeaderCell', GridCellBase.$);
//# sourceMappingURL=TextHeaderCell.js.map