import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ColumnPropertySetter as ColumnPropertySetter_internal } from './ColumnPropertySetter';
import { IgxColumnPropertySetter as IgxColumnPropertySetter } from './igx-column-property-setter';
export class IgxColumnPropertySettersCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxColumnPropertySetter.$type) {
            IgxColumnPropertySetter.$type = markType(IgxColumnPropertySetter, "IgxColumnPropertySetter");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxColumnPropertySetter.$type) {
            IgxColumnPropertySetter.$type = markType(IgxColumnPropertySetter, "IgxColumnPropertySetter");
        }
        let coll = new SyncableObservableCollection$2(IgxColumnPropertySetter.$type, ColumnPropertySetter_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxColumnPropertySetter();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-column-property-setters-collection.js.map