var IgxColumnResizingSeparatorComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ColumnResizingSeparator } from "./ColumnResizingSeparator";
export const IgxColumnResizingSeparatorComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxColumnResizingSeparatorComponent) }];
let IgxColumnResizingSeparatorComponent = IgxColumnResizingSeparatorComponent_1 = class IgxColumnResizingSeparatorComponent extends IgxDefinitionBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ColumnResizingSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the separator width for this column.
    */
    get separatorWidth() {
        return this.i.d1;
    }
    set separatorWidth(v) {
        this.i.d1 = +v;
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxColumnResizingSeparatorComponent.prototype, "separatorWidth", null);
IgxColumnResizingSeparatorComponent = IgxColumnResizingSeparatorComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-column-resizing-separator',
        template: ``,
        providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxColumnResizingSeparatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxColumnResizingSeparatorComponent);
export { IgxColumnResizingSeparatorComponent };
//# sourceMappingURL=igx-column-resizing-separator-component.js.map