import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { Column as Column_internal } from './Column';
import { IgxColumnComponent as IgxColumnComponent } from './igx-column-component';
export class IgxGridColumnCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxColumnComponent.$type) {
            IgxColumnComponent.$type = markType(IgxColumnComponent, "IgxColumnComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxColumnComponent.$type) {
            IgxColumnComponent.$type = markType(IgxColumnComponent, "IgxColumnComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxColumnComponent.$type, Column_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgxColumnComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-grid-column-collection.js.map