import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { PrimaryKeyValue as PrimaryKeyValue_internal } from './PrimaryKeyValue';
import { IgxPrimaryKeyValue as IgxPrimaryKeyValue } from './igx-primary-key-value';
export class IgxGridSelectedKeysCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxPrimaryKeyValue.$type) {
            IgxPrimaryKeyValue.$type = markType(IgxPrimaryKeyValue, "IgxPrimaryKeyValue");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxPrimaryKeyValue.$type) {
            IgxPrimaryKeyValue.$type = markType(IgxPrimaryKeyValue, "IgxPrimaryKeyValue");
        }
        let coll = new SyncableObservableCollection$2(IgxPrimaryKeyValue.$type, PrimaryKeyValue_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxPrimaryKeyValue();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-grid-selected-keys-collection.js.map