import { ResponsiveStateEnteringEventArgs as ResponsiveStateEnteringEventArgs_internal } from "./ResponsiveStateEnteringEventArgs";
/**
 * Information about the entering action.
*/
export class IgxResponsiveStateEnteringEventArgs {
    createImplementation() {
        return new ResponsiveStateEnteringEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}
//# sourceMappingURL=igx-responsive-state-entering-event-args.js.map