var IgxRowSeparatorComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { RowSeparator } from "./RowSeparator";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
export const IgxRowSeparatorComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxRowSeparatorComponent) }];
let IgxRowSeparatorComponent = IgxRowSeparatorComponent_1 = class IgxRowSeparatorComponent extends IgxDefinitionBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RowSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxRowSeparatorComponent = IgxRowSeparatorComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-row-separator',
        template: ``,
        providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxRowSeparatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxRowSeparatorComponent);
export { IgxRowSeparatorComponent };
//# sourceMappingURL=igx-row-separator-component.js.map