import { IgxCellInfo } from "./igx-cell-info";
import { RowSeparatorModel as RowSeparatorModel_internal } from "./RowSeparatorModel";
/**
 * Represents backing information for the row separators.
*/
export class IgxRowSeparatorInfo extends IgxCellInfo {
    createImplementation() {
        return new RowSeparatorModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}
//# sourceMappingURL=igx-row-separator-info.js.map