var IgxSectionFooterComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { SectionFooter } from "./SectionFooter";
/**
 * Used to configure the appearance of the section footer cells.
*/
export const IgxSectionFooterComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxSectionFooterComponent) }];
let IgxSectionFooterComponent = IgxSectionFooterComponent_1 = class IgxSectionFooterComponent extends IgxDefinitionBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SectionFooter();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxSectionFooterComponent = IgxSectionFooterComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-section-footer',
        template: ``,
        providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxSectionFooterComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxSectionFooterComponent);
export { IgxSectionFooterComponent };
//# sourceMappingURL=igx-section-footer-component.js.map