import { IgxCellInfo } from "./igx-cell-info";
import { TemplateCellModel as TemplateCellModel_internal } from "./TemplateCellModel";
/**
 * Represents backing information for a template cell.
*/
export class IgxTemplateCellInfo extends IgxCellInfo {
    createImplementation() {
        return new TemplateCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the value to provide to the template.
    */
    get value() {
        return this.i.ij;
    }
    set value(v) {
        this.i.ij = v;
    }
}
//# sourceMappingURL=igx-template-cell-info.js.map