import { IgxTemplateCellInfo } from "./igx-template-cell-info";
import { TemplateHeaderCellModel as TemplateHeaderCellModel_internal } from "./TemplateHeaderCellModel";
import { ensureBool } from "igniteui-angular-core";
/**
 * Backing information for the template header cells.
*/
export class IgxTemplateHeaderCellInfo extends IgxTemplateCellInfo {
    createImplementation() {
        return new TemplateHeaderCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    get isFilterUIVisible() {
        return this.i.im;
    }
    set isFilterUIVisible(v) {
        this.i.im = ensureBool(v);
    }
}
//# sourceMappingURL=igx-template-header-cell-info.js.map