var IgxTextColumnComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TextColumn } from "./TextColumn";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export const IgxTextColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxTextColumnComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTextColumnComponent) }];
let IgxTextColumnComponent = IgxTextColumnComponent_1 = class IgxTextColumnComponent extends IgxColumnComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new TextColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxTextColumnComponent = IgxTextColumnComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-text-column',
        template: ``,
        providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(() => IgxTextColumnComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTextColumnComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTextColumnComponent);
export { IgxTextColumnComponent };
//# sourceMappingURL=igx-text-column-component.js.map