var IgxTextHeaderComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxHeaderComponent } from "./igx-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TextHeader } from "./TextHeader";
/**
 * Represents a class used to configure the appearance of a text column header cells.
*/
export const IgxTextHeaderComponent_PROVIDERS = [{ provide: IgxHeaderComponent, useExisting: forwardRef(() => IgxTextHeaderComponent) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTextHeaderComponent) }];
let IgxTextHeaderComponent = IgxTextHeaderComponent_1 = class IgxTextHeaderComponent extends IgxHeaderComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new TextHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxTextHeaderComponent = IgxTextHeaderComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-text-header',
        template: ``,
        providers: [{ provide: IgxHeaderComponent, useExisting: forwardRef(() => IgxTextHeaderComponent_1) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxTextHeaderComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTextHeaderComponent);
export { IgxTextHeaderComponent };
//# sourceMappingURL=igx-text-header-component.js.map