import { IgxCellInfo } from "./igx-cell-info";
import { VerticalSeparatorCellModel as VerticalSeparatorCellModel_internal } from "./VerticalSeparatorCellModel";
import { ensureBool } from "igniteui-angular-core";
/**
 * Represents backing information for vertical separators.
*/
export class IgxVerticalSeparatorCellInfo extends IgxCellInfo {
    createImplementation() {
        return new VerticalSeparatorCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets or sets whether the vertical separator is hit test visible.
    */
    get isHitTestVisible() {
        return this.i.ii;
    }
    set isHitTestVisible(v) {
        this.i.ii = ensureBool(v);
    }
}
//# sourceMappingURL=igx-vertical-separator-cell-info.js.map