/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType, PointUtil } from "igniteui-angular-core";
import { INativeCell_$type } from "./INativeCell";
import { RenderingContext } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { CanvasPlaceholderView } from "./CanvasPlaceholderView";
import { DeviceUtils } from "igniteui-angular-core";
import { Random } from "igniteui-angular-core";
import { FontUtil } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var CanvasGridCellBase = /** @class */ (function (_super) {
    tslib_1.__extends(CanvasGridCellBase, _super);
    function CanvasGridCellBase(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.q = true;
        _this.o = true;
        _this.k = null;
        _this.bj = null;
        _this.bw = null;
        _this.l = false;
        _this.an = 1;
        _this.ar = 5;
        _this.at = 5;
        _this.as = 5;
        _this.aq = 5;
        _this.cs = null;
        _this.af = 0;
        _this.ah = 0;
        _this.ag = 0;
        _this.ae = 0;
        _this.cz = new Rectangle();
        _this.cw = new Line();
        _this.cy = new Line();
        _this.cx = new Line();
        _this.cv = new Line();
        _this.ax = 0;
        _this.az = 0;
        _this.a0 = 0;
        _this.a1 = 0;
        _this.bl = null;
        _this.j = null;
        _this.aj = 0;
        _this.ai = 0;
        _this.al = 0;
        _this.ak = 0;
        _this.s = true;
        _this.ay = NaN;
        _this.cr = new TextBlock();
        _this.cu = Color.u(255, 0, 0, 0);
        _this.r = true;
        _this.ap = 0;
        _this.a2 = 0;
        _this.ct = Color.u(255, 255, 255, 255);
        _this.m = false;
        _this.g = null;
        _this.c = 0;
        _this.e = 0;
        _this.bv = 1;
        _this.aw = 0;
        _this.av = 0;
        _this.i = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 12;
            return $ret;
        })());
        _this.p = true;
        _this.bo = -1;
        _this.bt = 0;
        _this.bu = 0;
        _this.n = false;
        _this.bm = 0;
        _this.b = 0;
        _this.ao = NaN;
        _this.h = null;
        _this.bq = -1;
        _this.am = NaN;
        _this.f = 1;
        _this.au = 1;
        _this.bj = a;
        return _this;
    }
    Object.defineProperty(CanvasGridCellBase.prototype, "x", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            this.o = a;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.ch = function (a) {
        this.k = a;
    };
    CanvasGridCellBase.prototype.b2 = function () {
        this.o = true;
        if (this.k != null) {
            this.k();
        }
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "isCanvasBased", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bk", {
        get: function () {
            return this.bj;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.ci = function (a) {
        this.bw = a;
        this.o = true;
        this.q = true;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "templateContext", {
        get: function () {
            return this.j.g();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "t", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            this.l = a;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.get_z = function () {
        return false;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "z", {
        get: function () {
            return this.get_z();
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.b9 = function (a, b, c, d, e) {
        this.o = true;
        this.cs = a;
        this.af = b;
        this.ah = c;
        this.ag = d;
        this.ae = e;
        this.q = true;
    };
    CanvasGridCellBase.prototype.ca = function (a) {
        this.o = true;
        this.an = a;
        this.cr._opacity = this.an;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "a9", {
        get: function () {
            return this.ar;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bb", {
        get: function () {
            return this.at;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "ba", {
        get: function () {
            return this.as;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a8", {
        get: function () {
            return this.aq;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a4", {
        get: function () {
            return this.af;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a6", {
        get: function () {
            return this.ah;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a5", {
        get: function () {
            return this.ag;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a3", {
        get: function () {
            return this.ae;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bd", {
        get: function () {
            return this.ax;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bf", {
        get: function () {
            return this.az;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bg", {
        get: function () {
            return this.a1;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.get_aa = function () {
        return false;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "aa", {
        get: function () {
            return this.get_aa();
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.by = function (a, b, c, d, e, f) {
        var g = true;
        var h = true;
        var i = false;
        if (this.aa) {
            g = false;
            h = false;
            i = false;
        }
        this.bz(a, b, c, d, e, f, g, h, i);
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "resized", {
        get: function () {
            return this.s;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.ensureCorrectSize = function () {
        this.s = this.u(this.au);
        return this.s;
    };
    CanvasGridCellBase.prototype.bz = function (a, b, c, d, e, f, g, h, i) {
        if (!this.r) {
            return;
        }
        if (this.bv != 1) {
            a.ad(this.bv);
        }
        this.au = f;
        if (!i) {
            this.b0();
            this.ensureCorrectSize();
        }
        if (this.x || this.s || i) {
            this.x = false;
            var j = this.j;
            if (this.p || this.s || (this.i != null && this.i.g != this.bo)) {
                this.p = false;
                this.bo = this.i.g;
                j.ac(this.i);
            }
            if (f != 1) {
                this.j.z();
                this.j.aa(f, f);
            }
            if (g) {
                this.b3();
            }
            if (h) {
                this.b4(this.j);
            }
            if (f != 1) {
                this.j.y();
            }
        }
        if (!i) {
            var k = Math.round((d - b) * f);
            var l = Math.round((e - c) * f);
            if (this.aj == this.al && this.ai == this.ak) {
                a.m(this.bl.getNativeElement(), 1, k, l, this.aj, this.ai);
            }
            else {
                a.n(this.bl.getNativeElement(), 1, 0, 0, this.aj, this.ai, k, l, this.aj, this.ai);
            }
        }
        if (this.bv != 1) {
            a.ad(1);
        }
    };
    CanvasGridCellBase.prototype.b3 = function () {
        if (!this.m) {
            this.j.k(0, 0, this.al, this.ak);
        }
        this.cz.n = 0;
        this.cz.o = 0;
        this.cz.width = this.a2;
        this.cz.height = this.ap;
        this.j.v(this.cz);
        if (this.cs != null) {
            if (this.af > 0) {
                this.cw.am = 0;
                this.cw.ak = this.af / 2;
                this.cw.an = this.ap;
                this.cw.al = this.af / 2;
                this.cw._stroke = this.cs;
                this.cw.ac = this.af;
                this.j.r(this.cw);
            }
            if (this.ag > 0) {
                this.cx.am = 0;
                this.cx.ak = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cx.an = this.ap;
                this.cx.al = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cx._stroke = this.cs;
                this.cx.ac = this.ag;
                this.j.r(this.cx);
            }
            if (this.ah > 0) {
                this.cy.am = this.ah / 2;
                this.cy.ak = this.af;
                this.cy.an = this.ah / 2;
                this.cy.al = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cy._stroke = this.cs;
                this.cy.ac = this.ah;
                this.j.r(this.cy);
            }
            if (this.ae > 0) {
                this.cv.am = Math.max(0, this.ap - (this.ae / 2));
                this.cv.ak = this.af;
                this.cv.an = Math.max(0, this.ap - (this.ae / 2));
                this.cv.al = Math.max(0, (this.a2 - (this.ag / 2)));
                this.cv._stroke = this.cs;
                this.cv.ac = this.ae;
                this.j.r(this.cv);
            }
        }
    };
    CanvasGridCellBase.prototype.cg = function (a) {
        this.au = a;
    };
    CanvasGridCellBase.prototype.renderStandardContent = function () {
        this.bz(this.j, 0, 0, 0, 0, this.au, false, true, true);
    };
    CanvasGridCellBase.prototype.renderStandardBackground = function () {
        this.bz(this.j, 0, 0, 0, 0, this.au, true, false, true);
    };
    CanvasGridCellBase.prototype.b4 = function (a) {
        if (this.q) {
            this.cq();
            this.q = false;
        }
        if (this.cr.ak != null) {
            this.cr.n = this.ax;
            this.cr.o = this.a0;
            this.j.w(this.cr);
        }
    };
    CanvasGridCellBase.prototype.b0 = function () {
        if (this.bl == null) {
            this.bl = this.bj.createElement("canvas");
            var a_1 = this.bj.get2DCanvasContext(this.bl);
            var b = ((function () {
                var $ret = new CanvasViewRenderer();
                $ret.h$d = a_1;
                return $ret;
            })());
            this.j = new RenderingContext(b, a_1);
            this.q = true;
        }
    };
    CanvasGridCellBase.prototype.u = function (a) {
        var b = Math.round(this.a2 * a);
        var c = Math.round(this.ap * a);
        this.aj = b;
        this.ai = c;
        var d = this.bc(b);
        var e = this.bc(c);
        if (d != this.al || e != this.ak) {
            this.bl.setAttribute("width", d + "px");
            this.bl.setAttribute("height", e + "px");
            this.al = d;
            this.ak = e;
            this.aj = b;
            this.ai = c;
            return true;
        }
        return false;
    };
    CanvasGridCellBase.prototype.bc = function (a) {
        return a;
    };
    CanvasGridCellBase.prototype.cf = function (a, b, c, d) {
        this.o = true;
        this.ar = a;
        this.at = b;
        this.as = c;
        this.aq = d;
        this.q = true;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "be", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            this.ay = a;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.cj = function (a) {
        var _this = this;
        this.o = true;
        this.cu = a;
        this.cr.am = ((function () {
            var $ret = new Brush();
            $ret.color = _this.cu;
            return $ret;
        })());
    };
    CanvasGridCellBase.prototype.get_y = function () {
        return false;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "y", {
        get: function () {
            return this.get_y();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "ab", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            this.o = true;
            this.r = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "a7", {
        get: function () {
            return this.ap;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CanvasGridCellBase.prototype, "bi", {
        get: function () {
            return this.a2;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.cc = function (a) {
        this.o = true;
        this.ap = a;
        this.cz.height = this.ap;
    };
    CanvasGridCellBase.prototype.cl = function (a) {
        this.o = true;
        this.a2 = a;
        this.cz.width = this.a2;
        this.q = true;
    };
    CanvasGridCellBase.prototype.bx = function () {
        if (!this.z) {
            return;
        }
        this.l = true;
        this.g = new CanvasPlaceholderView();
        this.c = 0;
        this.e = 1;
        this.g.l = Color.u(120, 120, 120, 120);
        this.g.h = 0;
    };
    CanvasGridCellBase.prototype.b8 = function (a) {
        var _this = this;
        this.o = true;
        this.ct = a;
        this.m = this.ct.l == 255;
        this.cz._fill = ((function () {
            var $ret = new Brush();
            $ret.color = _this.ct;
            return $ret;
        })());
    };
    CanvasGridCellBase.prototype.ce = function (a) {
        this.o = true;
        this.bv = a;
    };
    CanvasGridCellBase.prototype.cp = function (a) {
        if (!this.z) {
            return;
        }
        this.o = true;
        this.g.h = (a * 0.20000000298023224);
    };
    CanvasGridCellBase.prototype.b1 = function (a, b, c, d) {
        if (this.g != null) {
            var e = this.aw;
            var f = this.av;
            if (this.e == 1) {
                b = truncate((b + (d / 2) - (f / 2)));
            }
            else if (this.e == 2) {
                b = truncate((b + (d) - (f)));
            }
            if (this.c == 1) {
                a = truncate((a + (c / 2) - (e / 2)));
            }
            else if (this.c == 2) {
                a = truncate((a + (c) - (e)));
            }
        }
    };
    CanvasGridCellBase.prototype.cb = function (a) {
        this.i = a;
        this.p = true;
        this.o = true;
        this.q = true;
    };
    CanvasGridCellBase.prototype.co = function (a) {
        if (!this.z) {
            return;
        }
        this.o = true;
        var b = DeviceUtils.f(12);
        if (a.x != null && !isNaN_(a.x.d)) {
            b = a.x.d;
        }
        if (this.av != b) {
            this.av = b;
        }
        var c = a.e2 * 0.2;
        var d = a.dt * 0.6;
        if (this.aw >= c && this.aw <= d) {
            return;
        }
        var e = (CanvasGridCellBase.bs.nextDouble() * (d - c) + c);
        if (this.aw != e) {
            this.aw = e;
        }
    };
    CanvasGridCellBase.prototype.cm = function (a, b) {
        if (!this.z) {
            return;
        }
        this.o = true;
        this.c = a;
        this.e = b;
    };
    CanvasGridCellBase.prototype.cn = function (a) {
        if (!this.z) {
            return;
        }
        this.o = true;
    };
    CanvasGridCellBase.prototype.b7 = function (a) {
        this.a = a;
    };
    Object.defineProperty(CanvasGridCellBase.prototype, "d", {
        get: function () {
            return this.b;
        },
        enumerable: true,
        configurable: true
    });
    CanvasGridCellBase.prototype.cd = function (a) {
        this.b = a;
        this.o = true;
        this.q = true;
    };
    CanvasGridCellBase.prototype.cq = function () {
        if (this.bw == null) {
            return;
        }
        if (this.j == null) {
            return;
        }
        if (this.p || (this.i != null && this.i.g != this.bo)) {
            this.p = false;
            this.bo = this.i.g;
            this.j.ac(this.i);
        }
        var a;
        if (this.h != this.i || this.bq != this.i.g) {
            this.h = this.i;
            this.bq = this.i.g;
            this.ao = FontUtil.getCurrentFontHeight(this.bj, this.i);
        }
        a = this.ao;
        var b = 0;
        var c = 0;
        var d = this.a2;
        var e = this.ap;
        d -= (this.af + this.ar + this.ag + this.as);
        e -= (this.ah + this.at + this.ae + this.aq);
        d = Math.max(d, 0);
        e = Math.max(e, 0);
        var f = d;
        if (!isNaN_(this.ay) && this.ay < d) {
            f = this.ay;
        }
        var g = this.bh(this.cr, this.bw, f, this.j);
        switch (this.b) {
            case 0:
                b = this.ar + this.af;
                break;
            case 3:
            case 1:
                b = this.ar + this.af + ((d / 2) - (g / 2));
                break;
            case 2:
                b = Math.max(0, (this.a2 - (this.as + this.ag))) - g;
                break;
        }
        switch (this.f) {
            case 0:
                c = this.at + this.ah;
                break;
            case 3:
            case 1:
                c = this.at + this.ah + ((e / 2) - (a / 2));
                break;
            case 2:
                c = Math.max(0, (this.ap - (this.aq + this.ae))) - a;
                break;
        }
        this.ax = b;
        this.az = this.ax + g;
        this.a0 = c;
        this.a1 = this.a0 + (a / 2);
        this.o = true;
    };
    CanvasGridCellBase.prototype.bh = function (a, b, c, d) {
        var e = b;
        var f = e.length;
        var g = ("\u2026");
        if (isNaN_(this.am)) {
            this.am = d.f(g);
        }
        if (c <= this.am) {
            a.ak = g;
            return this.am;
        }
        var h = d.f(e);
        if (h <= c) {
            a.ak = b;
            return h;
        }
        var i = c / h;
        var j = truncate(Math.ceil(f * i));
        var k = e.substr(0, j) + g;
        var l = d.f(k);
        if (l > c) {
            f = j;
        }
        else {
            j = j + 1;
            k = e.substr(0, j) + g;
            l = d.f(k);
            if (l > c) {
                f = j;
            }
        }
        while (h > c && f > 0) {
            f--;
            e = e.substr(0, f) + g;
            h = d.f(e);
        }
        a.ak = e;
        return h;
    };
    CanvasGridCellBase.prototype.ck = function (a) {
        this.f = a;
        this.o = true;
        this.q = true;
    };
    CanvasGridCellBase.prototype.ad = function (a) {
        return a.isClickActionDesired;
    };
    CanvasGridCellBase.prototype.onContactStarted = function (a, b) {
        if (this.a != null && this.ad(this.a)) {
            this.bt = a.pageX;
            this.bu = a.pageY;
            this.a.mouseDownCell(this.bt, this.bu);
        }
    };
    CanvasGridCellBase.prototype.onContactMoved = function (a, b) {
        if (this.a != null && this.ad(this.a)) {
            var c = a.pageX;
            var d = a.pageY;
            if (this.a.isMouseDown) {
                if (b) {
                    if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bp || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bp) {
                        this.a.mouseUpCell(c, d);
                    }
                    else {
                        a.stopPropagation();
                    }
                }
                else {
                    if (PointUtil.equals(this.a.mousePosition, null)) {
                        this.a.mouseUpCell(c, d);
                    }
                    else {
                        if (Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bn || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bn) {
                            this.a.isControlPressed = a.ctrlKey;
                            this.a.dragStarted();
                        }
                    }
                }
            }
        }
    };
    CanvasGridCellBase.prototype.onContactCompleted = function (a, b) {
        if (this.a != null && this.ad(this.a)) {
            var c = a.pageX;
            var d = a.pageY;
            if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > CanvasGridCellBase.bp || Math.abs(d - this.a.mousePosition.y) > CanvasGridCellBase.bp || this.a.isDrag) {
                this.a.mouseUpCell(c, d);
            }
            if (this.a.isCellDown()) {
                this.a.isControlPressed = a.ctrlKey;
                this.a.isShiftPressed = a.shiftKey;
                this.a.clickCell();
                this.a.mouseUpCell(a.pageX, a.pageY);
            }
        }
    };
    CanvasGridCellBase.$t = markType(CanvasGridCellBase, 'CanvasGridCellBase', Base.$, [INativeCell_$type]);
    CanvasGridCellBase.bs = new Random(0);
    CanvasGridCellBase.bp = 10;
    CanvasGridCellBase.bn = 3;
    return CanvasGridCellBase;
}(Base));
export { CanvasGridCellBase };
//# sourceMappingURL=CanvasGridCellBase.js.map