/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType } from "igniteui-angular-core";
import { ICellPresenter_$type } from "./ICellPresenter";
import { CellModel } from "./CellModel";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
var CellPresenterBase = /** @class */ (function (_super) {
    tslib_1.__extends(CellPresenterBase, _super);
    function CellPresenterBase(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    CellPresenterBase.prototype.modelUpdated = function (a) {
        this.b(a);
    };
    CellPresenterBase.prototype.b = function (a) {
        this.a.bf(a.c);
        if (a.al(CellModel.c9) || a.al(CellModel.dd) || a.al(CellModel.db) || a.al(CellModel.c7)) {
            this.a.bl(a.c8, a.dc, a.da, a.c6);
        }
        if (a.af) {
            this.a.bh(a.h6, a.cy, a.c3, a.c1, a.cw);
        }
        if (a.av) {
            this.a.bi(a.dt, (a.dc + a.c6 + a.c3 + a.cw));
            this.a.bn(a.e2, (a.c8 + a.da + a.cy + a.c1));
        }
        if (a.ah) {
            if (a.ap && !this.a.l) {
                this.a.a1();
            }
            if (a.al(CellModel.cv)) {
                this.a.bg(a.h5.color);
            }
            if (a.al(CellModel.c5)) {
                this.a.bk(a.bh);
            }
            if (a.ak("IsCollapsable")) {
                this.a.m = a.ag;
                this.a.au = a.dw;
                this.a.n = a.am;
                this.a.bn(a.e2, (a.c8 + a.da + a.cy + a.c1));
            }
            if (a.ak("Indent")) {
                this.a.au = a.dw;
                this.a.bn(a.e2, (a.c8 + a.da + a.cy + a.c1));
            }
            if (a.ak("IsExpanded")) {
                this.a.n = a.am;
            }
        }
        if (a.av && a.ap) {
            this.a.bu(a);
        }
    };
    CellPresenterBase.prototype.c = function (a, b, c) {
        if (c == 0) {
            return a.color;
        }
        if (c == 1) {
            return b.color;
        }
        var d = BrushUtil.g(a, c, b, 0);
        return d.color;
    };
    Object.defineProperty(CellPresenterBase.prototype, "nativeCell", {
        get: function () {
            return this.a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CellPresenterBase.prototype, "isCanvasBased", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    CellPresenterBase.$t = markType(CellPresenterBase, 'CellPresenterBase', Base.$, [ICellPresenter_$type]);
    return CellPresenterBase;
}(Base));
export { CellPresenterBase };
//# sourceMappingURL=CellPresenterBase.js.map