/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType } from "igniteui-angular-core";
import { ICellRenderingEngine_$type } from "./ICellRenderingEngine";
import { CurrentRendererSettings } from "./CurrentRendererSettings";
import { RenderingContext } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { intDivide } from "igniteui-angular-core";
/**
 * @hidden
 */
var DataGridCellLayoutPanel = /** @class */ (function (_super) {
    tslib_1.__extends(DataGridCellLayoutPanel, _super);
    function DataGridCellLayoutPanel(a, b, c) {
        var _this = _super.call(this) || this;
        _this.e = null;
        _this.k = false;
        _this.q = null;
        _this._element = null;
        _this.f = null;
        _this.i = false;
        _this.m = false;
        _this.g = null;
        _this.l = false;
        _this._requestAnimationFrame = null;
        _this.s = 0;
        _this.o = -1;
        _this.n = -1;
        _this.j = false;
        _this.p = 0;
        _this.c = null;
        _this.a = null;
        _this.d = null;
        _this.b = null;
        _this.p = c;
        _this.q = a;
        _this.requestAnimationFrame = _this.q.getRequestAnimationFrame();
        _this.element = _this.q.createElement("div");
        _this.element.setRawStyleProperty("position", "relative");
        _this.element.setRawStyleProperty("box-sizing", "border-box");
        _this.refresh(_this.e, false);
        _this.f = b;
        _this.i = false;
        return _this;
    }
    Object.defineProperty(DataGridCellLayoutPanel.prototype, "element", {
        get: function () {
            return this._element;
        },
        set: function (a) {
            this._element = a;
        },
        enumerable: true,
        configurable: true
    });
    DataGridCellLayoutPanel.prototype.refresh = function (a, b) {
        this.e = a;
        this.ah(b);
    };
    DataGridCellLayoutPanel.prototype.viewportChanged = function () {
        this.ah(true);
    };
    DataGridCellLayoutPanel.prototype.invalidateVisibility = function (a) {
        this.g = a;
        this.m = true;
    };
    Object.defineProperty(DataGridCellLayoutPanel.prototype, "initialRefreshFinished", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    DataGridCellLayoutPanel.prototype.z = function (a, b, c, d) {
        this.ah(true);
    };
    DataGridCellLayoutPanel.prototype.ag = function (a) {
        var b = this.f.b(this.q, a);
        if (b.isCanvasBased) {
            var c = b.nativeCell.ab = false;
        }
        else {
            var d = b.nativeCell.x;
            d.setRawStyleProperty("top", "-1000px");
        }
    };
    DataGridCellLayoutPanel.prototype.ah = function (a) {
        if (a) {
            this.k = true;
            this.t();
            return;
        }
        if (this.l) {
            return;
        }
        if (this.k) {
            return;
        }
        this.k = true;
        this.v(runOn(this, this.t));
    };
    Object.defineProperty(DataGridCellLayoutPanel.prototype, "requestAnimationFrame", {
        get: function () {
            return this._requestAnimationFrame;
        },
        set: function (a) {
            this._requestAnimationFrame = a;
        },
        enumerable: true,
        configurable: true
    });
    DataGridCellLayoutPanel.prototype.v = function (a) {
        this.requestAnimationFrame(a);
    };
    DataGridCellLayoutPanel.prototype.t = function () {
        if (!this.k) {
            return;
        }
        this.k = false;
        if (this.m) {
            this.m = false;
            this.g();
        }
        if (this.e == null) {
            return;
        }
        if (Rect.l_op_Equality(this.e.actualVisibleRegion, null) || this.e.actualVisibleRegion.isEmpty) {
            return;
        }
        this.i = true;
        if (this.o != this.e.absoluteWidth) {
            this.element.setRawStyleProperty("width", this.e.absoluteWidth + "px");
        }
        if (this.n != this.e.absoluteHeight) {
            this.element.setRawStyleProperty("height", this.e.absoluteHeight + "px");
        }
        this.o = this.e.absoluteWidth;
        this.n = this.e.absoluteHeight;
        var a = this.e.actualVisibleRegion.top;
        var b = this.e.actualVisibleRegion.left;
        var c = this.e.be;
        var d = c.count;
        var e = this.e.ay;
        var f = this.e.ay.o;
        var g = f.count;
        var h = this.e.ay.p;
        for (var i = 0; i < g; i++) {
            if (h._inner[i]) {
                continue;
            }
            var j = e.item(f._inner[i]);
            for (var k = 0; k < j.count; k++) {
                var l = j._inner[k];
                this.ag(l);
            }
        }
        e.u();
        var m = false;
        var n = this.s;
        var o = true;
        var p = false;
        for (var q = 0; q < d; q++) {
            var r = c._inner[q].q;
            var s = c._inner[q].q.count;
            var t = c._inner[q].p;
            for (var u = 0; u < s; u++) {
                if (t._inner[u]) {
                    continue;
                }
                var v = r._inner[u];
                var w = this.f.b(this.q, v);
                if (!w.isCanvasBased) {
                    o = false;
                }
                else {
                    p = true;
                }
                if (v.ao) {
                    m = true;
                }
                if (v.r == 1 && v.e6 != n) {
                    m = true;
                }
            }
        }
        if (p) {
            this.u();
        }
        if (m) {
            if (this.s == 0x7FFFFFFFFFFFFFFF - 1) {
                this.s = 0;
            }
            else {
                this.s++;
            }
            n = this.s;
        }
        var x = 0;
        var y = new CurrentRendererSettings();
        var z = this.p;
        this.l = true;
        for (var aa = 0; aa < d; aa++) {
            var ab = c._inner[aa].q;
            var ac = c._inner[aa].q.count;
            var ad = c._inner[aa].p;
            for (var ae = 0; ae < ac; ae++) {
                if (ad._inner[ae]) {
                    continue;
                }
                var af = ab._inner[ae];
                var ag = this.f.b(this.q, af);
                if (ag.isCanvasBased) {
                    var ah = y.a;
                    this.al(y, aa, af, this.e, x, m, o);
                    if (y.a != ah && m) {
                        x++;
                    }
                }
                var ai = ag.isCanvasBased;
                var aj = null;
                if (!ai) {
                    aj = ag.nativeCell.x;
                    if (af.r == 0) {
                        this.element.append(aj);
                    }
                }
                if (af.r == 1) {
                    if (ai) {
                        var ak = af.p.nativeCell;
                        ak.ab = true;
                    }
                }
                af.r = 2;
                var al = (af.ep + intDivide(af.e2, 2));
                var am = (af.er + intDivide(af.dt, 2));
                var an = (al - b) / this.e.actualVisibleRegion.width;
                var ao = (am - a) / this.e.actualVisibleRegion.height;
                if (af.aq) {
                    if (!ai) {
                        aj.setRawPosition(af.br, af.bs);
                    }
                }
                af.hh();
                if (ai) {
                    var ap = af.p.nativeCell;
                    ap.cg(z);
                }
                af.p.modelUpdated(af);
                if (ai && y.b) {
                    var aq = af.p.nativeCell;
                    aq.by(y.a, y.c, y.d, af.br, af.bs, z);
                }
                af.ha();
                if (m) {
                    af.e6 = n;
                    if (!ai) {
                        aj.setRawStyleProperty("z-index", x.toString());
                    }
                    x++;
                }
            }
        }
        this.l = false;
        if (y.a != null && this.p != 1) {
            y.a.y();
        }
    };
    DataGridCellLayoutPanel.prototype.u = function () {
        if (!this.j) {
            this.j = true;
            var a = this.q.rootWrapper;
            var b = (window.navigator.msPointerEnabled && MSGesture !== undefined);
            var c = (window.PointerEvent || window.navigator.pointerEnabled);
            var d = (window.TouchEvent);
            if ((b || c)) {
                a.listen("pointerdown", runOn(this, this.ad));
                a.listen("pointerup", runOn(this, this.af));
                a.listen("pointermove", runOn(this, this.ae));
            }
            else {
                a.listen("mousedown", runOn(this, this.w));
                a.listen("mouseup", runOn(this, this.y));
                a.listen("mousemove", runOn(this, this.x));
                a.listen("touchstart", runOn(this, this.ai));
                a.listen("touchend", runOn(this, this.ak));
                a.listen("touchmove", runOn(this, this.aj));
            }
        }
    };
    DataGridCellLayoutPanel.prototype.w = function (a) {
        this.ac(a, false);
    };
    DataGridCellLayoutPanel.prototype.y = function (a) {
        this.aa(a, false);
    };
    DataGridCellLayoutPanel.prototype.x = function (a) {
        this.ab(a, false);
    };
    DataGridCellLayoutPanel.prototype.ad = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.ai(e_);
        }
        else {
            this.w(e_);
        }
    };
    DataGridCellLayoutPanel.prototype.ae = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.aj(e_);
        }
        else {
            this.x(e_);
        }
    };
    DataGridCellLayoutPanel.prototype.af = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.ak(e_);
        }
        else {
            this.y(e_);
        }
    };
    DataGridCellLayoutPanel.prototype.ai = function (a) {
        this.ac(a, true);
    };
    DataGridCellLayoutPanel.prototype.ac = function (a, b) {
        if (this.e == null) {
            return;
        }
        var c = this.q.rootWrapper.getOffset();
        var d = this.e.d(a.pageX - c.left, a.pageY - c.top);
        if (d == null) {
            return;
        }
        if (d.p != null) {
            if (d.p.isCanvasBased && d.p.nativeCell != null) {
                d.p.nativeCell.onContactStarted(a, b);
            }
        }
    };
    DataGridCellLayoutPanel.prototype.aj = function (a) {
        this.ab(a, true);
    };
    DataGridCellLayoutPanel.prototype.ab = function (a, b) {
        if (this.e == null) {
            return;
        }
        var c = this.q.rootWrapper.getOffset();
        var d = this.e.d(a.pageX - c.left, a.pageY - c.top);
        if (d == null) {
            return;
        }
        if (d.p != null) {
            if (d.p.isCanvasBased && d.p.nativeCell != null) {
                d.p.nativeCell.onContactMoved(a, b);
            }
        }
    };
    DataGridCellLayoutPanel.prototype.ak = function (a) {
        this.aa(a, true);
    };
    DataGridCellLayoutPanel.prototype.aa = function (a, b) {
        if (this.e == null) {
            return;
        }
        var c = this.q.rootWrapper.getOffset();
        var d = this.e.d(a.pageX - c.left, a.pageY - c.top);
        if (d == null) {
            return;
        }
        if (d.p != null) {
            if (d.p.isCanvasBased && d.p.nativeCell != null) {
                d.p.nativeCell.onContactCompleted(a, b);
            }
        }
    };
    DataGridCellLayoutPanel.prototype.al = function (a, b, c, d, e, f, g) {
        if (g) {
            b = 0;
        }
        if (this.c == null) {
            this.c = new Array(d.be.count);
            this.a = new Array(d.be.count);
            this.d = new Array(d.be.count);
            this.b = new Array(d.be.count);
            for (var h = 0; h < d.be.count; h++) {
                this.c[h] = null;
                this.a[h] = null;
                this.d[h] = -1;
                this.b[h] = -1;
            }
        }
        if (this.c[b] == null) {
            var i = this.q.createElement("canvas");
            this.a[b] = i;
            i.setRawStyleProperty("position", "absolute");
            i.setRawStyleProperty("z-index", e.toString());
            this.element.append(i);
            var j_1 = this.q.get2DCanvasContext(i);
            var k = ((function () {
                var $ret = new CanvasViewRenderer();
                $ret.h$d = j_1;
                return $ret;
            })());
            this.c[b] = new RenderingContext(k, j_1);
        }
        if (a.a != this.c[b]) {
            a.a = this.c[b];
            a.b = true;
            a.c = d.actualVisibleRegion.left;
            a.d = d.actualVisibleRegion.top;
            var l = d.actualVisibleRegion.width * this.p;
            var m = d.actualVisibleRegion.height * this.p;
            if (l != this.d[b] || m != this.b[b]) {
                this.a[b].setRawSize(d.actualVisibleRegion.width, d.actualVisibleRegion.height);
                this.a[b].setAttribute("width", l + "px");
                this.a[b].setAttribute("height", m + "px");
                this.d[b] = l;
                this.b[b] = m;
            }
            if (f) {
                this.a[b].setRawStyleProperty("z-index", e.toString());
            }
            a.a.k(0, 0, d.actualVisibleRegion.width, d.actualVisibleRegion.height);
            this.a[b].setRawPosition(a.c, a.d);
        }
    };
    DataGridCellLayoutPanel.$t = markType(DataGridCellLayoutPanel, 'DataGridCellLayoutPanel', Base.$, [ICellRenderingEngine_$type]);
    return DataGridCellLayoutPanel;
}(Base));
export { DataGridCellLayoutPanel };
//# sourceMappingURL=DataGridCellLayoutPanel.js.map