/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, runOn, markType, PointUtil } from "igniteui-angular-core";
import { INativeCell_$type } from "./INativeCell";
import { GridExpansionIndicator } from "./GridExpansionIndicator";
import { PlaceholderView } from "./PlaceholderView";
import { Color } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { Random } from "igniteui-angular-core";
import { intDivide, truncate, isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
var GridCellBase = /** @class */ (function (_super) {
    tslib_1.__extends(GridCellBase, _super);
    function GridCellBase(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.t = null;
        _this.v = null;
        _this.w = null;
        _this.e = null;
        _this.ah = 0;
        _this.ae = 24;
        _this.ag = 0;
        _this.af = 0;
        _this.ak = 0;
        _this.i = false;
        _this.j = false;
        _this.g = false;
        _this.am = 0;
        _this.ao = 0;
        _this.an = 0;
        _this.al = 0;
        _this.aa = 0;
        _this.ac = 0;
        _this.ab = 0;
        _this.z = 0;
        _this.bw = null;
        _this.ai = 0;
        _this.aq = 0;
        _this.aj = 0;
        _this.f = null;
        _this.c = 0;
        _this.d = 0;
        _this.s = 0;
        _this.r = 0;
        _this.k = false;
        _this.aw = 0;
        _this.ax = 0;
        _this.y = 0;
        _this.h = false;
        _this.t = a;
        _this.v = _this.t.createElement("div");
        _this.v.setRawStyleProperty("position", "absolute");
        _this.v.setRawStyleProperty("overflow", "hidden");
        _this.v.setRawStyleProperty("box-sizing", "border-box");
        var b = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        var c = (window.PointerEvent || window.navigator.pointerEnabled);
        var d = (window.TouchEvent);
        if ((b || c)) {
            _this.v.listen("pointerdown", runOn(_this, _this.ba));
            _this.v.listen("pointerup", runOn(_this, _this.bd));
            _this.v.listen("pointermove", runOn(_this, _this.bc));
            _this.v.listen("pointerleave", runOn(_this, _this.bb));
        }
        else {
            _this.v.listen("mousedown", runOn(_this, _this.a3));
            _this.v.listen("mouseup", runOn(_this, _this.a6));
            _this.v.listen("mousemove", runOn(_this, _this.a5));
            _this.v.listen("mouseleave", runOn(_this, _this.a4));
            _this.v.listen("touchstart", runOn(_this, _this.bo));
            _this.v.listen("touchend", runOn(_this, _this.bq));
            _this.v.listen("touchmove", runOn(_this, _this.bp));
        }
        return _this;
    }
    Object.defineProperty(GridCellBase.prototype, "b", {
        get: function () {
            return this.a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "u", {
        get: function () {
            return this.t;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "x", {
        get: function () {
            return this.v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "at", {
        get: function () {
            return this.ah;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "ar", {
        get: function () {
            return this.af;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "as", {
        get: function () {
            return this.ag;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "au", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.a9("Indent", b, this.ak);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "m", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.a9("IsCollapsable", b, this.i);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridCellBase.prototype, "n", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.a9("IsExpanded", b, this.j);
            }
        },
        enumerable: true,
        configurable: true
    });
    GridCellBase.prototype.a2 = function () {
        this.ag = 10;
        this.af = this.au * 24;
        this.ah = 24;
        if (this.w == null) {
            this.w = this.t.createElement("div");
            this.w.setRawStyleProperty("display", "inline-block");
            this.w.setRawStyleProperty("vertical-align", "middle");
            this.w.setRawStyleProperty("width", this.ah + "px");
            this.w.setRawStyleProperty("height", this.ah + "px");
            this.w.setRawStyleProperty("cursor", "pointer");
            this.w.setRawStyleProperty("position", "absolute");
            this.w.setRawXPosition(this.am + this.af);
            this.w.setRawYPosition(intDivide(this.ai, 2) - intDivide(this.ae, 2));
        }
        if (this.e == null) {
            var a = this.t.getSubRenderer(this.w);
            this.e = new GridExpansionIndicator();
            this.e.ab(a);
            this.e.y(24, 24);
        }
        if (this.w.parent() == null) {
            this.v.append(this.w);
        }
    };
    GridCellBase.prototype.be = function () {
        this.ah = 0;
        this.ag = 0;
        if (this.w != null) {
            if (this.w.parent() != null) {
                this.w.remove();
            }
        }
    };
    Object.defineProperty(GridCellBase.prototype, "l", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
        },
        enumerable: true,
        configurable: true
    });
    GridCellBase.prototype.get_p = function () {
        return false;
    };
    Object.defineProperty(GridCellBase.prototype, "p", {
        get: function () {
            return this.get_p();
        },
        enumerable: true,
        configurable: true
    });
    GridCellBase.prototype.bl = function (a, b, c, d) {
        this.am = a;
        this.ao = b;
        this.an = c;
        this.al = d;
        this.v.setRawStyleProperty("padding-left", a.toString() + "px");
        this.v.setRawStyleProperty("padding-top", b.toString() + "px");
        this.v.setRawStyleProperty("padding-right", c.toString() + "px");
        this.v.setRawStyleProperty("padding-bottom", d.toString() + "px");
    };
    GridCellBase.prototype.bh = function (a, b, c, d, e) {
        this.aa = b;
        this.ac = c;
        this.ab = d;
        this.z = e;
        this.bw = a;
        if (a == null) {
            this.v.setRawStyleProperty("border", "");
        }
        else {
            this.v.setRawStyleProperty("border-color", a._fill);
            this.v.setRawStyleProperty("border-left-width", b.toString() + "px");
            this.v.setRawStyleProperty("border-top-width", c.toString() + "px");
            this.v.setRawStyleProperty("border-right-width", d.toString() + "px");
            this.v.setRawStyleProperty("border-bottom-width", e.toString() + "px");
            this.v.setRawStyleProperty("border-style", "solid");
        }
    };
    GridCellBase.prototype.get_o = function () {
        return false;
    };
    Object.defineProperty(GridCellBase.prototype, "o", {
        get: function () {
            return this.get_o();
        },
        enumerable: true,
        configurable: true
    });
    GridCellBase.prototype.bi = function (a, b) {
        if (this.ai != a || this.aj != b) {
            this.ai = a;
            this.aj = b;
            var c = Math.max(0, this.ai - this.aj);
            this.v.setRawStyleProperty("height", a.toString() + "px");
            this.v.setRawStyleProperty("line-height", c.toString() + "px");
            if (this.w != null) {
                this.w.setRawYPosition(intDivide(this.ai, 2) - intDivide(this.ah, 2));
            }
        }
    };
    GridCellBase.prototype.bn = function (a, b) {
        if (this.aq != a) {
            this.aq = a;
            this.v.setRawStyleProperty("width", a.toString() + "px");
        }
    };
    GridCellBase.prototype.a1 = function () {
        if (!this.p) {
            return;
        }
        this.g = true;
        this.f = new PlaceholderView(this.t);
        this.c = 0;
        this.d = 1;
        this.f.l = Color.u(120, 120, 120, 120);
        this.f.i = 0;
        this.v.append(this.f.g);
    };
    GridCellBase.prototype.bg = function (a) {
        this.v.setRawStyleProperty("background-color", a.colorString);
    };
    GridCellBase.prototype.bk = function (a) {
        this.v.setRawStyleProperty("opacity", a.toString());
    };
    GridCellBase.prototype.bv = function (a) {
        if (!this.p) {
            return;
        }
        this.f.i = (a * 0.20000000298023224);
    };
    GridCellBase.prototype.bt = function (a, b, c, d) {
        if (this.f != null) {
            var e = this.s;
            var f = this.r;
            if (this.d == 1) {
                b = truncate((b + (d / 2) - (f / 2)));
            }
            else if (this.d == 2) {
                b = truncate((b + (d) - (f)));
            }
            if (this.c == 1) {
                a = truncate((a + (c / 2) - (e / 2)));
            }
            else if (this.c == 2) {
                a = truncate((a + (c) - (e)));
            }
            this.f.g.setRawXPosition(a);
            this.f.g.setRawYPosition(b);
        }
    };
    GridCellBase.prototype.a8 = function (a, b, c) {
    };
    GridCellBase.prototype.bu = function (a) {
        if (!this.p) {
            return;
        }
        var b = DeviceUtils.f(12);
        if (a.x != null && !isNaN_(a.x.d)) {
            b = a.x.d;
        }
        if (this.r != b) {
            this.r = b;
            this.f.d = (b);
        }
        var c = a.e2 * 0.2;
        var d = a.dt * 0.6;
        if (this.s >= c && this.s <= d && !this.k) {
            return;
        }
        this.k = false;
        var e = (GridCellBase.av.nextDouble() * (d - c) + c);
        if (this.s != e) {
            this.s = e;
            this.f.e = e;
        }
        this.bt(this.am + this.af + this.ah, this.ao, this.aq - (this.am + this.an), this.ai - (this.ao + this.al));
    };
    GridCellBase.prototype.br = function (a, b) {
        if (!this.p) {
            return;
        }
        this.c = a;
        this.d = b;
        this.k = true;
    };
    GridCellBase.prototype.bs = function (a) {
        if (!this.p) {
            return;
        }
        if (a != null) {
            this.f.l = a.color;
        }
    };
    GridCellBase.prototype.bf = function (a) {
        this.a = a;
    };
    GridCellBase.prototype.bj = function (a, b) {
        switch (b) {
            case 0:
                this.x.setRawStyleProperty("text-align", "left");
                break;
            case 1:
                this.x.setRawStyleProperty("text-align", "center");
                break;
            case 2:
                this.x.setRawStyleProperty("text-align", "right");
                break;
            case 3:
                this.x.setRawStyleProperty("text-align", "center");
                break;
        }
    };
    GridCellBase.prototype.bm = function (a, b) {
        switch (b) {
            case 0:
                a.setRawStyleProperty("vertical-align", "top");
                break;
            case 1:
                a.setRawStyleProperty("vertical-align", "center");
                break;
            case 2:
                a.setRawStyleProperty("vertical-align", "bottom");
                break;
            case 3:
                a.setRawStyleProperty("vertical-align", "center");
                break;
        }
    };
    GridCellBase.prototype.q = function (a) {
        return a.isClickActionDesired;
    };
    GridCellBase.prototype.a3 = function (a) {
        this.onContactStarted(a, false);
    };
    GridCellBase.prototype.a6 = function (a) {
        this.onContactCompleted(a, false);
    };
    GridCellBase.prototype.a5 = function (a) {
        this.onContactMoved(a, false);
    };
    GridCellBase.prototype.a4 = function (a) {
        this.a7(a, false);
    };
    GridCellBase.prototype.ba = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.bo(e_);
        }
        else {
            this.a3(e_);
        }
    };
    GridCellBase.prototype.bc = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.bp(e_);
        }
        else {
            this.a5(e_);
        }
    };
    GridCellBase.prototype.bd = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.bq(e_);
        }
        else {
            this.a6(e_);
        }
    };
    GridCellBase.prototype.bb = function (e_) {
        var a = (e_.originalEvent.pointerType);
        if (a != "touch") {
            this.a4(e_);
        }
    };
    GridCellBase.prototype.bo = function (a) {
        this.onContactStarted(a, true);
    };
    GridCellBase.prototype.bp = function (a) {
        this.onContactMoved(a, true);
    };
    GridCellBase.prototype.bq = function (a) {
        this.onContactCompleted(a, true);
    };
    GridCellBase.prototype.onContactStarted = function (e_, a) {
        var b = false;
        if (this.m) {
            var indicator_ = this.e.q();
            b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
        }
        this.h = false;
        if (b) {
            this.h = true;
        }
        else {
            if (this.a != null && this.q(this.a)) {
                this.aw = e_.pageX;
                this.ax = e_.pageY;
                this.a.mouseDownCell(this.aw, this.ax);
            }
        }
    };
    GridCellBase.prototype.onContactMoved = function (a, b) {
        if (this.a != null) {
            var c = a.pageX;
            var d = a.pageY;
            if (this.q(this.a)) {
                if (this.a.isMouseDown) {
                    if (b) {
                        if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ap || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ap) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            a.stopPropagation();
                        }
                    }
                    else {
                        if (PointUtil.equals(this.a.mousePosition, null)) {
                            this.a.mouseUpCell(c, d);
                        }
                        else {
                            if (Math.abs(c - this.a.mousePosition.x) > GridCellBase.ad || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ad) {
                                this.a.isControlPressed = a.ctrlKey;
                                this.a.dragStarted();
                            }
                        }
                    }
                }
            }
            if (this.a.isHoverActionDesired) {
                this.a.mouseIsOver(c, d);
            }
        }
    };
    GridCellBase.prototype.onContactCompleted = function (e_, a) {
        var b = false;
        if (this.m) {
            var indicator_ = this.e.q();
            b = (e_.originalEvent.srcElement === indicator_ || e_.originalEvent.target === indicator_);
        }
        if (this.h && b) {
            this.b.clickExpansionIndicator();
        }
        else {
            if (this.a != null && this.q(this.a)) {
                var c = e_.pageX;
                var d = e_.pageY;
                if (PointUtil.equals(this.a.mousePosition, null) || Math.abs(c - this.a.mousePosition.x) > GridCellBase.ap || Math.abs(d - this.a.mousePosition.y) > GridCellBase.ap || this.a.isDrag) {
                    this.a.mouseUpCell(c, d);
                }
                if (this.a.isCellDown()) {
                    this.a.isControlPressed = e_.ctrlKey;
                    this.a.isShiftPressed = e_.shiftKey;
                    this.a.clickCell();
                    this.a.mouseUpCell(e_.pageX, e_.pageY);
                }
            }
        }
        this.h = false;
    };
    GridCellBase.prototype.a7 = function (a, b) {
        if (this.a != null && this.a.isLeaveActionDesired) {
            var c = a.pageX;
            var d = a.pageY;
            this.a.mouseLeaveCell(c, d);
        }
    };
    GridCellBase.prototype.a9 = function (a, b, c) {
        switch (a) {
            case "Indent":
                this.af = this.au * 24;
                this.ag = this.au > 0 ? 10 : 0;
                if (this.w != null) {
                    this.w.setRawXPosition(this.am + this.af);
                    this.w.setRawYPosition(intDivide(this.ai, 2) - intDivide(this.ae, 2));
                }
                break;
            case "IsCollapsable":
                if (this.m) {
                    this.a2();
                }
                else {
                    this.be();
                }
                break;
            case "IsExpanded":
                if (this.e != null) {
                    this.e.g = this.n;
                }
                break;
        }
    };
    GridCellBase.$t = markType(GridCellBase, 'GridCellBase', Base.$, [INativeCell_$type]);
    GridCellBase.av = new Random(0);
    GridCellBase.ap = 10;
    GridCellBase.ad = 3;
    return GridCellBase;
}(Base));
export { GridCellBase };
//# sourceMappingURL=GridCellBase.js.map