/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, Point_$type, runOn, markType, delegateCombine, delegateRemove, INotifyPropertyChanged_$type, PropertyChangedEventArgs, EnumUtil } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { GridFilterDialogViewModelRow } from "./GridFilterDialogViewModelRow";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { GridFilterDialogOpeningEventArgs } from "./GridFilterDialogOpeningEventArgs";
import { ColumnComparisonConditionOperatorType_$type } from "./ColumnComparisonConditionOperatorType";
import { ColumnComparisonFilterCondition } from "./ColumnComparisonFilterCondition";
import { GridFilterDialogFilterChangeEventArgs } from "./GridFilterDialogFilterChangeEventArgs";
import { ColumnFilterConditionGroup } from "./ColumnFilterConditionGroup";
import { Stack$1 } from "igniteui-angular-core";
import { GridFilterDialogViewModelGroupingLevel } from "./GridFilterDialogViewModelGroupingLevel";
import { GridFilterDialogViewModelGrouping } from "./GridFilterDialogViewModelGrouping";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GridFilterDialogViewModelGroupingLevelCollection } from "./GridFilterDialogViewModelGroupingLevelCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var GridFilterDialogView = /** @class */ (function (_super) {
    tslib_1.__extends(GridFilterDialogView, _super);
    function GridFilterDialogView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.x = new Path();
        _this.i = 0;
        _this.h = 0;
        _this.m = null;
        _this.c = null;
        _this.l = null;
        _this.f = 0;
        _this.e = 0;
        _this.g = 1;
        _this.k = 0;
        _this.j = 0;
        _this.d = false;
        _this.b = null;
        _this.a = a;
        return _this;
    }
    GridFilterDialogView.prototype.t = function () {
        if (this.i != this.k || this.h != this.j) {
            this.q();
            this.i = this.k;
            this.h = this.j;
        }
        var a = Math.min(this.k, this.j);
        var b = { $type: Point_$type, x: this.k / 2, y: this.j / 2 };
        var c = Math.round(this.k * this.g);
        var d = Math.round(this.j * this.g);
        if (this.f != c || this.e != d) {
            this.m.setAttribute("width", c.toString());
            this.m.setAttribute("height", d.toString());
            this.m.setStyleProperty("width", this.k.toString() + "px");
            this.m.setStyleProperty("height", this.j.toString() + "px");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.f = truncate(Math.round(c));
            this.e = truncate(Math.round(d));
        }
        if (this.c.d && this.g != 1) {
            this.c.z();
            this.c.aa(this.g, this.g);
        }
        this.c.k(0, 0, this.k, this.j);
        this.c.s(this.x);
        if (this.c.d && this.g != 1) {
            this.c.y();
        }
    };
    GridFilterDialogView.prototype.q = function () {
        this.a.ah(this.k, this.j, this.x);
    };
    GridFilterDialogView.prototype.r = function (a) {
        if (a == null) {
            if (this.m != null) {
                this.m.destroy();
            }
            this.m = null;
            this.l = null;
            this.c = null;
            return;
        }
        this.g = (isNaN_(this.a.u) ? this.a.t : this.a.u);
        var b = a;
        this.l = b;
        this.l.rootWrapper.addClass("ui-radialgauge-container");
        var c = this.g;
        var d = Math.round(b.rootWrapper.width());
        var e = Math.round(b.rootWrapper.height());
        var f = d * c;
        var g = e * c;
        this.l.rootWrapper.setStyleProperty("position", "relative");
        var h = this.l.createElement("canvas");
        h.setStyleProperty("position", "absolute");
        this.l.append(h);
        this.f = truncate(Math.round(f));
        this.e = truncate(Math.round(g));
        h.setAttribute("width", f.toString());
        h.setAttribute("height", g.toString());
        h.setStyleProperty("width", d.toString() + "px");
        h.setStyleProperty("height", e.toString() + "px");
        h.listen("mousedown", runOn(this, this.n));
        h.listen("mouseup", runOn(this, this.o));
        this.k = d;
        this.j = e;
        this.m = h;
        var i = this.l.get2DCanvasContext(this.m);
        this.c = new RenderingContext(new CanvasViewRenderer(), i);
        if (isNaN_(this.a.u)) {
            this.a.t = window.devicePixelRatio;
            this.g = this.a.t;
        }
        this.t();
    };
    GridFilterDialogView.prototype.n = function (a) {
        a.preventDefault();
        a.stopPropagation();
    };
    GridFilterDialogView.prototype.o = function (a) {
        a.preventDefault();
        a.stopPropagation();
        if (!this.d) {
            this.a.am();
        }
        else {
            this.a.ag(this.b.b, false);
        }
    };
    GridFilterDialogView.prototype.u = function () {
        this.t();
    };
    GridFilterDialogView.prototype.s = function (a, b) {
        if (isNaN_(this.a.u)) {
            this.a.t = window.devicePixelRatio;
            this.g = this.a.t;
        }
        this.k = a;
        this.j = b;
        this.t();
    };
    GridFilterDialogView.prototype.w = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(138, 0, 0, 0);
            return $ret;
        })());
    };
    GridFilterDialogView.prototype.v = function (a) {
        this.d = true;
        var b = new GridFilterDialogPanel(this.m, this.l);
        b.a = this.a;
        b.x(a);
        this.b = b;
    };
    GridFilterDialogView.prototype.p = function () {
        this.d = false;
        if (this.b != null) {
            this.b.o();
            this.b.p();
            this.b = null;
        }
    };
    GridFilterDialogView.$t = markType(GridFilterDialogView, 'GridFilterDialogView');
    return GridFilterDialogView;
}(Base));
export { GridFilterDialogView };
/**
 * @hidden
 */
var GridFilterDialogPanel = /** @class */ (function (_super) {
    tslib_1.__extends(GridFilterDialogPanel, _super);
    function GridFilterDialogPanel(a, b) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.i = null;
        _this.d = null;
        _this.h = null;
        _this.k = null;
        _this.b = null;
        _this.g = null;
        _this.f = null;
        _this.j = null;
        _this.e = null;
        _this.c = false;
        var c = b.createElement("div");
        var d = b.getSubRenderer(c);
        c.setStyleProperty("position", "absolute");
        c.setStyleProperty("top", "0px");
        c.setStyleProperty("left", "0px");
        c.setStyleProperty("display", "none");
        c.setStyleProperty("z-index", "10000");
        c.setStyleProperty("opacity", ".9");
        c.setStyleProperty("background-color", "#aaa");
        c.setStyleProperty("border-radius", "3px");
        c.setStyleProperty("boxShadow", "0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22)");
        _this.i = a;
        _this.d = d;
        _this.h = c;
        _this.k = d.createElement("div");
        _this.h.append(_this.k);
        _this.g = d.createElement("div");
        _this.h.append(_this.g);
        _this.e = d.createElement("input");
        _this.e.setAttribute("type", "button");
        _this.e.setProperty("value", "add condition");
        _this.f = d.createElement("input");
        _this.f.setAttribute("type", "button");
        _this.f.setProperty("value", "apply");
        _this.j = d.createElement("input");
        _this.j.setAttribute("type", "button");
        _this.j.setProperty("value", "reset");
        _this.g.append(_this.e);
        _this.g.append(_this.f);
        _this.g.append(_this.j);
        _this.e.listen("click", runOn(_this, _this.r));
        _this.f.listen("click", runOn(_this, _this.s));
        _this.j.listen("click", runOn(_this, _this.v));
        _this.e.setStyleProperty("opacity", ".9");
        _this.e.setStyleProperty("margin", "3px");
        _this.f.setStyleProperty("opacity", ".9");
        _this.f.setStyleProperty("margin", "3px");
        _this.j.setStyleProperty("opacity", ".9");
        _this.j.setStyleProperty("margin", "3px");
        return _this;
    }
    GridFilterDialogPanel.prototype.r = function (a) {
        this.b.n();
    };
    GridFilterDialogPanel.prototype.v = function (a) {
        this.a.ag(this.b, true);
    };
    GridFilterDialogPanel.prototype.s = function (a) {
        this.a.ag(this.b, false);
    };
    GridFilterDialogPanel.prototype.x = function (a) {
        a.onModified = delegateCombine(a.onModified, runOn(this, this.aa));
        this.b = a;
        this.z();
        this.h.setStyleProperty("left", this.i.getOffset().left + "px");
        this.h.setStyleProperty("top", (this.i.getOffset().top + this.i.outerHeight()) + "px");
        this.h.setStyleProperty("display", "block");
        this.d.appendToBody(this.h);
    };
    GridFilterDialogPanel.prototype.o = function () {
        var a = this.b;
        a.onModified = delegateRemove(a.onModified, runOn(this, this.aa));
        this.b = null;
        this.h.setStyleProperty("display", "none");
        this.h.remove();
    };
    GridFilterDialogPanel.prototype.p = function () {
        this.d.destroy();
        this.h = null;
        this.k = null;
        this.f = null;
        this.g = null;
        this.j = null;
        if (this.b != null) {
            var a = this.b;
            a.onModified = delegateRemove(a.onModified, runOn(this, this.aa));
        }
        this.b = null;
    };
    GridFilterDialogPanel.prototype.aa = function (a) {
        if (this.c) {
            return;
        }
        this.z();
    };
    GridFilterDialogPanel.prototype.z = function () {
        for (var a = 0; a < this.b.f.count; a++) {
            var b = null;
            if (a < this.k.getChildCount()) {
                b = this.k.getChildAt(a);
            }
            else {
                b = this.d.createElement("div");
                this.k.append(b);
            }
            this.y(a, b, this.b.f._inner[a]);
        }
        while (this.k.getChildCount() > this.b.f.count) {
            var c = this.k.getChildAt(this.k.getChildCount() - 1);
            c.remove();
        }
    };
    GridFilterDialogPanel.prototype.y = function (a, b, c) {
        var d = false;
        var e = false;
        var f = false;
        var g = false;
        var h = this.l(c) > 0;
        if (b.getChildCount() == 0) {
            d = true;
            e = h;
            f = true;
        }
        else {
            if (h && b.getChildCount() == 2) {
                e = true;
            }
            if (!h && b.getChildCount() == 3) {
                g = true;
            }
        }
        var i = null;
        var j = null;
        var k = null;
        if (d) {
            i = this.d.createElement("select");
            this.q(i, c);
            i.listen("change", runOn(this, this.w));
            i.setStyleProperty("opacity", ".9");
            i.setStyleProperty("margin", "3px");
            b.append(i);
        }
        else {
            i = b.getChildAt(0);
        }
        if (e) {
            j = this.d.createElement("input");
            j.setAttribute("type", "text");
            j.listen("input", runOn(this, this.u));
            j.setStyleProperty("opacity", ".9");
            j.setStyleProperty("margin", "3px");
            if (b.getChildCount() == 2) {
                var l = b.getChildAt(b.getChildCount() - 1);
                l.before(j);
            }
            else {
                b.append(j);
            }
        }
        else {
            j = b.getChildAt(1);
        }
        if (g) {
            var m = b.getChildAt(1);
            m.remove();
        }
        if (f) {
            k = this.d.createElement("input");
            k.setAttribute("type", "button");
            k.setProperty("value", "X");
            k.listen("click", runOn(this, this.t));
            k.setStyleProperty("opacity", ".9");
            k.setStyleProperty("margin", "3px");
            b.append(k);
        }
        else {
            k = b.getChildAt(b.getChildCount() - 1);
        }
        this.c = true;
        i.setAttribute("data-index", a.toString());
        if (!stringIsNullOrEmpty(c.l)) {
            i.setProperty("value", c.l);
        }
        if (b.getChildCount() > 2) {
            j.setAttribute("data-index", a.toString());
            if (c.i != null) {
                j.setProperty("value", c.i);
            }
        }
        k.setAttribute("data-index", a.toString());
        this.c = false;
    };
    GridFilterDialogPanel.prototype.q = function (a, b) {
        a.removeChildren();
        for (var c = 0; c < b.e.length; c++) {
            var d = this.d.createElement("option");
            d.setAttribute("value", b.e[c]);
            d.setText(b.e[c]);
            a.append(d);
        }
    };
    GridFilterDialogPanel.prototype.t = function (a) {
        var b = this.n(a);
        this.b.f.removeAt(b);
    };
    GridFilterDialogPanel.prototype.n = function (a) {
        var originalEvent_ = a.originalEvent;
        var currentTarget_ = originalEvent_.currentTarget;
        return parseInt((currentTarget_.getAttribute('data-index')));
    };
    GridFilterDialogPanel.prototype.u = function (a) {
        this.c = true;
        var b = this.n(a);
        var c = this.k.getChildAt(b).getChildAt(1).getProperty("value");
        this.b.f._inner[b].i = c;
        this.c = false;
    };
    GridFilterDialogPanel.prototype.w = function (a) {
        this.c = true;
        var b = this.n(a);
        var c = this.k.getChildAt(b).getChildAt(0).getProperty("value");
        this.b.f._inner[b].l = c;
        this.c = false;
    };
    GridFilterDialogPanel.prototype.l = function (a) {
        return a.d[this.m(a)];
    };
    GridFilterDialogPanel.prototype.m = function (a) {
        for (var b = 0; b < a.e.length; b++) {
            if (a.e[b] == a.l) {
                return b;
            }
        }
        return 0;
    };
    GridFilterDialogPanel.$t = markType(GridFilterDialogPanel, 'GridFilterDialogPanel');
    return GridFilterDialogPanel;
}(Base));
export { GridFilterDialogPanel };
/**
 * @hidden
 */
var GridFilterDialog = /** @class */ (function (_super) {
    tslib_1.__extends(GridFilterDialog, _super);
    function GridFilterDialog() {
        var _this = _super.call(this) || this;
        _this.x = null;
        _this.o = true;
        _this.propertyChanged = null;
        _this.s = NaN;
        _this.r = 1;
        _this.f = null;
        _this.dialogOpening = null;
        _this.filterChanging = null;
        _this.filterChanged = null;
        _this.l = null;
        _this.l = new GridFilterDialogView(_this);
        return _this;
    }
    Object.defineProperty(GridFilterDialog.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            this.x = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridFilterDialog.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ak("IsAnimationEnabled", b, this.o);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridFilterDialog.prototype, "u", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            this.ak("PixelScalingRatio", b, this.s);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridFilterDialog.prototype, "t", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            this.ak("ActualPixelScalingRatio", b, this.r);
        },
        enumerable: true,
        configurable: true
    });
    GridFilterDialog.prototype.ak = function (a, b, c) {
        this.an(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    GridFilterDialog.prototype.an = function (a, b, c) {
        switch (a) {
            case "PixelScalingRatio":
                this.t = this.u;
                break;
            case "ActualPixelScalingRatio":
                this.l.u();
                break;
        }
    };
    GridFilterDialog.prototype.ao = function (a) {
        this.l.r(a);
    };
    GridFilterDialog.prototype.am = function () {
        var a = null;
        var b = 0;
        if (this.dialogOpening != null) {
            var c = new GridFilterDialogOpeningEventArgs();
            this.dialogOpening(this, c);
            a = c.a;
            b = c.b;
        }
        this.as(a, b);
    };
    GridFilterDialog.prototype.as = function (a, b) {
        this.f = a;
        var c = ColumnComparisonFilterCondition.c(b);
        var d = this.m(a, c);
        d.m = 1;
        d.a = b;
        d.onModified = delegateCombine(d.onModified, runOn(this, this.al));
        this.l.v(d);
    };
    GridFilterDialog.prototype.aj = function (a, b) {
        a.onModified = delegateRemove(a.onModified, runOn(this, this.al));
        if (b) {
            this.aq();
        }
        else {
            this.ap(a, true);
        }
        this.f = null;
    };
    GridFilterDialog.prototype.ar = function () {
        var _this = this;
        if (this.filterChanged != null) {
            this.filterChanged(this, ((function () {
                var $ret = new GridFilterDialogFilterChangeEventArgs();
                $ret.a = _this.f;
                return $ret;
            })()));
        }
    };
    GridFilterDialog.prototype.aq = function () {
        if (this.filterChanged != null) {
            this.filterChanged(this, ((function () {
                var $ret = new GridFilterDialogFilterChangeEventArgs();
                $ret.a = null;
                return $ret;
            })()));
        }
    };
    GridFilterDialog.prototype.ap = function (a, b) {
        var c = this.e(a);
        if (b) {
            if (this.filterChanged != null) {
                this.filterChanged(this, ((function () {
                    var $ret = new GridFilterDialogFilterChangeEventArgs();
                    $ret.a = c;
                    return $ret;
                })()));
            }
        }
        else {
            if (this.filterChanging != null) {
                this.filterChanging(this, ((function () {
                    var $ret = new GridFilterDialogFilterChangeEventArgs();
                    $ret.a = c;
                    return $ret;
                })()));
            }
        }
    };
    GridFilterDialog.prototype.e = function (a) {
        var b = new ColumnFilterConditionGroup();
        b.f = a.k;
        var c = new Stack$1(ColumnFilterConditionGroup.$);
        var d = 0;
        var e = b;
        for (var f = 0; f < a.f.count; f++) {
            var g = this.h(d, c, a, f);
            while (g != null) {
                e.h(g);
                e = g;
                d++;
                g = this.h(d, c, a, f);
            }
            g = this.g(d, c, a, f);
            while (g != null) {
                e = g;
                d--;
                g = this.g(d, c, a, f);
            }
            if (e == null) {
                e = b;
            }
            if (this.q(a, a.f._inner[f])) {
                continue;
            }
            e.h(this.d(a.f._inner[f]));
        }
        if (b.g == 0) {
            return null;
        }
        return b;
    };
    GridFilterDialog.prototype.q = function (a, b) {
        var c = 0;
        for (var d = 0; d < b.e.length; d++) {
            if (b.e[d] == b.l) {
                c = d;
                break;
            }
        }
        if (b.d[c] > 0 && b.i == null) {
            return true;
        }
        if (a.a != 0 && b.d[c] > 0 && typeof b.i === 'string' && stringIsNullOrEmpty(b.i)) {
            return true;
        }
        return false;
    };
    GridFilterDialog.prototype.g = function (a, b, c, d) {
        var e = this.w(c, d);
        if (a > e) {
            b.e();
            return b.d();
        }
        return null;
    };
    GridFilterDialog.prototype.w = function (a, b) {
        var c = a.c(b);
        if (c == null) {
            return 0;
        }
        return a.e.indexOf(c);
    };
    GridFilterDialog.prototype.h = function (a, b, c, d) {
        var e = this.w(c, d);
        if (a < e) {
            var f = c.b(d);
            var g = new ColumnFilterConditionGroup();
            g.f = f.a;
            b.h(g);
            return g;
        }
        return null;
    };
    GridFilterDialog.prototype.d = function (a) {
        var b = new ColumnComparisonFilterCondition();
        b.e = this.c(a.l);
        b.i = a.i;
        return b;
    };
    GridFilterDialog.prototype.c = function (a) {
        return EnumUtil.getEnumValue(ColumnComparisonConditionOperatorType_$type, EnumUtil.parse(ColumnComparisonConditionOperatorType_$type, a, true));
    };
    GridFilterDialog.prototype.al = function (a) {
        this.ap(a, false);
    };
    GridFilterDialog.prototype.m = function (a, b) {
        var c = new GridFilterDialogViewModel();
        if (a != null) {
            this.af(c, a, b);
        }
        else {
            var d = new GridFilterDialogViewModelRow();
            d.f = b;
            d.e = GridFilterDialog.a(b);
            d.d = GridFilterDialog.b(b);
            d.l = GridFilterDialog.ac(b[0]);
            c.f.add(d);
        }
        return c;
    };
    GridFilterDialog.prototype.af = function (a, b, c) {
        if (b.b()) {
            var d = b;
            for (var e = 0; e < d.g; e++) {
                var f = d.item(e);
                this.af(a, f, c);
            }
        }
        else {
            a.f.add(this.n(b, c));
        }
    };
    GridFilterDialog.prototype.n = function (a, b) {
        var c = new GridFilterDialogViewModelRow();
        c.l = GridFilterDialog.ac(a.e);
        c.f = b;
        c.e = GridFilterDialog.a(b);
        c.i = GridFilterDialog.z(GridFilterDialog.v(a.e), a.e, a);
        c.j = GridFilterDialog.aa(GridFilterDialog.v(a.e), a.e, a);
        c.d = GridFilterDialog.b(b);
        return c;
    };
    GridFilterDialog.v = function (a) {
        return ColumnComparisonFilterCondition.g(a);
    };
    GridFilterDialog.z = function (a, b, c) {
        if (a == 0) {
            return "";
        }
        return c.i != null ? c.i.toString() : "";
    };
    GridFilterDialog.aa = function (a, b, c) {
        return "";
    };
    GridFilterDialog.b = function (a) {
        return ColumnComparisonFilterCondition.d(a);
    };
    GridFilterDialog.a = function (a) {
        var b = new Array(a.length);
        for (var c = 0; c < a.length; c++) {
            b[c] = EnumUtil.getName(ColumnComparisonConditionOperatorType_$type, a[c]);
        }
        return b;
    };
    GridFilterDialog.ac = function (a) {
        return EnumUtil.getName(ColumnComparisonConditionOperatorType_$type, a);
    };
    GridFilterDialog.prototype.ai = function (a, b) {
        this.l.s(a, b);
    };
    GridFilterDialog.prototype.ah = function (a, b, c) {
        var d = Math.min(a, b);
        var e = { $type: Point_$type, x: a / 2, y: b / 2 };
        var f = d * 0.8;
        var g = f / 2;
        var h = g / 2;
        var i = h / 2;
        var j = i / 2;
        var k = new PathFigure();
        k._startPoint = { $type: Point_$type, x: e.x - g, y: e.y - g };
        var l = new LineSegment(1);
        l.c = { $type: Point_$type, x: e.x + g, y: e.y - g };
        k._segments.add(l);
        var m = new PathFigure();
        m._startPoint = { $type: Point_$type, x: e.x - h, y: e.y };
        var n = new LineSegment(1);
        n.c = { $type: Point_$type, x: e.x + h, y: e.y };
        m._segments.add(n);
        var o = new PathFigure();
        o._startPoint = { $type: Point_$type, x: e.x - i, y: e.y + g };
        var p = new LineSegment(1);
        p.c = { $type: Point_$type, x: e.x + i, y: e.y + g };
        o._segments.add(p);
        var q = new PathGeometry();
        q.c.add(k);
        q.c.add(m);
        q.c.add(o);
        c.ak = q;
        c._stroke = this.l.w();
        c.ac = 1;
    };
    GridFilterDialog.prototype.ag = function (a, b) {
        this.l.p();
        this.aj(a, b);
    };
    GridFilterDialog.$t = markType(GridFilterDialog, 'GridFilterDialog', Base.$, [INotifyPropertyChanged_$type]);
    return GridFilterDialog;
}(Base));
export { GridFilterDialog };
/**
 * @hidden
 */
var GridFilterDialogViewModel = /** @class */ (function (_super) {
    tslib_1.__extends(GridFilterDialogViewModel, _super);
    function GridFilterDialogViewModel() {
        var _this = _super.call(this) || this;
        _this.a = 0;
        _this.e = null;
        _this.k = false;
        _this.m = 0;
        _this.f = null;
        _this.onModified = null;
        _this.k = false;
        _this.f = new GridFilterDialogViewModelRowCollection();
        _this.f.ae = _this;
        _this.e = new GridFilterDialogViewModelGroupingLevelCollection();
        _this.f.ag = runOn(_this, _this.u);
        var a = _this.f;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.t));
        return _this;
    }
    GridFilterDialogViewModel.prototype.n = function () {
        var a = new GridFilterDialogViewModelRow();
        var b = ColumnComparisonFilterCondition.c(this.a);
        a.f = b;
        a.e = GridFilterDialog.a(b);
        a.d = GridFilterDialog.b(b);
        a.l = GridFilterDialog.ac(b[0]);
        this.f.add(a);
    };
    GridFilterDialogViewModel.prototype.u = function (a) {
        if (this.onModified != null) {
            this.onModified(this);
        }
    };
    GridFilterDialogViewModel.prototype.t = function (a, b) {
        switch (b.action) {
            case 0:
                if (b.newItems != null) {
                    for (var c = 0; c < b.newItems.count; c++) {
                        var d = b.newItems.item(c);
                        this.q(c + b.newStartingIndex, d);
                    }
                }
                break;
            case 1:
                if (b.oldItems != null) {
                    for (var e = 0; e < b.oldItems.count; e++) {
                        this.r(b.oldStartingIndex);
                    }
                }
                break;
            case 2:
                if (b.oldItems != null) {
                    for (var f = 0; f < b.oldItems.count; f++) {
                        this.r(b.oldStartingIndex);
                    }
                }
                if (b.newItems != null) {
                    for (var g = 0; g < b.newItems.count; g++) {
                        var h = b.newItems.item(g);
                        this.q(g + b.newStartingIndex, b.newItems.item(g));
                    }
                }
                break;
            case 4:
                this.s();
                break;
        }
        if (this.onModified != null) {
            this.onModified(this);
        }
    };
    GridFilterDialogViewModel.prototype.r = function (a) {
        var b = this.c(a);
        if (b == null) {
            return;
        }
        var c = this.b(a);
        if (c == null) {
            return;
        }
        this.w(c, a);
        for (var d = b.indexOf(c) + 1; d < b.count; d++) {
            this.v(b._inner[d], -1);
        }
    };
    GridFilterDialogViewModel.prototype.w = function (a, b) {
        a.b--;
    };
    GridFilterDialogViewModel.prototype.s = function () {
        this.e.clear();
    };
    GridFilterDialogViewModel.prototype.q = function (a, b) {
        var c = this.c(a);
        if (c == null) {
            return;
        }
        var d = this.b(a);
        if (d == null) {
            return;
        }
        this.p(d, a);
        for (var e = c.indexOf(d) + 1; e < c.count; e++) {
            this.v(c._inner[e], +1);
        }
    };
    GridFilterDialogViewModel.prototype.v = function (a, b) {
        a.c += b;
        a.b -= b;
    };
    GridFilterDialogViewModel.prototype.p = function (a, b) {
        a.b++;
    };
    GridFilterDialogViewModel.prototype.b = function (a) {
        for (var b = this.e.count - 1; b >= 0; b--) {
            for (var c = 0; c < this.e._inner[b].count; c--) {
                if (this.e._inner[b]._inner[c].c <= a && this.e._inner[b]._inner[c].b >= a) {
                    return this.e._inner[b]._inner[c];
                }
            }
        }
        return null;
    };
    GridFilterDialogViewModel.prototype.c = function (a) {
        for (var b = this.e.count - 1; b >= 0; b--) {
            for (var c = 0; c < this.e._inner[b].count; c--) {
                if (this.e._inner[b]._inner[c].c <= a && this.e._inner[b]._inner[c].b >= a) {
                    return this.e._inner[b];
                }
            }
        }
        return null;
    };
    GridFilterDialogViewModel.prototype.h = function (a, b) {
        var c = this.d(a, b);
        if (this.i(c, a, b)) {
            if (this.e.count < this.m) {
                return true;
            }
            else {
                return false;
            }
        }
        return true;
    };
    GridFilterDialogViewModel.prototype.i = function (a, b, c) {
        if (a == null) {
            return false;
        }
        for (var d = 0; d < a.count; d++) {
            if (this.j(a._inner[d], b, c)) {
                return true;
            }
        }
        return false;
    };
    GridFilterDialogViewModel.prototype.j = function (a, b, c) {
        if (c > a.c || b > a.b) {
            return false;
        }
        return true;
    };
    GridFilterDialogViewModel.prototype.d = function (a, b) {
        if (this.e.count == 0) {
            return null;
        }
        for (var c = 0; c < this.e.count; c++) {
            if (!this.i(this.e._inner[c], a, b)) {
                return this.e._inner[c];
            }
        }
        return this.e._inner[this.e.count - 1];
    };
    GridFilterDialogViewModel.prototype.aa = function (a, b) {
        for (var c = 0; c < this.e.count; c++) {
            for (var d = 0; d < this.e._inner[c].count; d++) {
                if (this.e._inner[c]._inner[d].c == a && this.e._inner[c]._inner[d].b == b) {
                    this.e._inner[c].removeAt(d);
                    break;
                }
            }
        }
        this.x();
        if (this.onModified != null) {
            this.onModified(this);
        }
    };
    GridFilterDialogViewModel.prototype.x = function () {
        for (var a = this.e.count - 1; a >= 0; a--) {
            var b = new List$1(GridFilterDialogViewModelGrouping.$, 0);
            for (var c = 0; c < this.e._inner[a].count; c++) {
                var d = this.e._inner[a]._inner[c];
                if (a > 0) {
                    if (!this.i(this.e._inner[a - 1], d.c, d.b)) {
                        b.add(d);
                    }
                }
            }
            for (var e = 0; e < b.count; e++) {
                this.e._inner[a].remove(b._inner[e]);
                this.e._inner[a - 1].add(b._inner[e]);
            }
            if (this.e._inner[a].count == 0) {
                this.e.removeAt(a);
            }
        }
        this.y();
    };
    GridFilterDialogViewModel.prototype.y = function () {
        for (var a = this.e.count - 1; a >= 0; a--) {
            var b = new List$1(GridFilterDialogViewModelGrouping.$, 0);
            for (var c = 0; c < this.e._inner[a].count; c++) {
                b.add(this.e._inner[a]._inner[c]);
            }
            b.aa(function (d, e) { return Base.compareSimple(d.c, e.c); });
            this.e._inner[a].clear();
            for (var d = 0; d < this.e._inner[a].count; d++) {
                this.e._inner[a].add(b._inner[d]);
            }
        }
    };
    GridFilterDialogViewModel.prototype.l = function (a, b) {
        for (var c = 0; c < this.e.count; c++) {
            for (var d = 0; d < this.e._inner[c].count; d++) {
                if (this.e._inner[c]._inner[d].c == a && this.e._inner[c]._inner[d].b == b) {
                    return true;
                }
            }
        }
        return false;
    };
    GridFilterDialogViewModel.prototype.z = function (a, b) {
        for (var c = 0; c < this.e.count; c++) {
            for (var d = 0; d < this.e._inner[c].count; d++) {
                if (this.e._inner[c]._inner[d].c == a && this.e._inner[c]._inner[d].b == b) {
                    this.e._inner[c]._inner[d].a = !this.e._inner[c]._inner[d].a;
                }
            }
        }
        if (this.onModified != null) {
            this.onModified(this);
        }
    };
    GridFilterDialogViewModel.prototype.o = function (a, b, c) {
        if (!this.h(a, b)) {
            return;
        }
        var d = this.d(a, b);
        var e = d;
        if (this.i(d, a, b)) {
            this.e.add(new GridFilterDialogViewModelGroupingLevel());
            e = this.d(a, b);
        }
        e.add(((function () {
            var $ret = new GridFilterDialogViewModelGrouping();
            $ret.c = a;
            $ret.b = b;
            $ret.a = c;
            return $ret;
        })()));
        this.y();
        if (this.onModified != null) {
            this.onModified(this);
        }
    };
    GridFilterDialogViewModel.$t = markType(GridFilterDialogViewModel, 'GridFilterDialogViewModel');
    return GridFilterDialogViewModel;
}(Base));
export { GridFilterDialogViewModel };
/**
 * @hidden
 */
var GridFilterDialogViewModelRowCollection = /** @class */ (function (_super) {
    tslib_1.__extends(GridFilterDialogViewModelRowCollection, _super);
    function GridFilterDialogViewModelRowCollection() {
        var _this = _super.call(this, GridFilterDialogViewModelRow.$, 0) || this;
        _this.ae = null;
        _this.af = null;
        _this.collectionChanged = delegateCombine(_this.collectionChanged, runOn(_this, _this.ah));
        return _this;
    }
    GridFilterDialogViewModelRowCollection.prototype.ah = function (a, b) {
        if (b.oldItems != null) {
            for (var c = 0; c < b.oldItems.count; c++) {
                var d = b.oldItems.item(c);
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.ai));
            }
        }
        if (b.newItems != null) {
            for (var e = 0; e < b.newItems.count; e++) {
                var f = b.newItems.item(e);
                f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.ai));
            }
        }
    };
    GridFilterDialogViewModelRowCollection.prototype.ai = function (a, b) {
        if (this.af != null) {
            this.af(this.ae);
        }
    };
    Object.defineProperty(GridFilterDialogViewModelRowCollection.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            this.af = a;
        },
        enumerable: true,
        configurable: true
    });
    GridFilterDialogViewModelRowCollection.$t = markType(GridFilterDialogViewModelRowCollection, 'GridFilterDialogViewModelRowCollection', ObservableCollection$1.$.specialize(GridFilterDialogViewModelRow.$));
    return GridFilterDialogViewModelRowCollection;
}(ObservableCollection$1));
export { GridFilterDialogViewModelRowCollection };
//# sourceMappingURL=GridFilterDialogView_combined.js.map