/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, Point_$type, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, EnumUtil, runOn, delegateCombine } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { Brush } from "igniteui-angular-core";
import { TransformGroup } from "igniteui-angular-core";
import { TranslateTransform } from "igniteui-angular-core";
import { RotateTransform } from "igniteui-angular-core";
import { DoubleAnimator } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { ColumnSortDirection_$type } from "./ColumnSortDirection";
import { EasingFunctions } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { Geometry } from "igniteui-angular-core";
import { SortIndicatorRenderCompletedEventArgs } from "./SortIndicatorRenderCompletedEventArgs";
/**
 * @hidden
 */
var GridSortIndicatorView = /** @class */ (function (_super) {
    tslib_1.__extends(GridSortIndicatorView, _super);
    function GridSortIndicatorView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.d = new List$1(Path.$, 0);
        _this.i = 0;
        _this.h = 0;
        _this.b = 0;
        _this.m = null;
        _this.c = null;
        _this.l = null;
        _this.f = 0;
        _this.e = 0;
        _this.g = 1;
        _this.k = 0;
        _this.j = 0;
        _this.a = a;
        return _this;
    }
    GridSortIndicatorView.prototype.s = function () {
        if (this.m == null || this.c == null) {
            return;
        }
        if (this.i != this.k || this.h != this.j || this.b != this.a.f) {
            this.d.clear();
            switch (this.a.f) {
                case 0:
                    this.n();
                    break;
                case 1:
                    this.o();
                    break;
                case 2:
                    this.p();
                    break;
            }
            this.i = this.k;
            this.h = this.j;
            this.b = this.a.f;
        }
        switch (this.a.f) {
            case 0:
                this.u();
                break;
            case 1:
                this.v();
                break;
            case 2:
                this.w();
                break;
        }
        var a = Math.round(this.k * this.g);
        var b = Math.round(this.j * this.g);
        if (this.f != a || this.e != b) {
            this.m.setAttribute("width", a.toString());
            this.m.setAttribute("height", b.toString());
            this.m.setStyleProperty("width", this.k.toString() + "px");
            this.m.setStyleProperty("height", this.j.toString() + "px");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.f = truncate(Math.round(a));
            this.e = truncate(Math.round(b));
        }
        if (this.c.d && this.g != 1) {
            this.c.z();
            this.c.aa(this.g, this.g);
        }
        this.c.k(0, 0, this.k, this.j);
        this.c.z();
        this.c.aa(this.a.u(), this.a.u());
        for (var c = 0; c < this.d.count; c++) {
            this.c.j(this.d._inner[c].j);
            var d = this.x();
            if (this.a.ax != null) {
                d = this.a.ax;
            }
            this.d._inner[c]._stroke = d;
            this.c.s(this.d._inner[c]);
        }
        this.c.y();
        if (this.c.d && this.g != 1) {
            this.c.y();
        }
        this.a.aq();
    };
    GridSortIndicatorView.prototype.t = function () {
        this.s();
    };
    GridSortIndicatorView.prototype.n = function () {
        this.a.al(this.k, this.j, this.d);
    };
    GridSortIndicatorView.prototype.u = function () {
        var _this = this;
        if (this.d.count != 1) {
            return;
        }
        this.d._inner[0]._opacity = this.a.q;
        var a = { $type: Point_$type, x: this.k / 2, y: this.j / 2 };
        var b = new TransformGroup();
        b.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.j = -a.x;
            $ret.k = -a.y;
            return $ret;
        })()));
        b.j.add(((function () {
            var $ret = new RotateTransform();
            $ret.j = _this.a.p;
            return $ret;
        })()));
        b.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.j = a.x;
            $ret.k = a.y;
            return $ret;
        })()));
        this.d._inner[0].j = b;
    };
    GridSortIndicatorView.prototype.o = function () {
        this.a.am(this.k, this.j, this.d);
    };
    GridSortIndicatorView.prototype.v = function () {
        if (this.d.count != 4) {
            return;
        }
        this.d._inner[0]._opacity = this.a.q;
        this.d._inner[1]._opacity = this.a.q;
        this.d._inner[2]._opacity = this.a.w;
        this.d._inner[3]._opacity = this.a.w;
    };
    GridSortIndicatorView.prototype.p = function () {
        this.a.an(this.k, this.j, this.d);
    };
    GridSortIndicatorView.prototype.w = function () {
        this.d._inner[0]._opacity = this.a.q;
        this.d._inner[1]._opacity = this.a.w;
    };
    GridSortIndicatorView.prototype.q = function (a) {
        if (a == null) {
            this.m = null;
            this.l = null;
            this.c = null;
            return;
        }
        this.g = (isNaN_(this.a.v) ? this.a.o : this.a.v);
        var b = a;
        this.l = b;
        this.a.j.u(this.l);
        this.a.i.u(this.l);
        this.l.rootWrapper.addClass("ui-radialgauge-container");
        var c = this.g;
        var d = Math.round(b.rootWrapper.width());
        var e = Math.round(b.rootWrapper.height());
        var f = d * c;
        var g = e * c;
        this.l.rootWrapper.setStyleProperty("position", "relative");
        var h = this.l.createElement("canvas");
        h.setStyleProperty("position", "absolute");
        this.l.append(h);
        this.f = truncate(Math.round(f));
        this.e = truncate(Math.round(g));
        h.setAttribute("width", f.toString());
        h.setAttribute("height", g.toString());
        h.setStyleProperty("width", d.toString() + "px");
        h.setStyleProperty("height", e.toString() + "px");
        this.k = d;
        this.j = e;
        this.m = h;
        var i = this.l.get2DCanvasContext(this.m);
        this.c = new RenderingContext(new CanvasViewRenderer(), i);
        if (isNaN_(this.a.v)) {
            this.a.o = window.devicePixelRatio;
            this.g = this.a.o;
        }
        this.s();
    };
    GridSortIndicatorView.prototype.r = function (a, b) {
        if (isNaN_(this.a.v)) {
            this.a.o = window.devicePixelRatio;
            this.g = this.a.o;
        }
        this.k = a;
        this.j = b;
        this.s();
    };
    GridSortIndicatorView.prototype.x = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(138, 0, 0, 0);
            return $ret;
        })());
    };
    GridSortIndicatorView.$t = markType(GridSortIndicatorView, 'GridSortIndicatorView');
    return GridSortIndicatorView;
}(Base));
export { GridSortIndicatorView };
/**
 * @hidden
 */
var GridSortIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(GridSortIndicator, _super);
    function GridSortIndicator() {
        var _this = _super.call(this) || this;
        _this.aa = null;
        _this.a = 0;
        _this.aw = null;
        _this.k = true;
        _this.propertyChanged = null;
        _this.g = null;
        _this.h = null;
        _this.n = NaN;
        _this.m = 1;
        _this.e = 0;
        _this.q = 0;
        _this.p = 0;
        _this.w = 0;
        _this.s = 0;
        _this.r = 0;
        _this.y = 0;
        _this.x = 0;
        _this.t = 0;
        _this.z = 0;
        _this.c = null;
        _this.renderCompleted = null;
        _this.q = 0;
        _this.w = 0.5;
        _this.p = 180;
        _this.c = new GridSortIndicatorView(_this);
        _this.g = new DoubleAnimator(0, 1, 400);
        _this.h = new DoubleAnimator(0, 1, 400);
        _this.g.b = EasingFunctions.cubicEase;
        _this.h.b = EasingFunctions.cubicEase;
        var a = _this.g;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(_this, _this.aj));
        var b = _this.h;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(_this, _this.ak));
        return _this;
    }
    Object.defineProperty(GridSortIndicator.prototype, "ab", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            this.aa = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ap("SortDirection", enumGetBox(ColumnSortDirection_$type, b), enumGetBox(ColumnSortDirection_$type, this.a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "ax", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.ap("IconColor", b, this.aw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.ap("IsAnimationEnabled", b, this.k);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "i", {
        get: function () {
            return this.g;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "j", {
        get: function () {
            return this.h;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "v", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            this.ap("PixelScalingRatio", b, this.n);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "o", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            this.ap("ActualPixelScalingRatio", b, this.m);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridSortIndicator.prototype, "f", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ap("SortIndicatorStyle", enumGetBox(SortIndicatorStyle_$type, b), enumGetBox(SortIndicatorStyle_$type, this.e));
            }
        },
        enumerable: true,
        configurable: true
    });
    GridSortIndicator.prototype.ap = function (a, b, c) {
        this.at(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    GridSortIndicator.prototype.at = function (a, b, c) {
        switch (a) {
            case "PixelScalingRatio":
                this.o = this.v;
                break;
            case "ActualPixelScalingRatio":
                this.c.t();
                break;
            case "IconColor":
                this.c.t();
                break;
            case "SortIndicatorStyle":
                switch (this.f) {
                    case 0:
                        this.ar(this.b, false);
                        break;
                    case 1:
                    case 2:
                        this.as(this.b, false);
                        break;
                }
                break;
            case "SortDirection":
                switch (this.f) {
                    case 0:
                        this.ar(EnumUtil.getEnumValue(ColumnSortDirection_$type, c), this.l);
                        break;
                    case 1:
                    case 2:
                        this.as(EnumUtil.getEnumValue(ColumnSortDirection_$type, c), this.l);
                        break;
                }
                break;
        }
    };
    GridSortIndicator.prototype.ak = function (a, b) {
        switch (this.f) {
            case 0:
                this.q = this.s + this.h.o * (this.y - this.s);
                break;
            case 1:
            case 2:
                this.q = this.s + this.h.o * (this.y - this.s);
                this.w = this.t + this.h.o * (this.z - this.t);
                break;
        }
        this.c.t();
    };
    GridSortIndicator.prototype.aj = function (a, b) {
        this.p = this.r + this.g.o * (this.x - this.r);
        this.c.t();
    };
    GridSortIndicator.prototype.ar = function (a, b) {
        this.s = this.q;
        this.r = this.p;
        if (this.l || this.g.f() || this.h.f()) {
            this.g.w();
            this.h.w();
        }
        if (a == 0) {
            this.y = 0;
            this.x = 180;
        }
        else {
            this.y = 1;
            if (a == 1) {
                this.x = 180;
            }
            else {
                this.x = 0;
            }
        }
        if (b) {
            this.g.v();
            this.h.v();
        }
        else {
            this.p = this.x;
            this.q = this.y;
            this.c.t();
        }
    };
    GridSortIndicator.prototype.as = function (a, b) {
        this.s = this.q;
        this.t = this.w;
        if (this.l || this.h.f()) {
            this.h.w();
        }
        switch (a) {
            case 0:
                this.y = 0.4;
                this.z = 0.4;
                break;
            case 1:
                this.y = 1;
                this.z = 0.2;
                break;
            case 2:
                this.y = 0.2;
                this.z = 1;
                break;
        }
        if (b) {
            this.h.v();
        }
        else {
            this.q = this.y;
            this.w = this.z;
            this.c.t();
        }
    };
    GridSortIndicator.prototype.u = function () {
        switch (this.f) {
            case 0: return 1;
            case 1: return 0.71;
            case 2: return 1;
        }
        return 1;
    };
    GridSortIndicator.prototype.au = function (a) {
        this.c.q(a);
    };
    GridSortIndicator.prototype.av = function (a) {
        this.j.u(a);
        this.i.u(a);
    };
    GridSortIndicator.prototype.ac = function () {
        return this.c.m.getNativeElement();
    };
    GridSortIndicator.prototype.ao = function (a, b) {
        this.c.r(a, b);
    };
    GridSortIndicator.prototype.al = function (a, b, c) {
        var d = Math.min(a, b);
        var e = { $type: Point_$type, x: a / 2, y: b / 2 };
        var f = d * 0.8;
        var g = f / 2;
        var h = g / 2;
        var i = new PathFigure();
        i._startPoint = { $type: Point_$type, x: e.x, y: e.y - g };
        var j = new LineSegment(1);
        j.c = { $type: Point_$type, x: e.x, y: e.y + g };
        i._segments.add(j);
        var k = new PathFigure();
        k._startPoint = { $type: Point_$type, x: e.x - g, y: (e.y + g) - g };
        var l = new LineSegment(1);
        l.c = { $type: Point_$type, x: e.x, y: e.y + g };
        var m = new LineSegment(1);
        m.c = { $type: Point_$type, x: e.x + g, y: (e.y + g) - g };
        k._segments.add(l);
        k._segments.add(m);
        var n = new PathGeometry();
        n.c.add(i);
        n.c.add(k);
        var o = new Path();
        o.ak = n;
        o._stroke = this.c.x();
        o.ac = 1;
        c.add(o);
    };
    GridSortIndicator.prototype.am = function (a, b, c) {
        var _this = this;
        var d = Geometry.a("M3.792172, 7.800278 L7.983785, 3.635676 L12.148387, 7.800278L12.148387, 7.800278");
        var e = Geometry.a("M7.97027972,4.10930186 L7.97027972,13.8116223 L7.97027972,4.10930186 Z");
        var f = Geometry.a("M11.851613, 16.199722 L16.043224, 20.364325  L20.207829, 16.199722");
        var g = Geometry.a("M16.043224,10.1883777 L16.043224,19.8906981 L16.043224,10.1883777 Z");
        c.add(((function () {
            var $ret = new Path();
            $ret.ak = d;
            $ret.aj = 2;
            $ret.stroke = _this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((function () {
            var $ret = new Path();
            $ret.ak = e;
            $ret.aj = 2;
            $ret.stroke = _this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((function () {
            var $ret = new Path();
            $ret.ak = f;
            $ret.aj = 2;
            $ret.stroke = _this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((function () {
            var $ret = new Path();
            $ret.ak = g;
            $ret.aj = 2;
            $ret.stroke = _this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
    };
    GridSortIndicator.prototype.an = function (a, b, c) {
        var _this = this;
        var d = { $type: Point_$type, x: a / 2, y: b / 2 };
        var e = { $type: Point_$type, x: d.x - 3.5, y: d.y - 1.5 };
        var f = { $type: Point_$type, x: d.x - 3.5, y: d.y + 1.5 };
        var g = Geometry.a("M" + e.x.toString() + ", " + e.y.toString() + " l 3.5,-3.5 3.5,3.5");
        var h = Geometry.a("M" + f.x.toString() + ", " + f.y.toString() + " l 3.5,3.5 3.5,-3.5");
        c.add(((function () {
            var $ret = new Path();
            $ret.ak = g;
            $ret.aj = 2;
            $ret.stroke = _this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
        c.add(((function () {
            var $ret = new Path();
            $ret.ak = h;
            $ret.aj = 2;
            $ret.stroke = _this.c.x();
            $ret.ac = 2;
            return $ret;
        })()));
    };
    GridSortIndicator.prototype.aq = function () {
        if (this.renderCompleted != null) {
            this.renderCompleted(this, new SortIndicatorRenderCompletedEventArgs());
        }
    };
    GridSortIndicator.$t = markType(GridSortIndicator, 'GridSortIndicator', Base.$, [INotifyPropertyChanged_$type]);
    return GridSortIndicator;
}(Base));
export { GridSortIndicator };
//# sourceMappingURL=GridSortIndicatorView_combined.js.map