/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { GridCellBase } from "./GridCellBase";
import { Base, runOn, markType } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var ImageCell = /** @class */ (function (_super) {
    tslib_1.__extends(ImageCell, _super);
    function ImageCell(a) {
        var _this = _super.call(this, a) || this;
        _this.b3 = null;
        _this.bx = 1;
        _this.by = 3;
        _this.b5 = null;
        _this.bz = false;
        _this.b0 = 1;
        _this.b2 = null;
        _this.b3 = a.createElement("img");
        _this.b3.listen("load", runOn(_this, _this.b8));
        _this.b2 = a.createElement("div");
        _this.b2.setRawStyleProperty("background-size", "contain");
        _this.b2.setRawStyleProperty("background-repeat", "no-repeat");
        _this.b2.setRawStyleProperty("background-position", "center");
        _this.b2.setRawStyleProperty("width", "100%");
        _this.b2.setRawStyleProperty("height", "100%");
        _this.x.setRawStyleProperty("text-align", "left");
        _this.x.setRawStyleProperty("vertical-align", "middle");
        _this.x.append(_this.b2);
        return _this;
    }
    Object.defineProperty(ImageCell.prototype, "b4", {
        get: function () {
            return this.b3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ImageCell.prototype, "b1", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            this.b0 = a;
        },
        enumerable: true,
        configurable: true
    });
    ImageCell.prototype.b8 = function (a) {
        this.bz = false;
        if (!stringIsNullOrEmpty(this.b5)) {
            this.b2.setRawStyleProperty("opacity", "1");
            this.b2.setRawStyleProperty("background-image", "url(" + this.b5 + ")");
        }
    };
    ImageCell.prototype.b9 = function (a, b) {
        if (a == this.b5) {
            return;
        }
        this.b6();
        this.b2.setRawStyleProperty("opacity", "0");
        if (a == null || a.length == 0) {
            this.b7(this.b3);
            return;
        }
        if (Base.equalsStatic(a, this.b5)) {
            return;
        }
        this.cd(a, b);
        var img_ = this.b3.getNativeElement();
        if (img_ != null && (img_.complete)) {
            this.bz = false;
            this.b3.setRawStyleProperty("opacity", "1");
            this.b2.setRawStyleProperty("background-image", "url(" + this.b5 + ")");
        }
    };
    ImageCell.prototype.b7 = function (a) {
        a.setAttribute("src", "");
        this.b2.setRawStyleProperty("background-image", "");
    };
    ImageCell.prototype.cc = function (a) {
        switch (a) {
            case 1:
                this.b2.setRawStyleProperty("background-size", "100% 100%");
                break;
            case 2:
                this.b2.setRawStyleProperty("background-size", "auto");
                break;
            case 0:
                this.b2.setRawStyleProperty("background-size", "contain");
                break;
        }
    };
    ImageCell.prototype.cd = function (a, b) {
        this.bz = true;
        this.b5 = a;
        this.b4.setAttribute("src", a);
    };
    ImageCell.prototype.b6 = function () {
        if (this.bz) {
            this.b7(this.b3);
            this.b5 = "";
        }
    };
    ImageCell.prototype.ca = function (a) {
        this.bx = a;
    };
    ImageCell.prototype.cb = function (a) {
        this.by = a;
    };
    ImageCell.prototype.get_p = function () {
        return true;
    };
    ImageCell.prototype.a9 = function (a, b, c) {
        _super.prototype.a9.call(this, a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.b2.setRawStyleProperty("margin-left", this.ar + this.at + this.as + "px");
        }
    };
    ImageCell.$t = markType(ImageCell, 'ImageCell', GridCellBase.$);
    return ImageCell;
}(GridCellBase));
export { ImageCell };
//# sourceMappingURL=ImageCell.js.map