/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var SummaryCell = /** @class */ (function (_super) {
    tslib_1.__extends(SummaryCell, _super);
    function SummaryCell(a) {
        var _this = _super.call(this, a) || this;
        _this.bx = null;
        _this.by = null;
        _this.b2 = -1;
        _this.b1 = -1;
        _this.x.setRawStyleProperty("vertical-align", "middle");
        _this.bx = a.createElement("span");
        _this.bx.setRawStyleProperty("display", "inline-block");
        _this.bx.setRawStyleProperty("width", "50%");
        _this.bx.setRawStyleProperty("white-space", "nowrap");
        _this.bx.setRawStyleProperty("text-overflow", "ellipsis");
        _this.bx.setRawStyleProperty("vertical-align", "middle");
        _this.bx.setRawStyleProperty("overflow", "hidden");
        _this.x.append(_this.bx);
        _this.by = a.createElement("span");
        _this.by.setRawStyleProperty("display", "inline-block");
        _this.by.setRawStyleProperty("width", "50%");
        _this.by.setRawStyleProperty("text-align", "right");
        _this.by.setRawStyleProperty("white-space", "nowrap");
        _this.by.setRawStyleProperty("text-overflow", "ellipsis");
        _this.by.setRawStyleProperty("vertical-align", "middle");
        _this.by.setRawStyleProperty("overflow", "hidden");
        _this.x.append(_this.by);
        return _this;
    }
    Object.defineProperty(SummaryCell.prototype, "bz", {
        get: function () {
            return this.bx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SummaryCell.prototype, "b0", {
        get: function () {
            return this.by;
        },
        enumerable: true,
        configurable: true
    });
    SummaryCell.prototype.bn = function (a, b) {
        _super.prototype.bn.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.b2 != c) {
            this.b2 = c;
        }
    };
    SummaryCell.prototype.bi = function (a, b) {
        _super.prototype.bi.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.b1 != c) {
            this.b1 = c;
        }
    };
    SummaryCell.prototype.get_p = function () {
        return false;
    };
    SummaryCell.$t = markType(SummaryCell, 'SummaryCell', GridCellBase.$);
    return SummaryCell;
}(GridCellBase));
export { SummaryCell };
//# sourceMappingURL=SummaryCell.js.map