/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { GridCellBase } from "./GridCellBase";
import { GridSortIndicator } from "./GridSortIndicator";
import { runOn, delegateCombine, markType } from "igniteui-angular-core";
import { GridFilterDialog } from "./GridFilterDialog";
/**
 * @hidden
 */
var TextHeaderCell = /** @class */ (function (_super) {
    tslib_1.__extends(TextHeaderCell, _super);
    function TextHeaderCell(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.by = null;
        _this.bx = null;
        _this.b3 = null;
        _this.b6 = -1;
        _this.b5 = -1;
        _this.b2 = null;
        _this.b0 = false;
        _this.b1 = a.createElement("span");
        _this.x.setRawStyleProperty("text-align", "left");
        _this.x.setRawStyleProperty("vertical-align", "middle");
        _this.b1.setRawStyleProperty("display", "inline-block");
        _this.b1.setRawStyleProperty("line-height", "normal");
        _this.b1.setRawStyleProperty("vertical-align", "middle");
        _this.b1.setRawStyleProperty("overflow", "hidden");
        _this.b1.setRawStyleProperty("white-space", "nowrap");
        _this.b1.setRawStyleProperty("text-overflow", "ellipsis");
        _this.x.append(_this.b1);
        var b = a.createElement("div");
        b.setRawStyleProperty("display", "none");
        b.setRawStyleProperty("width", "15px");
        b.setRawStyleProperty("height", "15px");
        _this.b2 = b;
        var c = a.getSubRenderer(b);
        _this.bx = new GridFilterDialog();
        _this.bx.ao(c);
        _this.x.append(b);
        _this.bx.ai(15, 15);
        b = a.createElement("div");
        b.setRawStyleProperty("display", "inline-block");
        b.setRawStyleProperty("vertical-align", "middle");
        b.setRawStyleProperty("width", "16px");
        b.setRawStyleProperty("height", "16px");
        b.setRawStyleProperty("margin", "0 0 0 5px");
        _this.b3 = b;
        c = a.getSubRenderer(b);
        _this.by = new GridSortIndicator();
        _this.by.au(c);
        _this.x.append(b);
        _this.by.ao(16, 16);
        var d = _this.bx;
        d.dialogOpening = delegateCombine(d.dialogOpening, runOn(_this, _this.b7));
        var e = _this.bx;
        e.filterChanging = delegateCombine(e.filterChanging, runOn(_this, _this.b9));
        var f = _this.bx;
        f.filterChanged = delegateCombine(f.filterChanged, runOn(_this, _this.b8));
        return _this;
    }
    Object.defineProperty(TextHeaderCell.prototype, "b4", {
        get: function () {
            return this.b1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextHeaderCell.prototype, "bz", {
        get: function () {
            return this.by;
        },
        enumerable: true,
        configurable: true
    });
    TextHeaderCell.prototype.q = function (a) {
        return true;
    };
    TextHeaderCell.prototype.bn = function (a, b) {
        _super.prototype.bn.call(this, a, b);
        a -= 21;
        if (this.b0) {
            a -= 15;
        }
        var c = Math.max(0, a - b);
        if (c != this.b6) {
            this.b6 = c;
            this.b1.setRawStyleProperty("max-width", c.toString() + "px");
        }
    };
    TextHeaderCell.prototype.bi = function (a, b) {
        _super.prototype.bi.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.b5 != c) {
            this.b5 = c;
            this.b1.setRawStyleProperty("max-height", c.toString() + "px");
        }
    };
    TextHeaderCell.prototype.b8 = function (a, b) {
        this.b.columnFilterChanged(b.a);
    };
    TextHeaderCell.prototype.b9 = function (a, b) {
        this.b.columnFilterChanging(b.a);
    };
    TextHeaderCell.prototype.b7 = function (a, b) {
        if (this.b != null) {
            b.a = this.b.getColumnFilterCondition();
            b.b = this.b.getColumnPropertyType();
        }
    };
    TextHeaderCell.prototype.a8 = function (a, b, c) {
        _super.prototype.a8.call(this, a, b, c);
        if (c == 2) {
            this.x.removeChild(this.b3);
            this.x.removeChild(this.b2);
            this.b1.before(this.b2);
            this.b2.before(this.b3);
            this.b3.setRawStyleProperty("margin", "0 5px 0 0");
        }
        else {
            this.x.removeChild(this.b3);
            this.x.removeChild(this.b1);
            this.b2.before(this.b1);
            this.b2.before(this.b3);
            this.b3.setRawStyleProperty("margin", "0 0 0 5px");
        }
    };
    TextHeaderCell.prototype.get_o = function () {
        return true;
    };
    TextHeaderCell.$t = markType(TextHeaderCell, 'TextHeaderCell', GridCellBase.$);
    return TextHeaderCell;
}(GridCellBase));
export { TextHeaderCell };
//# sourceMappingURL=TextHeaderCell.js.map