import { ColumnExchanger as ColumnExchanger_internal } from "./ColumnExchanger";
/**
 * Indicates a column that should be exchanged with another.
*/
var IgxColumnExchanger = /** @class */ (function () {
    function IgxColumnExchanger() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxColumnExchanger.prototype.createImplementation = function () {
        return new ColumnExchanger_internal(0);
    };
    Object.defineProperty(IgxColumnExchanger.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxColumnExchanger.prototype.onImplementationCreated = function () {
    };
    IgxColumnExchanger.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxColumnExchanger.prototype, "targetIndex", {
        /**
         * The desired location of the new column
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxColumnExchanger;
}());
export { IgxColumnExchanger };
//# sourceMappingURL=igx-column-exchanger.js.map