import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ColumnExchanger as ColumnExchanger_internal } from './ColumnExchanger';
import { IgxColumnExchanger as IgxColumnExchanger } from './igx-column-exchanger';
var IgxColumnExchangersCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxColumnExchangersCollection, _super);
    function IgxColumnExchangersCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxColumnExchanger.$type) {
            IgxColumnExchanger.$type = markType(IgxColumnExchanger, "IgxColumnExchanger");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxColumnExchangersCollection.prototype._createInnerColl = function () {
        if (!IgxColumnExchanger.$type) {
            IgxColumnExchanger.$type = markType(IgxColumnExchanger, "IgxColumnExchanger");
        }
        var coll = new SyncableObservableCollection$2(IgxColumnExchanger.$type, ColumnExchanger_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxColumnExchanger();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxColumnExchangersCollection;
}(IgCollection));
export { IgxColumnExchangersCollection };
//# sourceMappingURL=igx-column-exchangers-collection.js.map