import { GridCellPosition as GridCellPosition_internal } from "./GridCellPosition";
var IgxGridCellPosition = /** @class */ (function () {
    function IgxGridCellPosition() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridCellPosition.prototype.createImplementation = function () {
        return new GridCellPosition_internal();
    };
    Object.defineProperty(IgxGridCellPosition.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridCellPosition.prototype.onImplementationCreated = function () {
    };
    IgxGridCellPosition.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridCellPosition.prototype, "rowIndex", {
        /**
         * Gets or sets the row position of the cell.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellPosition.prototype, "columnUniqueKey", {
        /**
         * Gets or sets the column position of the cell.  Can be null for spanning elements like section headers.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGridCellPosition;
}());
export { IgxGridCellPosition };
//# sourceMappingURL=igx-grid-cell-position.js.map