import { GridColumnAnimationSettings as GridColumnAnimationSettings_internal } from "./GridColumnAnimationSettings";
/**
 * Column animation settings for the grid.
*/
var IgxGridColumnAnimationSettings = /** @class */ (function () {
    function IgxGridColumnAnimationSettings() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridColumnAnimationSettings.prototype.createImplementation = function () {
        return new GridColumnAnimationSettings_internal();
    };
    Object.defineProperty(IgxGridColumnAnimationSettings.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridColumnAnimationSettings.prototype.onImplementationCreated = function () {
    };
    IgxGridColumnAnimationSettings.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    IgxGridColumnAnimationSettings.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    return IgxGridColumnAnimationSettings;
}());
export { IgxGridColumnAnimationSettings };
//# sourceMappingURL=igx-grid-column-animation-settings.js.map