import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { Column as Column_internal } from './Column';
import { IgxColumnComponent as IgxColumnComponent } from './igx-column-component';
var IgxGridColumnCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxGridColumnCollection, _super);
    function IgxGridColumnCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxColumnComponent.$type) {
            IgxColumnComponent.$type = markType(IgxColumnComponent, "IgxColumnComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxGridColumnCollection.prototype._createInnerColl = function () {
        if (!IgxColumnComponent.$type) {
            IgxColumnComponent.$type = markType(IgxColumnComponent, "IgxColumnComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxColumnComponent.$type, Column_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgxColumnComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxGridColumnCollection;
}(IgCollection));
export { IgxGridColumnCollection };
//# sourceMappingURL=igx-grid-column-collection.js.map