import { GridFilterDialogViewModelRow as GridFilterDialogViewModelRow_internal } from "./GridFilterDialogViewModelRow";
var IgxGridFilterDialogViewModelRow = /** @class */ (function () {
    function IgxGridFilterDialogViewModelRow() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridFilterDialogViewModelRow.prototype.createImplementation = function () {
        return new GridFilterDialogViewModelRow_internal();
    };
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridFilterDialogViewModelRow.prototype.onImplementationCreated = function () {
    };
    IgxGridFilterDialogViewModelRow.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "operatorTypes", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "operators", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "currentOperator", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "operandNumber", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "operand1", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridFilterDialogViewModelRow.prototype, "operand2", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridFilterDialogViewModelRow.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    return IgxGridFilterDialogViewModelRow;
}());
export { IgxGridFilterDialogViewModelRow };
//# sourceMappingURL=igx-grid-filter-dialog-view-model-row.js.map