import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { CellRange as CellRange_internal } from './CellRange';
import { IgxCellRange as IgxCellRange } from './igx-cell-range';
var IgxGridSelectedCellRangesCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxGridSelectedCellRangesCollection, _super);
    function IgxGridSelectedCellRangesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxCellRange.$type) {
            IgxCellRange.$type = markType(IgxCellRange, "IgxCellRange");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxGridSelectedCellRangesCollection.prototype._createInnerColl = function () {
        if (!IgxCellRange.$type) {
            IgxCellRange.$type = markType(IgxCellRange, "IgxCellRange");
        }
        var coll = new SyncableObservableCollection$2(IgxCellRange.$type, CellRange_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxCellRange();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxGridSelectedCellRangesCollection;
}(IgCollection));
export { IgxGridSelectedCellRangesCollection };
//# sourceMappingURL=igx-grid-selected-cell-ranges-collection.js.map