import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { CellKey as CellKey_internal } from './CellKey';
import { IgxCellKey as IgxCellKey } from './igx-cell-key';
var IgxGridSelectedCellsCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxGridSelectedCellsCollection, _super);
    function IgxGridSelectedCellsCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxCellKey.$type) {
            IgxCellKey.$type = markType(IgxCellKey, "IgxCellKey");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxGridSelectedCellsCollection.prototype._createInnerColl = function () {
        if (!IgxCellKey.$type) {
            IgxCellKey.$type = markType(IgxCellKey, "IgxCellKey");
        }
        var coll = new SyncableObservableCollection$2(IgxCellKey.$type, CellKey_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxCellKey();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxGridSelectedCellsCollection;
}(IgCollection));
export { IgxGridSelectedCellsCollection };
//# sourceMappingURL=igx-grid-selected-cells-collection.js.map