/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { IgxTextHeaderDynamicModule } from './igx-text-header-dynamic-module';
import { IgxSectionHeaderDynamicModule } from './igx-section-header-dynamic-module';
import { IgxRowSeparatorDynamicModule } from './igx-row-separator-dynamic-module';
import { IgxHeaderSeparatorDynamicModule } from './igx-header-separator-dynamic-module';
import { IgxColumnResizingSeparatorDynamicModule } from './igx-column-resizing-separator-dynamic-module';
import { IgxColumnMovingSeparatorDynamicModule } from './igx-column-moving-separator-dynamic-module';
import { IgxLiveGridComponent } from './igx-live-grid-component';
import { TypeRegistrar } from "igniteui-angular-core";
import { IgxLiveGridCoreModule } from './igx-live-grid-core-module';
var IgxLiveGridCoreDynamicModule = /** @class */ (function () {
    function IgxLiveGridCoreDynamicModule() {
        TypeRegistrar.registerCons('IgxLiveGridComponent', IgxLiveGridComponent);
    }
    IgxLiveGridCoreDynamicModule = tslib_1.__decorate([
        NgModule({
            declarations: [],
            exports: [IgxTextHeaderDynamicModule,
                IgxSectionHeaderDynamicModule,
                IgxRowSeparatorDynamicModule,
                IgxHeaderSeparatorDynamicModule,
                IgxColumnResizingSeparatorDynamicModule,
                IgxColumnMovingSeparatorDynamicModule,
                IgxLiveGridCoreModule
            ],
            imports: [CommonModule, IgxTextHeaderDynamicModule,
                IgxSectionHeaderDynamicModule,
                IgxRowSeparatorDynamicModule,
                IgxHeaderSeparatorDynamicModule,
                IgxColumnResizingSeparatorDynamicModule,
                IgxColumnMovingSeparatorDynamicModule,
                IgxLiveGridCoreModule
            ],
            entryComponents: [IgxLiveGridComponent]
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLiveGridCoreDynamicModule);
    return IgxLiveGridCoreDynamicModule;
}());
export { IgxLiveGridCoreDynamicModule };
//# sourceMappingURL=igx-live-grid-core-dynamic-module.js.map