import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { RowSeparator } from "./RowSeparator";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
export var IgxRowSeparatorComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxRowSeparatorComponent; }) }];
var IgxRowSeparatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxRowSeparatorComponent, _super);
    function IgxRowSeparatorComponent() {
        return _super.call(this) || this;
    }
    IgxRowSeparatorComponent_1 = IgxRowSeparatorComponent;
    IgxRowSeparatorComponent.prototype.createImplementation = function () {
        return new RowSeparator();
    };
    Object.defineProperty(IgxRowSeparatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    var IgxRowSeparatorComponent_1;
    IgxRowSeparatorComponent = IgxRowSeparatorComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-row-separator',
            template: "",
            providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxRowSeparatorComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxRowSeparatorComponent);
    return IgxRowSeparatorComponent;
}(IgxDefinitionBaseComponent));
export { IgxRowSeparatorComponent };
//# sourceMappingURL=igx-row-separator-component.js.map