import { SummaryData as SummaryData_internal } from "./SummaryData";
/**
 * Object used to store summary information for group headers.
*/
var IgxSummaryData = /** @class */ (function () {
    function IgxSummaryData() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxSummaryData.prototype.createImplementation = function () {
        return new SummaryData_internal();
    };
    Object.defineProperty(IgxSummaryData.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxSummaryData.prototype.onImplementationCreated = function () {
    };
    IgxSummaryData.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxSummaryData.prototype, "summaryName", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryData.prototype, "summaryValue", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryData.prototype, "summaryOperand", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryData.prototype, "formattedText", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSummaryData.prototype, "formattedValue", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxSummaryData;
}());
export { IgxSummaryData };
//# sourceMappingURL=igx-summary-data.js.map