import * as tslib_1 from "tslib";
import { IgxCellInfo } from "./igx-cell-info";
import { TemplateCellModel as TemplateCellModel_internal } from "./TemplateCellModel";
/**
 * Represents backing information for a template cell.
*/
var IgxTemplateCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTemplateCellInfo, _super);
    function IgxTemplateCellInfo() {
        return _super.call(this) || this;
    }
    IgxTemplateCellInfo.prototype.createImplementation = function () {
        return new TemplateCellModel_internal();
    };
    Object.defineProperty(IgxTemplateCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTemplateCellInfo.prototype, "value", {
        /**
         * Sets or gets the value to provide to the template.
        */
        get: function () {
            return this.i.ij;
        },
        set: function (v) {
            this.i.ij = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxTemplateCellInfo;
}(IgxCellInfo));
export { IgxTemplateCellInfo };
//# sourceMappingURL=igx-template-cell-info.js.map