import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TextColumn } from "./TextColumn";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export var IgxTextColumnComponent_PROVIDERS = [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxTextColumnComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTextColumnComponent; }) }];
var IgxTextColumnComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTextColumnComponent, _super);
    function IgxTextColumnComponent() {
        return _super.call(this) || this;
    }
    IgxTextColumnComponent_1 = IgxTextColumnComponent;
    IgxTextColumnComponent.prototype.createImplementation = function () {
        return new TextColumn();
    };
    Object.defineProperty(IgxTextColumnComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    var IgxTextColumnComponent_1;
    IgxTextColumnComponent = IgxTextColumnComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-text-column',
            template: "",
            providers: [{ provide: IgxColumnComponent, useExisting: forwardRef(function () { return IgxTextColumnComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTextColumnComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTextColumnComponent);
    return IgxTextColumnComponent;
}(IgxColumnComponent));
export { IgxTextColumnComponent };
//# sourceMappingURL=igx-text-column-component.js.map