import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxHeaderComponent } from "./igx-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TextHeader } from "./TextHeader";
/**
 * Represents a class used to configure the appearance of a text column header cells.
*/
export var IgxTextHeaderComponent_PROVIDERS = [{ provide: IgxHeaderComponent, useExisting: forwardRef(function () { return IgxTextHeaderComponent; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTextHeaderComponent; }) }];
var IgxTextHeaderComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTextHeaderComponent, _super);
    function IgxTextHeaderComponent() {
        return _super.call(this) || this;
    }
    IgxTextHeaderComponent_1 = IgxTextHeaderComponent;
    IgxTextHeaderComponent.prototype.createImplementation = function () {
        return new TextHeader();
    };
    Object.defineProperty(IgxTextHeaderComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    var IgxTextHeaderComponent_1;
    IgxTextHeaderComponent = IgxTextHeaderComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-text-header',
            template: "",
            providers: [{ provide: IgxHeaderComponent, useExisting: forwardRef(function () { return IgxTextHeaderComponent_1; }) }, { provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxTextHeaderComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxTextHeaderComponent);
    return IgxTextHeaderComponent;
}(IgxHeaderComponent));
export { IgxTextHeaderComponent };
//# sourceMappingURL=igx-text-header-component.js.map