import * as tslib_1 from "tslib";
import { IgxCellInfo } from "./igx-cell-info";
import { VerticalSeparatorCellModel as VerticalSeparatorCellModel_internal } from "./VerticalSeparatorCellModel";
import { ensureBool } from "igniteui-angular-core";
/**
 * Represents backing information for vertical separators.
*/
var IgxVerticalSeparatorCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxVerticalSeparatorCellInfo, _super);
    function IgxVerticalSeparatorCellInfo() {
        return _super.call(this) || this;
    }
    IgxVerticalSeparatorCellInfo.prototype.createImplementation = function () {
        return new VerticalSeparatorCellModel_internal();
    };
    Object.defineProperty(IgxVerticalSeparatorCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxVerticalSeparatorCellInfo.prototype, "isHitTestVisible", {
        /**
         * Gets or sets whether the vertical separator is hit test visible.
        */
        get: function () {
            return this.i.ii;
        },
        set: function (v) {
            this.i.ii = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxVerticalSeparatorCellInfo;
}(IgxCellInfo));
export { IgxVerticalSeparatorCellInfo };
//# sourceMappingURL=igx-vertical-separator-cell-info.js.map