import { Base, Type } from "igniteui-angular-core";
import { ICellRenderingEngine } from "./ICellRenderingEngine";
import { DomWrapper, DomRenderer } from "igniteui-angular-core";
import { DataGridPresenterManager } from "./DataGridPresenterManager";
import { VisualModel } from "./VisualModel";
import { CellModel } from "./CellModel";
/**
 * @hidden
 */
export declare class DataGridCellLayoutPanel extends Base implements ICellRenderingEngine {
    static $t: Type;
    private e;
    private k;
    private q;
    private _element;
    element: DomWrapper;
    private f;
    private i;
    constructor(a: DomRenderer, b: DataGridPresenterManager, c: number);
    refresh(a: VisualModel, b: boolean): void;
    viewportChanged(): void;
    private m;
    private g;
    invalidateVisibility(a: () => void): void;
    readonly initialRefreshFinished: boolean;
    z(a: number, b: number, c: number, d: number): void;
    ag(a: CellModel): void;
    private l;
    ah(a: boolean): void;
    private _requestAnimationFrame;
    private requestAnimationFrame;
    protected v(a: () => void): void;
    private s;
    private o;
    private n;
    private t;
    private j;
    private u;
    private w;
    private y;
    private x;
    private ad;
    private ae;
    private af;
    private ai;
    private ac;
    private aj;
    private ab;
    private ak;
    private aa;
    p: number;
    private c;
    private a;
    private d;
    private b;
    private al;
}
