import { Base, Type } from "igniteui-angular-core";
import { IExternalGrid } from "./IExternalGrid";
import { DomRenderer } from "igniteui-angular-core";
import { IDataSource } from "igniteui-angular-core";
import { TextColumn } from "./TextColumn";
import { NumericColumn } from "./NumericColumn";
import { DateTimeColumn } from "./DateTimeColumn";
import { ImageColumn } from "./ImageColumn";
import { TemplateColumn } from "./TemplateColumn";
/**
 * @hidden
 */
export declare class GridExternalWrapper extends Base implements IExternalGrid {
    static $t: Type;
    private a;
    constructor(a: any);
    readonly renderer: DomRenderer;
    onContentSizeChanged(): void;
    createLocalDataSource(a: any): IDataSource;
    createTextColumn(a: string): TextColumn;
    createNumericColumn(a: string): NumericColumn;
    createDateTimeColumn(a: string): DateTimeColumn;
    createImageColumn(a: string): ImageColumn;
    createTemplateColumn(a: string): TemplateColumn;
    focusScroller(): void;
    insertExternalColumnAtIndex(index_: number, column_: any): void;
    removeExternalColumn(column_: any): void;
    setDefaultCursor(): void;
    setResizeCursor(): void;
    setHandCursor(): void;
    ensureColumnsAreManual(): void;
}
