import { CellStyleRequestedEventArgs as CellStyleRequestedEventArgs_internal } from "./CellStyleRequestedEventArgs";
/**
 * Information about the style request for a cell.
*/
export declare class IgxCellStyleRequestedEventArgs {
    protected createImplementation(): CellStyleRequestedEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: CellStyleRequestedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The proposed style key for the cell. Used for recycling the cell.
    */
    styleKey: string;
    /**
     * The resolved value for the cell.
    */
    resolvedValue: any;
    /**
     * The row number for the cell.
    */
    rowNumber: number;
}
