import { ColumnExchanger as ColumnExchanger_internal } from "./ColumnExchanger";
/**
 * Indicates a column that should be exchanged with another.
*/
export declare class IgxColumnExchanger {
    protected createImplementation(): ColumnExchanger_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ColumnExchanger_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The desired location of the new column
    */
    targetIndex: number;
}
