import { Type } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
export declare const IgxColumnMovingSeparatorComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxColumnMovingSeparatorComponent extends IgxDefinitionBaseComponent {
    protected createImplementation(): ColumnMovingSeparator;
    /**
                                 * @hidden
                                 */
    readonly i: ColumnMovingSeparator;
    constructor();
    /**
     * Gets or sets the separator width for this column.
    */
    separatorWidth: number;
}
