import { Type } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ColumnResizingSeparator } from "./ColumnResizingSeparator";
export declare const IgxColumnResizingSeparatorComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxColumnResizingSeparatorComponent extends IgxDefinitionBaseComponent {
    protected createImplementation(): ColumnResizingSeparator;
    /**
                                 * @hidden
                                 */
    readonly i: ColumnResizingSeparator;
    constructor();
    /**
     * Gets or sets the separator width for this column.
    */
    separatorWidth: number;
}
