import { FormatGroupTextEventArgs as FormatGroupTextEventArgs_internal } from "./FormatGroupTextEventArgs";
export declare class IgxFormatGroupTextEventArgs {
    protected createImplementation(): FormatGroupTextEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: FormatGroupTextEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the group name.
    */
    groupName: string;
    /**
     * Gets the original value before formatting.
    */
    groupValue: any;
    /**
     * Gets the group value as text, formatted based on the GroupDescription's ValueFormat.
    */
    formattedValue: string;
    /**
     * Gets or sets the final text that will be displayed in the group header.
    */
    formattedText: string;
}
