import { FormatSummaryTextEventArgs as FormatSummaryTextEventArgs_internal } from "./FormatSummaryTextEventArgs";
export declare class IgxFormatSummaryTextEventArgs {
    protected createImplementation(): FormatSummaryTextEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: FormatSummaryTextEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the summary property name.
    */
    propertyPath: string;
    /**
     * Gets the summary display name.
    */
    displayName: string;
    /**
     * Gets the original value before formatting.
    */
    summaryResult: any;
    /**
     * Gets or sets the summary value as formatted text.  Setting this property will only affect summary cells.
    */
    formattedResult: string;
    /**
     * Gets or sets the final text that will be displayed in the group header.
    */
    formattedText: string;
}
