import { IgxGridCellPosition } from "./igx-grid-cell-position";
import { GridActiveCellChangedEventArgs as GridActiveCellChangedEventArgs_internal } from "./GridActiveCellChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
export declare class IgxGridActiveCellChangedEventArgs {
    protected createImplementation(): GridActiveCellChangedEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridActiveCellChangedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new active cell.
    */
    newActiveCell: IgxGridCellPosition;
    /**
     * The old active cell.
    */
    oldActiveCell: IgxGridCellPosition;
}
