import { GridCellPosition as GridCellPosition_internal } from "./GridCellPosition";
export declare class IgxGridCellPosition {
    protected createImplementation(): GridCellPosition_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridCellPosition_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the row position of the cell.
    */
    rowIndex: number;
    /**
     * Gets or sets the column position of the cell.  Can be null for spanning elements like section headers.
    */
    columnUniqueKey: string;
}
