import { DataSourceSchemaPropertyType } from "igniteui-angular-core";
import { IgxGridFilterDialogViewModelGroupingLevelCollection } from "./igx-grid-filter-dialog-view-model-grouping-level-collection";
import { IgxGridFilterDialogViewModelRowCollection } from "./igx-grid-filter-dialog-view-model-row-collection";
import { GridFilterDialogViewModel as GridFilterDialogViewModel_internal } from "./GridFilterDialogViewModel";
export declare class IgxGridFilterDialogViewModel {
    protected createImplementation(): GridFilterDialogViewModel_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridFilterDialogViewModel_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    propertyType: DataSourceSchemaPropertyType;
    private _groupingLevels;
    groupingLevels: IgxGridFilterDialogViewModelGroupingLevelCollection;
    isTopLevelOr: boolean;
    maxGroupingLevels: number;
    private _rows;
    rows: IgxGridFilterDialogViewModelRowCollection;
    addNewRow(): void;
    canGroupRange(startIndex: number, endIndex: number): boolean;
    ungroupRange(startIndex: number, endIndex: number): void;
    targetingRange(startIndex: number, endIndex: number): boolean;
    toggleRange(startIndex: number, endIndex: number): void;
    groupRange(startIndex: number, endIndex: number, isOrGrouping: boolean): void;
}
