import { IgxGridSelectedCellsCollection } from "./igx-grid-selected-cells-collection";
import { GridSelectedCellsChangedEventArgs as GridSelectedCellsChangedEventArgs_internal } from "./GridSelectedCellsChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
export declare class IgxGridSelectedCellsChangedEventArgs {
    protected createImplementation(): GridSelectedCellsChangedEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridSelectedCellsChangedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    private _addedCells;
    /**
     * The cells added to the selection.
    */
    addedCells: IgxGridSelectedCellsCollection;
    private _removedCells;
    /**
     * The cells removed from the selection.
    */
    removedCells: IgxGridSelectedCellsCollection;
}
