import { PrimaryKeyValue as PrimaryKeyValue_internal } from "./PrimaryKeyValue";
/**
 * A primary key value.
*/
export declare class IgxPrimaryKeyValue {
    protected _implementation: any;
    readonly i: PrimaryKeyValue_internal;
    private onImplementationCreated;
    constructor(primaryKey?: string[], primaryKeyValue?: object[]);
    protected _provideImplementation(i: any): void;
    static createIdentityKey(item: any): IgxPrimaryKeyValue;
    /**
 * The primary key associated with this value.
*/
    readonly key: string[];
    /**
     * The value of the keys for this primary key value.
    */
    readonly value: any[];
    /**
 * Determines if two primary key values are equal.

* @param other  * The other key value to check against.
*/
    equals(other: any): boolean;
}
