import { Type } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { RowSeparator } from "./RowSeparator";
/**
 * Represents a Row separator, this is used to visually separate the rows in a grid
*/
export declare const IgxRowSeparatorComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxRowSeparatorComponent extends IgxDefinitionBaseComponent {
    protected createImplementation(): RowSeparator;
    /**
                                 * @hidden
                                 */
    readonly i: RowSeparator;
    constructor();
}
