import { Type } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { SummaryRow } from "./SummaryRow";
export declare const IgxSummaryRowComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare abstract class IgxSummaryRowComponent extends IgxDefinitionBaseComponent {
    /**
                                 * @hidden
                                 */
    readonly i: SummaryRow;
    constructor();
    selectedBackground: string;
    actualSelectedBackground: string;
    summaryNameTextColor: string;
    actualSummaryNameTextColor: string;
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    paddingLeft: number;
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    paddingTop: number;
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    paddingRight: number;
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    paddingBottom: number;
}
