import { IgxTemplateCellInfo } from "./igx-template-cell-info";
import { TemplateHeaderCellModel as TemplateHeaderCellModel_internal } from "./TemplateHeaderCellModel";
/**
 * Backing information for the template header cells.
*/
export declare class IgxTemplateHeaderCellInfo extends IgxTemplateCellInfo {
    protected createImplementation(): TemplateHeaderCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: TemplateHeaderCellModel_internal;
    constructor();
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    isFilterUIVisible: boolean;
}
