import { IgxCellInfo } from './igx-cell-info';
import { TemplateHeaderCellUpdatingEventArgs as TemplateHeaderCellUpdatingEventArgs_internal } from "./TemplateHeaderCellUpdatingEventArgs";
/**
 * Information about the header cell that has content which is being created or updated.
*/
export declare class IgxTemplateHeaderCellUpdatingEventArgs {
    protected createImplementation(): TemplateHeaderCellUpdatingEventArgs_internal;
    protected _implementation: any;
    readonly i: TemplateHeaderCellUpdatingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    readonly isCanvasBased: boolean;
    /**
     * The host in which to add or update content if this is a DOM based cell.
    */
    readonly content: Element;
    readonly context: CanvasRenderingContext2D;
    ensureCorrectSize(): boolean;
    renderStandardBackground(): void;
    renderStandardContent(): void;
    /**
     * The backing information for the current cell.
    */
    readonly cellInfo: IgxCellInfo;
}
