import { IgxCellInfo } from './igx-cell-info';
import { TemplateSectionHeaderCellUpdatingEventArgs as TemplateSectionHeaderCellUpdatingEventArgs_internal } from "./TemplateSectionHeaderCellUpdatingEventArgs";
/**
 * Information about the cell that has content which is being created or updated.
*/
export declare class IgxTemplateSectionHeaderCellUpdatingEventArgs {
    protected createImplementation(): TemplateSectionHeaderCellUpdatingEventArgs_internal;
    protected _implementation: any;
    readonly i: TemplateSectionHeaderCellUpdatingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The host in which to add or update content.
    */
    readonly content: Element;
    /**
     * The backing information for the current cell.
    */
    readonly cellInfo: IgxCellInfo;
}
