import { IgxCellInfo } from "./igx-cell-info";
import { TextCellModel as TextCellModel_internal } from "./TextCellModel";
/**
 * Backing information for a text cell in the grid.
*/
export declare class IgxTextCellInfo extends IgxCellInfo {
    protected createImplementation(): TextCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: TextCellModel_internal;
    constructor();
    /**
     * Sets or gets the text value for the cell.
    */
    textValue: string;
}
