import { Type } from '@angular/core';
import { IgxColumnComponent } from "./igx-column-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TextColumn } from "./TextColumn";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export declare const IgxTextColumnComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTextColumnComponent extends IgxColumnComponent {
    protected createImplementation(): TextColumn;
    /**
                                 * @hidden
                                 */
    readonly i: TextColumn;
    constructor();
}
