/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { MinSummaryCalculator } from "igniteui-angular-core";
import { MaxSummaryCalculator } from "igniteui-angular-core";
import { SumSummaryCalculator } from "igniteui-angular-core";
import { AverageSummaryCalculator } from "igniteui-angular-core";
import { CountSummaryCalculator } from "igniteui-angular-core";
import { FormatSummaryTextEventArgs } from "./FormatSummaryTextEventArgs";
/**
 * @hidden
 */
export class ColumnSummaryDescription extends Base {
    constructor(a, ..._rest) {
        super();
        this.i = false;
        this.a = 0;
        this.q = null;
        this.d = 0;
        this.b = null;
        this.o = null;
        this.p = null;
        this.m = null;
        this.j = 10;
        this.formatText = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0: break;
            case 1:
                {
                    let c = _rest[0];
                    this.t = c;
                    this.e = 4;
                }
                break;
            case 2:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    this.t = c;
                    this.e = d;
                }
                break;
        }
    }
    get t() {
        return this.q;
    }
    set t(a) {
        this.q = a;
    }
    get e() {
        return this.d;
    }
    set e(a) {
        this.d = a;
        switch (this.d) {
            case 0:
                this.c = new MinSummaryCalculator();
                break;
            case 1:
                this.c = new MaxSummaryCalculator();
                break;
            case 2:
                this.c = new SumSummaryCalculator();
                break;
            case 3:
                this.c = new AverageSummaryCalculator();
                break;
            case 4:
                this.c = new CountSummaryCalculator();
                break;
        }
    }
    get c() {
        return this.b;
    }
    set c(a) {
        this.b = a;
    }
    get r() {
        return this.o;
    }
    set r(a) {
        this.o = a;
    }
    get s() {
        return this.p;
    }
    set s(a) {
        this.p = a;
    }
    get n() {
        return this.m;
    }
    set n(a) {
        this.m = a;
    }
    get l() {
        return this.j;
    }
    set l(a) {
        this.j = a;
    }
    equals(a) {
        let b = a;
        if (b == null) {
            return super.equals(a);
        }
        return b.t == this.t && b.e == this.e;
    }
    getHashCode() {
        return Base.getHashCodeStatic(this.t) * 17 + this.e;
    }
    f(a, b, c) {
        let d = ((() => {
            let $ret = new FormatSummaryTextEventArgs();
            $ret.e = this.t;
            $ret.b = this.s;
            $ret.a = a;
            $ret.c = b;
            $ret.d = c;
            return $ret;
        })());
        if (this.formatText != null) {
            this.formatText(this, d);
        }
        return d;
    }
}
ColumnSummaryDescription.$t = markType(ColumnSummaryDescription, 'ColumnSummaryDescription');
//# sourceMappingURL=ColumnSummaryDescription.js.map