/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { CellModel } from "./CellModel";
import { FontUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ContentCellModelHelper extends Base {
    static e(a) {
        if (a == null) {
            return ContentCellModelHelper.d;
        }
        return a.color;
    }
    static b(a, b, c) {
        switch (c) {
            case 0:
                a.setRawStyleProperty("text-align", "left");
                break;
            case 1:
                a.setRawStyleProperty("text-align", "center");
                break;
            case 2:
                a.setRawStyleProperty("text-align", "right");
                break;
            case 3:
                a.setRawStyleProperty("text-align", "center");
                break;
        }
    }
    static c(a, b, c) {
        switch (c) {
            case 0:
                b.setRawStyleProperty("vertical-align", "top");
                break;
            case 1:
                b.setRawStyleProperty("vertical-align", "center");
                break;
            case 2:
                b.setRawStyleProperty("vertical-align", "bottom");
                break;
            case 3:
                b.setRawStyleProperty("vertical-align", "center");
                break;
        }
    }
    static a(a, b, c, d, e) {
        if (b.ah) {
            if (b.al(CellModel.dp) || b.al(CellModel.e1)) {
                let f = Math.min(1, Math.max(0, b.bq));
                let g = b.bi * (1 - f);
                d.setRawStyleProperty("opacity", g.toString());
                if (b.ap) {
                    e.bv(b.bi * f);
                }
            }
            if (b.al(CellModel.ex)) {
                let h = ContentCellModelHelper.e((b).ig);
                d.setRawStyleProperty("color", h.colorString);
                if (b.ap) {
                    e.bs(b.ig);
                }
            }
            if (b.al(CellModel.d7)) {
                switch (b.v) {
                    case 0:
                        d.setRawStyleProperty("white-space", "nowrap");
                        d.setRawStyleProperty("text-overflow", "ellipsis");
                        break;
                    case 3:
                    case 2:
                        d.setRawStyleProperty("white-space", "pre-wrap");
                        d.setRawStyleProperty("text-overflow", "ellipsis");
                        break;
                    case 1:
                        d.setRawStyleProperty("white-space", "nowrap");
                        d.setRawStyleProperty("text-overflow", "clip");
                        break;
                }
            }
            if (b.al(CellModel.dv) || b.al(CellModel.e0)) {
                let i = b.e;
                let j = b.g;
                ContentCellModelHelper.b(c, d, i);
                e.a8(c, d, i);
                ContentCellModelHelper.c(c, d, j);
                if (b.ap) {
                    e.br(i, j);
                }
            }
            if (b.al(CellModel.dr)) {
                let k = b.x;
                if (k == null) {
                    k = FontUtil.getDefaultFont(a);
                }
                d.setRawStyleProperty("font", k.fontString);
            }
        }
    }
}
ContentCellModelHelper.$t = markType(ContentCellModelHelper, 'ContentCellModelHelper');
ContentCellModelHelper.d = Color.u(0, 0, 0, 0);
//# sourceMappingURL=ContentCellModelHelper.js.map