/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType } from "igniteui-angular-core";
import { ICellRenderingEngine_$type } from "./ICellRenderingEngine";
import { CurrentRendererSettings } from "./CurrentRendererSettings";
import { RenderingContext } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { intDivide } from "igniteui-angular-core";
/**
 * @hidden
 */
export class DataGridCellLayoutPanel extends Base {
    constructor(a, b, c) {
        super();
        this.e = null;
        this.k = false;
        this.q = null;
        this._element = null;
        this.f = null;
        this.i = false;
        this.m = false;
        this.g = null;
        this.l = false;
        this._requestAnimationFrame = null;
        this.s = 0;
        this.o = -1;
        this.n = -1;
        this.j = false;
        this.p = 0;
        this.c = null;
        this.a = null;
        this.d = null;
        this.b = null;
        this.p = c;
        this.q = a;
        this.requestAnimationFrame = this.q.getRequestAnimationFrame();
        this.element = this.q.createElement("div");
        this.element.setRawStyleProperty("position", "relative");
        this.element.setRawStyleProperty("box-sizing", "border-box");
        this.refresh(this.e, false);
        this.f = b;
        this.i = false;
    }
    get element() {
        return this._element;
    }
    set element(a) {
        this._element = a;
    }
    refresh(a, b) {
        this.e = a;
        this.ah(b);
    }
    viewportChanged() {
        this.ah(true);
    }
    invalidateVisibility(a) {
        this.g = a;
        this.m = true;
    }
    get initialRefreshFinished() {
        return this.i;
    }
    z(a, b, c, d) {
        this.ah(true);
    }
    ag(a) {
        let b = this.f.b(this.q, a);
        if (b.isCanvasBased) {
            let c = b.nativeCell.ab = false;
        }
        else {
            let d = b.nativeCell.x;
            d.setRawStyleProperty("top", "-1000px");
        }
    }
    ah(a) {
        if (a) {
            this.k = true;
            this.t();
            return;
        }
        if (this.l) {
            return;
        }
        if (this.k) {
            return;
        }
        this.k = true;
        this.v(runOn(this, this.t));
    }
    get requestAnimationFrame() {
        return this._requestAnimationFrame;
    }
    set requestAnimationFrame(a) {
        this._requestAnimationFrame = a;
    }
    v(a) {
        this.requestAnimationFrame(a);
    }
    t() {
        if (!this.k) {
            return;
        }
        this.k = false;
        if (this.m) {
            this.m = false;
            this.g();
        }
        if (this.e == null) {
            return;
        }
        if (Rect.l_op_Equality(this.e.actualVisibleRegion, null) || this.e.actualVisibleRegion.isEmpty) {
            return;
        }
        this.i = true;
        if (this.o != this.e.absoluteWidth) {
            this.element.setRawStyleProperty("width", this.e.absoluteWidth + "px");
        }
        if (this.n != this.e.absoluteHeight) {
            this.element.setRawStyleProperty("height", this.e.absoluteHeight + "px");
        }
        this.o = this.e.absoluteWidth;
        this.n = this.e.absoluteHeight;
        let a = this.e.actualVisibleRegion.top;
        let b = this.e.actualVisibleRegion.left;
        let c = this.e.be;
        let d = c.count;
        let e = this.e.ay;
        let f = this.e.ay.o;
        let g = f.count;
        let h = this.e.ay.p;
        for (let i = 0; i < g; i++) {
            if (h._inner[i]) {
                continue;
            }
            let j = e.item(f._inner[i]);
            for (let k = 0; k < j.count; k++) {
                let l = j._inner[k];
                this.ag(l);
            }
        }
        e.u();
        let m = false;
        let n = this.s;
        let o = true;
        let p = false;
        for (let q = 0; q < d; q++) {
            let r = c._inner[q].q;
            let s = c._inner[q].q.count;
            let t = c._inner[q].p;
            for (let u = 0; u < s; u++) {
                if (t._inner[u]) {
                    continue;
                }
                let v = r._inner[u];
                let w = this.f.b(this.q, v);
                if (!w.isCanvasBased) {
                    o = false;
                }
                else {
                    p = true;
                }
                if (v.ao) {
                    m = true;
                }
                if (v.r == 1 && v.e6 != n) {
                    m = true;
                }
            }
        }
        if (p) {
            this.u();
        }
        if (m) {
            if (this.s == 0x7FFFFFFFFFFFFFFF - 1) {
                this.s = 0;
            }
            else {
                this.s++;
            }
            n = this.s;
        }
        let x = 0;
        let y = new CurrentRendererSettings();
        let z = this.p;
        this.l = true;
        for (let aa = 0; aa < d; aa++) {
            let ab = c._inner[aa].q;
            let ac = c._inner[aa].q.count;
            let ad = c._inner[aa].p;
            for (let ae = 0; ae < ac; ae++) {
                if (ad._inner[ae]) {
                    continue;
                }
                let af = ab._inner[ae];
                let ag = this.f.b(this.q, af);
                if (ag.isCanvasBased) {
                    let ah = y.a;
                    this.al(y, aa, af, this.e, x, m, o);
                    if (y.a != ah && m) {
                        x++;
                    }
                }
                let ai = ag.isCanvasBased;
                let aj = null;
                if (!ai) {
                    aj = ag.nativeCell.x;
                    if (af.r == 0) {
                        this.element.append(aj);
                    }
                }
                if (af.r == 1) {
                    if (ai) {
                        let ak = af.p.nativeCell;
                        ak.ab = true;
                    }
                }
                af.r = 2;
                let al = (af.ep + intDivide(af.e2, 2));
                let am = (af.er + intDivide(af.dt, 2));
                let an = (al - b) / this.e.actualVisibleRegion.width;
                let ao = (am - a) / this.e.actualVisibleRegion.height;
                if (af.aq) {
                    if (!ai) {
                        aj.setRawPosition(af.br, af.bs);
                    }
                }
                af.hh();
                if (ai) {
                    let ap = af.p.nativeCell;
                    ap.cg(z);
                }
                af.p.modelUpdated(af);
                if (ai && y.b) {
                    let aq = af.p.nativeCell;
                    aq.by(y.a, y.c, y.d, af.br, af.bs, z);
                }
                af.ha();
                if (m) {
                    af.e6 = n;
                    if (!ai) {
                        aj.setRawStyleProperty("z-index", x.toString());
                    }
                    x++;
                }
            }
        }
        this.l = false;
        if (y.a != null && this.p != 1) {
            y.a.y();
        }
    }
    u() {
        if (!this.j) {
            this.j = true;
            let a = this.q.rootWrapper;
            let b = (window.navigator.msPointerEnabled && MSGesture !== undefined);
            let c = (window.PointerEvent || window.navigator.pointerEnabled);
            let d = (window.TouchEvent);
            if ((b || c)) {
                a.listen("pointerdown", runOn(this, this.ad));
                a.listen("pointerup", runOn(this, this.af));
                a.listen("pointermove", runOn(this, this.ae));
            }
            else {
                a.listen("mousedown", runOn(this, this.w));
                a.listen("mouseup", runOn(this, this.y));
                a.listen("mousemove", runOn(this, this.x));
                a.listen("touchstart", runOn(this, this.ai));
                a.listen("touchend", runOn(this, this.ak));
                a.listen("touchmove", runOn(this, this.aj));
            }
        }
    }
    w(a) {
        this.ac(a, false);
    }
    y(a) {
        this.aa(a, false);
    }
    x(a) {
        this.ab(a, false);
    }
    ad(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.ai(e_);
        }
        else {
            this.w(e_);
        }
    }
    ae(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.aj(e_);
        }
        else {
            this.x(e_);
        }
    }
    af(e_) {
        let a = (e_.originalEvent.pointerType);
        if (a == "touch") {
            this.ak(e_);
        }
        else {
            this.y(e_);
        }
    }
    ai(a) {
        this.ac(a, true);
    }
    ac(a, b) {
        if (this.e == null) {
            return;
        }
        let c = this.q.rootWrapper.getOffset();
        let d = this.e.d(a.pageX - c.left, a.pageY - c.top);
        if (d == null) {
            return;
        }
        if (d.p != null) {
            if (d.p.isCanvasBased && d.p.nativeCell != null) {
                d.p.nativeCell.onContactStarted(a, b);
            }
        }
    }
    aj(a) {
        this.ab(a, true);
    }
    ab(a, b) {
        if (this.e == null) {
            return;
        }
        let c = this.q.rootWrapper.getOffset();
        let d = this.e.d(a.pageX - c.left, a.pageY - c.top);
        if (d == null) {
            return;
        }
        if (d.p != null) {
            if (d.p.isCanvasBased && d.p.nativeCell != null) {
                d.p.nativeCell.onContactMoved(a, b);
            }
        }
    }
    ak(a) {
        this.aa(a, true);
    }
    aa(a, b) {
        if (this.e == null) {
            return;
        }
        let c = this.q.rootWrapper.getOffset();
        let d = this.e.d(a.pageX - c.left, a.pageY - c.top);
        if (d == null) {
            return;
        }
        if (d.p != null) {
            if (d.p.isCanvasBased && d.p.nativeCell != null) {
                d.p.nativeCell.onContactCompleted(a, b);
            }
        }
    }
    al(a, b, c, d, e, f, g) {
        if (g) {
            b = 0;
        }
        if (this.c == null) {
            this.c = new Array(d.be.count);
            this.a = new Array(d.be.count);
            this.d = new Array(d.be.count);
            this.b = new Array(d.be.count);
            for (let h = 0; h < d.be.count; h++) {
                this.c[h] = null;
                this.a[h] = null;
                this.d[h] = -1;
                this.b[h] = -1;
            }
        }
        if (this.c[b] == null) {
            let i = this.q.createElement("canvas");
            this.a[b] = i;
            i.setRawStyleProperty("position", "absolute");
            i.setRawStyleProperty("z-index", e.toString());
            this.element.append(i);
            let j = this.q.get2DCanvasContext(i);
            let k = ((() => {
                let $ret = new CanvasViewRenderer();
                $ret.h$d = j;
                return $ret;
            })());
            this.c[b] = new RenderingContext(k, j);
        }
        if (a.a != this.c[b]) {
            a.a = this.c[b];
            a.b = true;
            a.c = d.actualVisibleRegion.left;
            a.d = d.actualVisibleRegion.top;
            let l = d.actualVisibleRegion.width * this.p;
            let m = d.actualVisibleRegion.height * this.p;
            if (l != this.d[b] || m != this.b[b]) {
                this.a[b].setRawSize(d.actualVisibleRegion.width, d.actualVisibleRegion.height);
                this.a[b].setAttribute("width", l + "px");
                this.a[b].setAttribute("height", m + "px");
                this.d[b] = l;
                this.b[b] = m;
            }
            if (f) {
                this.a[b].setRawStyleProperty("z-index", e.toString());
            }
            a.a.k(0, 0, d.actualVisibleRegion.width, d.actualVisibleRegion.height);
            this.a[b].setRawPosition(a.c, a.d);
        }
    }
}
DataGridCellLayoutPanel.$t = markType(DataGridCellLayoutPanel, 'DataGridCellLayoutPanel', Base.$, [ICellRenderingEngine_$type]);
//# sourceMappingURL=DataGridCellLayoutPanel.js.map