/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, delegateRemove, delegateCombine, markType } from "igniteui-angular-core";
import { GridAnimationPhaseSettings } from "./GridAnimationPhaseSettings";
/**
 * @hidden
 */
export class GridAnimationSettings extends Base {
    constructor() {
        super();
        this.g = null;
        this.b = null;
        this.c = null;
        this.a = null;
        this.propertyChanged = null;
        this.b = new GridAnimationPhaseSettings();
        this.b.l = 500;
        this.b.c = 1;
        this.b.e = false;
        this.c = new GridAnimationPhaseSettings();
        this.c.l = 300;
        this.c.c = 1;
        this.c.n = 0;
        this.c.e = true;
        this.a = new GridAnimationPhaseSettings();
        this.a.l = 0;
        this.a.c = 1;
        this.a.n = 0;
        this.a.e = true;
    }
    get e() {
        return this.b;
    }
    set e(a) {
        let b = this.b;
        this.b = a;
        this.m("CellDataLoadedMainPhase", b, this.b);
    }
    get f() {
        return this.c;
    }
    set f(a) {
        let b = this.c;
        this.c = a;
        this.m("RowSelectionMainPhase", b, this.c);
    }
    get d() {
        return this.a;
    }
    set d(a) {
        let b = this.a;
        this.a = a;
        this.m("CellActivationMainPhase", b, this.a);
    }
    m(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.n(a, b, c);
    }
    n(a, b, c) {
        switch (a) {
            case "CellDataLoadedMainPhase":
                if (b != null) {
                    let d = b;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.l));
                }
                if (c != null) {
                    let e = c;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.l));
                }
                break;
            case "RowSelectionMainPhase":
                if (b != null) {
                    let f = b;
                    f.propertyChanged = delegateRemove(f.propertyChanged, runOn(this, this.o));
                }
                if (c != null) {
                    let g = c;
                    g.propertyChanged = delegateCombine(g.propertyChanged, runOn(this, this.o));
                }
                break;
            case "CellActivationMainPhase":
                if (b != null) {
                    let h = b;
                    h.propertyChanged = delegateRemove(h.propertyChanged, runOn(this, this.k));
                }
                if (c != null) {
                    let i = c;
                    i.propertyChanged = delegateCombine(i.propertyChanged, runOn(this, this.k));
                }
                break;
        }
    }
    l(a, b) {
        this.m("CellDataLoadedMainPhase", this.e, this.e);
    }
    o(a, b) {
        this.m("RowSelectionMainPhase", this.f, this.f);
    }
    k(a, b) {
        this.m("CellActivationMainPhase", this.d, this.d);
    }
}
GridAnimationSettings.$t = markType(GridAnimationSettings, 'GridAnimationSettings', Base.$, [INotifyPropertyChanged_$type]);
//# sourceMappingURL=GridAnimationSettings.js.map