/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Point_$type, runOn, markType, delegateCombine, delegateRemove, INotifyPropertyChanged_$type, PropertyChangedEventArgs, EnumUtil } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { GridFilterDialogViewModelRow } from "./GridFilterDialogViewModelRow";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { GridFilterDialogOpeningEventArgs } from "./GridFilterDialogOpeningEventArgs";
import { ColumnComparisonConditionOperatorType_$type } from "./ColumnComparisonConditionOperatorType";
import { ColumnComparisonFilterCondition } from "./ColumnComparisonFilterCondition";
import { GridFilterDialogFilterChangeEventArgs } from "./GridFilterDialogFilterChangeEventArgs";
import { ColumnFilterConditionGroup } from "./ColumnFilterConditionGroup";
import { Stack$1 } from "igniteui-angular-core";
import { GridFilterDialogViewModelGroupingLevel } from "./GridFilterDialogViewModelGroupingLevel";
import { GridFilterDialogViewModelGrouping } from "./GridFilterDialogViewModelGrouping";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GridFilterDialogViewModelGroupingLevelCollection } from "./GridFilterDialogViewModelGroupingLevelCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export class GridFilterDialogView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.x = new Path();
        this.i = 0;
        this.h = 0;
        this.m = null;
        this.c = null;
        this.l = null;
        this.f = 0;
        this.e = 0;
        this.g = 1;
        this.k = 0;
        this.j = 0;
        this.d = false;
        this.b = null;
        this.a = a;
    }
    t() {
        if (this.i != this.k || this.h != this.j) {
            this.q();
            this.i = this.k;
            this.h = this.j;
        }
        let a = Math.min(this.k, this.j);
        let b = { $type: Point_$type, x: this.k / 2, y: this.j / 2 };
        let c = Math.round(this.k * this.g);
        let d = Math.round(this.j * this.g);
        if (this.f != c || this.e != d) {
            this.m.setAttribute("width", c.toString());
            this.m.setAttribute("height", d.toString());
            this.m.setStyleProperty("width", this.k.toString() + "px");
            this.m.setStyleProperty("height", this.j.toString() + "px");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.f = truncate(Math.round(c));
            this.e = truncate(Math.round(d));
        }
        if (this.c.d && this.g != 1) {
            this.c.z();
            this.c.aa(this.g, this.g);
        }
        this.c.k(0, 0, this.k, this.j);
        this.c.s(this.x);
        if (this.c.d && this.g != 1) {
            this.c.y();
        }
    }
    q() {
        this.a.ah(this.k, this.j, this.x);
    }
    r(a) {
        if (a == null) {
            if (this.m != null) {
                this.m.destroy();
            }
            this.m = null;
            this.l = null;
            this.c = null;
            return;
        }
        this.g = (isNaN_(this.a.u) ? this.a.t : this.a.u);
        let b = a;
        this.l = b;
        this.l.rootWrapper.addClass("ui-radialgauge-container");
        let c = this.g;
        let d = Math.round(b.rootWrapper.width());
        let e = Math.round(b.rootWrapper.height());
        let f = d * c;
        let g = e * c;
        this.l.rootWrapper.setStyleProperty("position", "relative");
        let h = this.l.createElement("canvas");
        h.setStyleProperty("position", "absolute");
        this.l.append(h);
        this.f = truncate(Math.round(f));
        this.e = truncate(Math.round(g));
        h.setAttribute("width", f.toString());
        h.setAttribute("height", g.toString());
        h.setStyleProperty("width", d.toString() + "px");
        h.setStyleProperty("height", e.toString() + "px");
        h.listen("mousedown", runOn(this, this.n));
        h.listen("mouseup", runOn(this, this.o));
        this.k = d;
        this.j = e;
        this.m = h;
        let i = this.l.get2DCanvasContext(this.m);
        this.c = new RenderingContext(new CanvasViewRenderer(), i);
        if (isNaN_(this.a.u)) {
            this.a.t = window.devicePixelRatio;
            this.g = this.a.t;
        }
        this.t();
    }
    n(a) {
        a.preventDefault();
        a.stopPropagation();
    }
    o(a) {
        a.preventDefault();
        a.stopPropagation();
        if (!this.d) {
            this.a.am();
        }
        else {
            this.a.ag(this.b.b, false);
        }
    }
    u() {
        this.t();
    }
    s(a, b) {
        if (isNaN_(this.a.u)) {
            this.a.t = window.devicePixelRatio;
            this.g = this.a.t;
        }
        this.k = a;
        this.j = b;
        this.t();
    }
    w() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(138, 0, 0, 0);
            return $ret;
        })());
    }
    v(a) {
        this.d = true;
        let b = new GridFilterDialogPanel(this.m, this.l);
        b.a = this.a;
        b.x(a);
        this.b = b;
    }
    p() {
        this.d = false;
        if (this.b != null) {
            this.b.o();
            this.b.p();
            this.b = null;
        }
    }
}
GridFilterDialogView.$t = markType(GridFilterDialogView, 'GridFilterDialogView');
/**
 * @hidden
 */
export class GridFilterDialogPanel extends Base {
    constructor(a, b) {
        super();
        this.a = null;
        this.i = null;
        this.d = null;
        this.h = null;
        this.k = null;
        this.b = null;
        this.g = null;
        this.f = null;
        this.j = null;
        this.e = null;
        this.c = false;
        let c = b.createElement("div");
        let d = b.getSubRenderer(c);
        c.setStyleProperty("position", "absolute");
        c.setStyleProperty("top", "0px");
        c.setStyleProperty("left", "0px");
        c.setStyleProperty("display", "none");
        c.setStyleProperty("z-index", "10000");
        c.setStyleProperty("opacity", ".9");
        c.setStyleProperty("background-color", "#aaa");
        c.setStyleProperty("border-radius", "3px");
        c.setStyleProperty("boxShadow", "0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22)");
        this.i = a;
        this.d = d;
        this.h = c;
        this.k = d.createElement("div");
        this.h.append(this.k);
        this.g = d.createElement("div");
        this.h.append(this.g);
        this.e = d.createElement("input");
        this.e.setAttribute("type", "button");
        this.e.setProperty("value", "add condition");
        this.f = d.createElement("input");
        this.f.setAttribute("type", "button");
        this.f.setProperty("value", "apply");
        this.j = d.createElement("input");
        this.j.setAttribute("type", "button");
        this.j.setProperty("value", "reset");
        this.g.append(this.e);
        this.g.append(this.f);
        this.g.append(this.j);
        this.e.listen("click", runOn(this, this.r));
        this.f.listen("click", runOn(this, this.s));
        this.j.listen("click", runOn(this, this.v));
        this.e.setStyleProperty("opacity", ".9");
        this.e.setStyleProperty("margin", "3px");
        this.f.setStyleProperty("opacity", ".9");
        this.f.setStyleProperty("margin", "3px");
        this.j.setStyleProperty("opacity", ".9");
        this.j.setStyleProperty("margin", "3px");
    }
    r(a) {
        this.b.n();
    }
    v(a) {
        this.a.ag(this.b, true);
    }
    s(a) {
        this.a.ag(this.b, false);
    }
    x(a) {
        a.onModified = delegateCombine(a.onModified, runOn(this, this.aa));
        this.b = a;
        this.z();
        this.h.setStyleProperty("left", this.i.getOffset().left + "px");
        this.h.setStyleProperty("top", (this.i.getOffset().top + this.i.outerHeight()) + "px");
        this.h.setStyleProperty("display", "block");
        this.d.appendToBody(this.h);
    }
    o() {
        let a = this.b;
        a.onModified = delegateRemove(a.onModified, runOn(this, this.aa));
        this.b = null;
        this.h.setStyleProperty("display", "none");
        this.h.remove();
    }
    p() {
        this.d.destroy();
        this.h = null;
        this.k = null;
        this.f = null;
        this.g = null;
        this.j = null;
        if (this.b != null) {
            let a = this.b;
            a.onModified = delegateRemove(a.onModified, runOn(this, this.aa));
        }
        this.b = null;
    }
    aa(a) {
        if (this.c) {
            return;
        }
        this.z();
    }
    z() {
        for (let a = 0; a < this.b.f.count; a++) {
            let b = null;
            if (a < this.k.getChildCount()) {
                b = this.k.getChildAt(a);
            }
            else {
                b = this.d.createElement("div");
                this.k.append(b);
            }
            this.y(a, b, this.b.f._inner[a]);
        }
        while (this.k.getChildCount() > this.b.f.count) {
            let c = this.k.getChildAt(this.k.getChildCount() - 1);
            c.remove();
        }
    }
    y(a, b, c) {
        let d = false;
        let e = false;
        let f = false;
        let g = false;
        let h = this.l(c) > 0;
        if (b.getChildCount() == 0) {
            d = true;
            e = h;
            f = true;
        }
        else {
            if (h && b.getChildCount() == 2) {
                e = true;
            }
            if (!h && b.getChildCount() == 3) {
                g = true;
            }
        }
        let i = null;
        let j = null;
        let k = null;
        if (d) {
            i = this.d.createElement("select");
            this.q(i, c);
            i.listen("change", runOn(this, this.w));
            i.setStyleProperty("opacity", ".9");
            i.setStyleProperty("margin", "3px");
            b.append(i);
        }
        else {
            i = b.getChildAt(0);
        }
        if (e) {
            j = this.d.createElement("input");
            j.setAttribute("type", "text");
            j.listen("input", runOn(this, this.u));
            j.setStyleProperty("opacity", ".9");
            j.setStyleProperty("margin", "3px");
            if (b.getChildCount() == 2) {
                let l = b.getChildAt(b.getChildCount() - 1);
                l.before(j);
            }
            else {
                b.append(j);
            }
        }
        else {
            j = b.getChildAt(1);
        }
        if (g) {
            let m = b.getChildAt(1);
            m.remove();
        }
        if (f) {
            k = this.d.createElement("input");
            k.setAttribute("type", "button");
            k.setProperty("value", "X");
            k.listen("click", runOn(this, this.t));
            k.setStyleProperty("opacity", ".9");
            k.setStyleProperty("margin", "3px");
            b.append(k);
        }
        else {
            k = b.getChildAt(b.getChildCount() - 1);
        }
        this.c = true;
        i.setAttribute("data-index", a.toString());
        if (!stringIsNullOrEmpty(c.l)) {
            i.setProperty("value", c.l);
        }
        if (b.getChildCount() > 2) {
            j.setAttribute("data-index", a.toString());
            if (c.i != null) {
                j.setProperty("value", c.i);
            }
        }
        k.setAttribute("data-index", a.toString());
        this.c = false;
    }
    q(a, b) {
        a.removeChildren();
        for (let c = 0; c < b.e.length; c++) {
            let d = this.d.createElement("option");
            d.setAttribute("value", b.e[c]);
            d.setText(b.e[c]);
            a.append(d);
        }
    }
    t(a) {
        let b = this.n(a);
        this.b.f.removeAt(b);
    }
    n(a) {
        let originalEvent_ = a.originalEvent;
        let currentTarget_ = originalEvent_.currentTarget;
        return parseInt((currentTarget_.getAttribute('data-index')));
    }
    u(a) {
        this.c = true;
        let b = this.n(a);
        let c = this.k.getChildAt(b).getChildAt(1).getProperty("value");
        this.b.f._inner[b].i = c;
        this.c = false;
    }
    w(a) {
        this.c = true;
        let b = this.n(a);
        let c = this.k.getChildAt(b).getChildAt(0).getProperty("value");
        this.b.f._inner[b].l = c;
        this.c = false;
    }
    l(a) {
        return a.d[this.m(a)];
    }
    m(a) {
        for (let b = 0; b < a.e.length; b++) {
            if (a.e[b] == a.l) {
                return b;
            }
        }
        return 0;
    }
}
GridFilterDialogPanel.$t = markType(GridFilterDialogPanel, 'GridFilterDialogPanel');
/**
 * @hidden
 */
export class GridFilterDialog extends Base {
    constructor() {
        super();
        this.x = null;
        this.o = true;
        this.propertyChanged = null;
        this.s = NaN;
        this.r = 1;
        this.f = null;
        this.dialogOpening = null;
        this.filterChanging = null;
        this.filterChanged = null;
        this.l = null;
        this.l = new GridFilterDialogView(this);
    }
    get y() {
        return this.x;
    }
    set y(a) {
        this.x = a;
    }
    get p() {
        return this.o;
    }
    set p(a) {
        let b = this.o;
        this.o = a;
        if (b != this.o) {
            this.ak("IsAnimationEnabled", b, this.o);
        }
    }
    get u() {
        return this.s;
    }
    set u(a) {
        let b = this.s;
        this.s = a;
        this.ak("PixelScalingRatio", b, this.s);
    }
    get t() {
        return this.r;
    }
    set t(a) {
        let b = this.r;
        this.r = a;
        this.ak("ActualPixelScalingRatio", b, this.r);
    }
    ak(a, b, c) {
        this.an(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    an(a, b, c) {
        switch (a) {
            case "PixelScalingRatio":
                this.t = this.u;
                break;
            case "ActualPixelScalingRatio":
                this.l.u();
                break;
        }
    }
    ao(a) {
        this.l.r(a);
    }
    am() {
        let a = null;
        let b = 0;
        if (this.dialogOpening != null) {
            let c = new GridFilterDialogOpeningEventArgs();
            this.dialogOpening(this, c);
            a = c.a;
            b = c.b;
        }
        this.as(a, b);
    }
    as(a, b) {
        this.f = a;
        let c = ColumnComparisonFilterCondition.c(b);
        let d = this.m(a, c);
        d.m = 1;
        d.a = b;
        d.onModified = delegateCombine(d.onModified, runOn(this, this.al));
        this.l.v(d);
    }
    aj(a, b) {
        a.onModified = delegateRemove(a.onModified, runOn(this, this.al));
        if (b) {
            this.aq();
        }
        else {
            this.ap(a, true);
        }
        this.f = null;
    }
    ar() {
        if (this.filterChanged != null) {
            this.filterChanged(this, ((() => {
                let $ret = new GridFilterDialogFilterChangeEventArgs();
                $ret.a = this.f;
                return $ret;
            })()));
        }
    }
    aq() {
        if (this.filterChanged != null) {
            this.filterChanged(this, ((() => {
                let $ret = new GridFilterDialogFilterChangeEventArgs();
                $ret.a = null;
                return $ret;
            })()));
        }
    }
    ap(a, b) {
        let c = this.e(a);
        if (b) {
            if (this.filterChanged != null) {
                this.filterChanged(this, ((() => {
                    let $ret = new GridFilterDialogFilterChangeEventArgs();
                    $ret.a = c;
                    return $ret;
                })()));
            }
        }
        else {
            if (this.filterChanging != null) {
                this.filterChanging(this, ((() => {
                    let $ret = new GridFilterDialogFilterChangeEventArgs();
                    $ret.a = c;
                    return $ret;
                })()));
            }
        }
    }
    e(a) {
        let b = new ColumnFilterConditionGroup();
        b.f = a.k;
        let c = new Stack$1(ColumnFilterConditionGroup.$);
        let d = 0;
        let e = b;
        for (let f = 0; f < a.f.count; f++) {
            let g = this.h(d, c, a, f);
            while (g != null) {
                e.h(g);
                e = g;
                d++;
                g = this.h(d, c, a, f);
            }
            g = this.g(d, c, a, f);
            while (g != null) {
                e = g;
                d--;
                g = this.g(d, c, a, f);
            }
            if (e == null) {
                e = b;
            }
            if (this.q(a, a.f._inner[f])) {
                continue;
            }
            e.h(this.d(a.f._inner[f]));
        }
        if (b.g == 0) {
            return null;
        }
        return b;
    }
    q(a, b) {
        let c = 0;
        for (let d = 0; d < b.e.length; d++) {
            if (b.e[d] == b.l) {
                c = d;
                break;
            }
        }
        if (b.d[c] > 0 && b.i == null) {
            return true;
        }
        if (a.a != 0 && b.d[c] > 0 && typeof b.i === 'string' && stringIsNullOrEmpty(b.i)) {
            return true;
        }
        return false;
    }
    g(a, b, c, d) {
        let e = this.w(c, d);
        if (a > e) {
            b.e();
            return b.d();
        }
        return null;
    }
    w(a, b) {
        let c = a.c(b);
        if (c == null) {
            return 0;
        }
        return a.e.indexOf(c);
    }
    h(a, b, c, d) {
        let e = this.w(c, d);
        if (a < e) {
            let f = c.b(d);
            let g = new ColumnFilterConditionGroup();
            g.f = f.a;
            b.h(g);
            return g;
        }
        return null;
    }
    d(a) {
        let b = new ColumnComparisonFilterCondition();
        b.e = this.c(a.l);
        b.i = a.i;
        return b;
    }
    c(a) {
        return EnumUtil.getEnumValue(ColumnComparisonConditionOperatorType_$type, EnumUtil.parse(ColumnComparisonConditionOperatorType_$type, a, true));
    }
    al(a) {
        this.ap(a, false);
    }
    m(a, b) {
        let c = new GridFilterDialogViewModel();
        if (a != null) {
            this.af(c, a, b);
        }
        else {
            let d = new GridFilterDialogViewModelRow();
            d.f = b;
            d.e = GridFilterDialog.a(b);
            d.d = GridFilterDialog.b(b);
            d.l = GridFilterDialog.ac(b[0]);
            c.f.add(d);
        }
        return c;
    }
    af(a, b, c) {
        if (b.b()) {
            let d = b;
            for (let e = 0; e < d.g; e++) {
                let f = d.item(e);
                this.af(a, f, c);
            }
        }
        else {
            a.f.add(this.n(b, c));
        }
    }
    n(a, b) {
        let c = new GridFilterDialogViewModelRow();
        c.l = GridFilterDialog.ac(a.e);
        c.f = b;
        c.e = GridFilterDialog.a(b);
        c.i = GridFilterDialog.z(GridFilterDialog.v(a.e), a.e, a);
        c.j = GridFilterDialog.aa(GridFilterDialog.v(a.e), a.e, a);
        c.d = GridFilterDialog.b(b);
        return c;
    }
    static v(a) {
        return ColumnComparisonFilterCondition.g(a);
    }
    static z(a, b, c) {
        if (a == 0) {
            return "";
        }
        return c.i != null ? c.i.toString() : "";
    }
    static aa(a, b, c) {
        return "";
    }
    static b(a) {
        return ColumnComparisonFilterCondition.d(a);
    }
    static a(a) {
        let b = new Array(a.length);
        for (let c = 0; c < a.length; c++) {
            b[c] = EnumUtil.getName(ColumnComparisonConditionOperatorType_$type, a[c]);
        }
        return b;
    }
    static ac(a) {
        return EnumUtil.getName(ColumnComparisonConditionOperatorType_$type, a);
    }
    ai(a, b) {
        this.l.s(a, b);
    }
    ah(a, b, c) {
        let d = Math.min(a, b);
        let e = { $type: Point_$type, x: a / 2, y: b / 2 };
        let f = d * 0.8;
        let g = f / 2;
        let h = g / 2;
        let i = h / 2;
        let j = i / 2;
        let k = new PathFigure();
        k._startPoint = { $type: Point_$type, x: e.x - g, y: e.y - g };
        let l = new LineSegment(1);
        l.c = { $type: Point_$type, x: e.x + g, y: e.y - g };
        k._segments.add(l);
        let m = new PathFigure();
        m._startPoint = { $type: Point_$type, x: e.x - h, y: e.y };
        let n = new LineSegment(1);
        n.c = { $type: Point_$type, x: e.x + h, y: e.y };
        m._segments.add(n);
        let o = new PathFigure();
        o._startPoint = { $type: Point_$type, x: e.x - i, y: e.y + g };
        let p = new LineSegment(1);
        p.c = { $type: Point_$type, x: e.x + i, y: e.y + g };
        o._segments.add(p);
        let q = new PathGeometry();
        q.c.add(k);
        q.c.add(m);
        q.c.add(o);
        c.ak = q;
        c._stroke = this.l.w();
        c.ac = 1;
    }
    ag(a, b) {
        this.l.p();
        this.aj(a, b);
    }
}
GridFilterDialog.$t = markType(GridFilterDialog, 'GridFilterDialog', Base.$, [INotifyPropertyChanged_$type]);
/**
 * @hidden
 */
export class GridFilterDialogViewModel extends Base {
    constructor() {
        super();
        this.a = 0;
        this.e = null;
        this.k = false;
        this.m = 0;
        this.f = null;
        this.onModified = null;
        this.k = false;
        this.f = new GridFilterDialogViewModelRowCollection();
        this.f.ae = this;
        this.e = new GridFilterDialogViewModelGroupingLevelCollection();
        this.f.ag = runOn(this, this.u);
        let a = this.f;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.t));
    }
    n() {
        let a = new GridFilterDialogViewModelRow();
        let b = ColumnComparisonFilterCondition.c(this.a);
        a.f = b;
        a.e = GridFilterDialog.a(b);
        a.d = GridFilterDialog.b(b);
        a.l = GridFilterDialog.ac(b[0]);
        this.f.add(a);
    }
    u(a) {
        if (this.onModified != null) {
            this.onModified(this);
        }
    }
    t(a, b) {
        switch (b.action) {
            case 0:
                if (b.newItems != null) {
                    for (let c = 0; c < b.newItems.count; c++) {
                        let d = b.newItems.item(c);
                        this.q(c + b.newStartingIndex, d);
                    }
                }
                break;
            case 1:
                if (b.oldItems != null) {
                    for (let e = 0; e < b.oldItems.count; e++) {
                        this.r(b.oldStartingIndex);
                    }
                }
                break;
            case 2:
                if (b.oldItems != null) {
                    for (let f = 0; f < b.oldItems.count; f++) {
                        this.r(b.oldStartingIndex);
                    }
                }
                if (b.newItems != null) {
                    for (let g = 0; g < b.newItems.count; g++) {
                        let h = b.newItems.item(g);
                        this.q(g + b.newStartingIndex, b.newItems.item(g));
                    }
                }
                break;
            case 4:
                this.s();
                break;
        }
        if (this.onModified != null) {
            this.onModified(this);
        }
    }
    r(a) {
        let b = this.c(a);
        if (b == null) {
            return;
        }
        let c = this.b(a);
        if (c == null) {
            return;
        }
        this.w(c, a);
        for (let d = b.indexOf(c) + 1; d < b.count; d++) {
            this.v(b._inner[d], -1);
        }
    }
    w(a, b) {
        a.b--;
    }
    s() {
        this.e.clear();
    }
    q(a, b) {
        let c = this.c(a);
        if (c == null) {
            return;
        }
        let d = this.b(a);
        if (d == null) {
            return;
        }
        this.p(d, a);
        for (let e = c.indexOf(d) + 1; e < c.count; e++) {
            this.v(c._inner[e], +1);
        }
    }
    v(a, b) {
        a.c += b;
        a.b -= b;
    }
    p(a, b) {
        a.b++;
    }
    b(a) {
        for (let b = this.e.count - 1; b >= 0; b--) {
            for (let c = 0; c < this.e._inner[b].count; c--) {
                if (this.e._inner[b]._inner[c].c <= a && this.e._inner[b]._inner[c].b >= a) {
                    return this.e._inner[b]._inner[c];
                }
            }
        }
        return null;
    }
    c(a) {
        for (let b = this.e.count - 1; b >= 0; b--) {
            for (let c = 0; c < this.e._inner[b].count; c--) {
                if (this.e._inner[b]._inner[c].c <= a && this.e._inner[b]._inner[c].b >= a) {
                    return this.e._inner[b];
                }
            }
        }
        return null;
    }
    h(a, b) {
        let c = this.d(a, b);
        if (this.i(c, a, b)) {
            if (this.e.count < this.m) {
                return true;
            }
            else {
                return false;
            }
        }
        return true;
    }
    i(a, b, c) {
        if (a == null) {
            return false;
        }
        for (let d = 0; d < a.count; d++) {
            if (this.j(a._inner[d], b, c)) {
                return true;
            }
        }
        return false;
    }
    j(a, b, c) {
        if (c > a.c || b > a.b) {
            return false;
        }
        return true;
    }
    d(a, b) {
        if (this.e.count == 0) {
            return null;
        }
        for (let c = 0; c < this.e.count; c++) {
            if (!this.i(this.e._inner[c], a, b)) {
                return this.e._inner[c];
            }
        }
        return this.e._inner[this.e.count - 1];
    }
    aa(a, b) {
        for (let c = 0; c < this.e.count; c++) {
            for (let d = 0; d < this.e._inner[c].count; d++) {
                if (this.e._inner[c]._inner[d].c == a && this.e._inner[c]._inner[d].b == b) {
                    this.e._inner[c].removeAt(d);
                    break;
                }
            }
        }
        this.x();
        if (this.onModified != null) {
            this.onModified(this);
        }
    }
    x() {
        for (let a = this.e.count - 1; a >= 0; a--) {
            let b = new List$1(GridFilterDialogViewModelGrouping.$, 0);
            for (let c = 0; c < this.e._inner[a].count; c++) {
                let d = this.e._inner[a]._inner[c];
                if (a > 0) {
                    if (!this.i(this.e._inner[a - 1], d.c, d.b)) {
                        b.add(d);
                    }
                }
            }
            for (let e = 0; e < b.count; e++) {
                this.e._inner[a].remove(b._inner[e]);
                this.e._inner[a - 1].add(b._inner[e]);
            }
            if (this.e._inner[a].count == 0) {
                this.e.removeAt(a);
            }
        }
        this.y();
    }
    y() {
        for (let a = this.e.count - 1; a >= 0; a--) {
            let b = new List$1(GridFilterDialogViewModelGrouping.$, 0);
            for (let c = 0; c < this.e._inner[a].count; c++) {
                b.add(this.e._inner[a]._inner[c]);
            }
            b.aa((d, e) => Base.compareSimple(d.c, e.c));
            this.e._inner[a].clear();
            for (let d = 0; d < this.e._inner[a].count; d++) {
                this.e._inner[a].add(b._inner[d]);
            }
        }
    }
    l(a, b) {
        for (let c = 0; c < this.e.count; c++) {
            for (let d = 0; d < this.e._inner[c].count; d++) {
                if (this.e._inner[c]._inner[d].c == a && this.e._inner[c]._inner[d].b == b) {
                    return true;
                }
            }
        }
        return false;
    }
    z(a, b) {
        for (let c = 0; c < this.e.count; c++) {
            for (let d = 0; d < this.e._inner[c].count; d++) {
                if (this.e._inner[c]._inner[d].c == a && this.e._inner[c]._inner[d].b == b) {
                    this.e._inner[c]._inner[d].a = !this.e._inner[c]._inner[d].a;
                }
            }
        }
        if (this.onModified != null) {
            this.onModified(this);
        }
    }
    o(a, b, c) {
        if (!this.h(a, b)) {
            return;
        }
        let d = this.d(a, b);
        let e = d;
        if (this.i(d, a, b)) {
            this.e.add(new GridFilterDialogViewModelGroupingLevel());
            e = this.d(a, b);
        }
        e.add(((() => {
            let $ret = new GridFilterDialogViewModelGrouping();
            $ret.c = a;
            $ret.b = b;
            $ret.a = c;
            return $ret;
        })()));
        this.y();
        if (this.onModified != null) {
            this.onModified(this);
        }
    }
}
GridFilterDialogViewModel.$t = markType(GridFilterDialogViewModel, 'GridFilterDialogViewModel');
/**
 * @hidden
 */
export class GridFilterDialogViewModelRowCollection extends ObservableCollection$1 {
    constructor() {
        super(GridFilterDialogViewModelRow.$, 0);
        this.ae = null;
        this.af = null;
        this.collectionChanged = delegateCombine(this.collectionChanged, runOn(this, this.ah));
    }
    ah(a, b) {
        if (b.oldItems != null) {
            for (let c = 0; c < b.oldItems.count; c++) {
                let d = b.oldItems.item(c);
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.ai));
            }
        }
        if (b.newItems != null) {
            for (let e = 0; e < b.newItems.count; e++) {
                let f = b.newItems.item(e);
                f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.ai));
            }
        }
    }
    ai(a, b) {
        if (this.af != null) {
            this.af(this.ae);
        }
    }
    get ag() {
        return this.af;
    }
    set ag(a) {
        this.af = a;
    }
}
GridFilterDialogViewModelRowCollection.$t = markType(GridFilterDialogViewModelRowCollection, 'GridFilterDialogViewModelRowCollection', ObservableCollection$1.$.specialize(GridFilterDialogViewModelRow.$));
//# sourceMappingURL=GridFilterDialogView_combined.js.map