/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { Base, runOn, markType } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ImageCell extends GridCellBase {
    constructor(a) {
        super(a);
        this.b3 = null;
        this.bx = 1;
        this.by = 3;
        this.b5 = null;
        this.bz = false;
        this.b0 = 1;
        this.b2 = null;
        this.b3 = a.createElement("img");
        this.b3.listen("load", runOn(this, this.b8));
        this.b2 = a.createElement("div");
        this.b2.setRawStyleProperty("background-size", "contain");
        this.b2.setRawStyleProperty("background-repeat", "no-repeat");
        this.b2.setRawStyleProperty("background-position", "center");
        this.b2.setRawStyleProperty("width", "100%");
        this.b2.setRawStyleProperty("height", "100%");
        this.x.setRawStyleProperty("text-align", "left");
        this.x.setRawStyleProperty("vertical-align", "middle");
        this.x.append(this.b2);
    }
    get b4() {
        return this.b3;
    }
    get b1() {
        return this.b0;
    }
    set b1(a) {
        this.b0 = a;
    }
    b8(a) {
        this.bz = false;
        if (!stringIsNullOrEmpty(this.b5)) {
            this.b2.setRawStyleProperty("opacity", "1");
            this.b2.setRawStyleProperty("background-image", "url(" + this.b5 + ")");
        }
    }
    b9(a, b) {
        if (a == this.b5) {
            return;
        }
        this.b6();
        this.b2.setRawStyleProperty("opacity", "0");
        if (a == null || a.length == 0) {
            this.b7(this.b3);
            return;
        }
        if (Base.equalsStatic(a, this.b5)) {
            return;
        }
        this.cd(a, b);
        let img_ = this.b3.getNativeElement();
        if (img_ != null && (img_.complete)) {
            this.bz = false;
            this.b3.setRawStyleProperty("opacity", "1");
            this.b2.setRawStyleProperty("background-image", "url(" + this.b5 + ")");
        }
    }
    b7(a) {
        a.setAttribute("src", "");
        this.b2.setRawStyleProperty("background-image", "");
    }
    cc(a) {
        switch (a) {
            case 1:
                this.b2.setRawStyleProperty("background-size", "100% 100%");
                break;
            case 2:
                this.b2.setRawStyleProperty("background-size", "auto");
                break;
            case 0:
                this.b2.setRawStyleProperty("background-size", "contain");
                break;
        }
    }
    cd(a, b) {
        this.bz = true;
        this.b5 = a;
        this.b4.setAttribute("src", a);
    }
    b6() {
        if (this.bz) {
            this.b7(this.b3);
            this.b5 = "";
        }
    }
    ca(a) {
        this.bx = a;
    }
    cb(a) {
        this.by = a;
    }
    get_p() {
        return true;
    }
    a9(a, b, c) {
        super.a9(a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.b2.setRawStyleProperty("margin-left", this.ar + this.at + this.as + "px");
        }
    }
}
ImageCell.$t = markType(ImageCell, 'ImageCell', GridCellBase.$);
//# sourceMappingURL=ImageCell.js.map