/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, enumGetBox, markType } from "igniteui-angular-core";
import { FixedCellPositions_$type } from "./FixedCellPositions";
/**
 * @hidden
 */
export class RowPath extends Base {
    constructor(a, b) {
        super();
        this.l = 0;
        this.k = 0;
        this.a = 0;
        this.j = -1;
        this.c = false;
        this.i = -1;
        this.b = 0;
        this.l = a;
        this.k = b;
        this.y();
    }
    get t() {
        return this.l;
    }
    set t(a) {
        this.l = a;
        this.y();
    }
    get s() {
        return this.k;
    }
    set s(a) {
        this.k = a;
        this.y();
    }
    get b() {
        return this.a;
    }
    set b(a) {
        this.a = a;
        this.y();
    }
    y() {
        this.j = (this.l * 1000000) + this.k;
    }
    getHashCode() {
        return this.j;
    }
    equals(a) {
        let b = a;
        if (this.a != b.a) {
            return false;
        }
        if (this.l != b.l) {
            return false;
        }
        if (this.k != b.k) {
            return false;
        }
        return true;
    }
    toString() {
        return "F" + enumGetBox(FixedCellPositions_$type, this.a) + "." + this.l + "." + this.k;
    }
    get e() {
        return ((this.k == -100 || this.k == -101) && this.l == -100);
    }
    get f() {
        return this.k == -101;
    }
    get h() {
        return (this.k == -200 || this.k == -201);
    }
    get g() {
        return this.c;
    }
    set g(a) {
        this.c = a;
    }
    get m() {
        return this.i;
    }
    set m(a) {
        this.i = a;
    }
    w() {
        let a = new RowPath(this.t, this.s);
        a.b = this.b;
        a.g = this.g;
        a.m = this.m;
        return a;
    }
}
RowPath.$t = markType(RowPath, 'RowPath');
//# sourceMappingURL=RowPath.js.map