/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class SummaryCell extends GridCellBase {
    constructor(a) {
        super(a);
        this.bx = null;
        this.by = null;
        this.b2 = -1;
        this.b1 = -1;
        this.x.setRawStyleProperty("vertical-align", "middle");
        this.bx = a.createElement("span");
        this.bx.setRawStyleProperty("display", "inline-block");
        this.bx.setRawStyleProperty("width", "50%");
        this.bx.setRawStyleProperty("white-space", "nowrap");
        this.bx.setRawStyleProperty("text-overflow", "ellipsis");
        this.bx.setRawStyleProperty("vertical-align", "middle");
        this.bx.setRawStyleProperty("overflow", "hidden");
        this.x.append(this.bx);
        this.by = a.createElement("span");
        this.by.setRawStyleProperty("display", "inline-block");
        this.by.setRawStyleProperty("width", "50%");
        this.by.setRawStyleProperty("text-align", "right");
        this.by.setRawStyleProperty("white-space", "nowrap");
        this.by.setRawStyleProperty("text-overflow", "ellipsis");
        this.by.setRawStyleProperty("vertical-align", "middle");
        this.by.setRawStyleProperty("overflow", "hidden");
        this.x.append(this.by);
    }
    get bz() {
        return this.bx;
    }
    get b0() {
        return this.by;
    }
    bn(a, b) {
        super.bn(a, b);
        let c = Math.max(0, a - b);
        if (this.b2 != c) {
            this.b2 = c;
        }
    }
    bi(a, b) {
        super.bi(a, b);
        let c = Math.max(0, a - b);
        if (this.b1 != c) {
            this.b1 = c;
        }
    }
    get_p() {
        return false;
    }
}
SummaryCell.$t = markType(SummaryCell, 'SummaryCell', GridCellBase.$);
//# sourceMappingURL=SummaryCell.js.map