/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { TemplateCellContainer } from "./TemplateCellContainer";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class TemplateCell extends GridCellBase {
    constructor(a) {
        super(a);
        this.bx = null;
        this.bx = new TemplateCellContainer(a);
        this.bx.element.setRawStyleProperty("box-sizing", "border-box");
        this.x.append(this.bx.element);
    }
    get by() {
        return this.bx;
    }
    get_p() {
        return true;
    }
    a9(a, b, c) {
        super.a9(a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.bx.element.setRawStyleProperty("margin-left", this.ar + this.at + this.as + "px");
        }
    }
}
TemplateCell.$t = markType(TemplateCell, 'TemplateCell', GridCellBase.$);
//# sourceMappingURL=TemplateCell.js.map