/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SectionHeader } from "./SectionHeader";
import { markType } from "igniteui-angular-core";
import { TemplateSectionHeaderCellModel } from "./TemplateSectionHeaderCellModel";
import { TemplateSectionHeaderCellUpdatingEventArgs } from "./TemplateSectionHeaderCellUpdatingEventArgs";
/**
 * @hidden
 */
export class TemplateSectionHeader extends SectionHeader {
    constructor() {
        super(...arguments);
        this.cellUpdating = null;
    }
    b8(a, b, c) {
        return "templateSectionHeader";
    }
    l(a) {
        return new TemplateSectionHeaderCellModel();
    }
    eu(a, b) {
        if (this.cellUpdating != null) {
            this.cellUpdating(this, ((() => {
                let $ret = new TemplateSectionHeaderCellUpdatingEventArgs();
                $ret.cellInfo = a;
                $ret.content = b;
                return $ret;
            })()));
        }
    }
}
TemplateSectionHeader.$t = markType(TemplateSectionHeader, 'TemplateSectionHeader', SectionHeader.$);
//# sourceMappingURL=TemplateSectionHeader.js.map