/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class TextCell extends GridCellBase {
    constructor(a) {
        super(a);
        this.bx = null;
        this.b0 = -1;
        this.bz = -1;
        this.bx = a.createElement("span");
        this.x.setRawStyleProperty("text-align", "left");
        this.bx.setRawStyleProperty("display", "inline-block");
        this.bx.setRawStyleProperty("line-height", "normal");
        this.bx.setRawStyleProperty("vertical-align", "middle");
        this.bx.setRawStyleProperty("overflow", "hidden");
        this.bx.setRawStyleProperty("white-space", "nowrap");
        this.bx.setRawStyleProperty("text-overflow", "ellipsis");
        this.x.setRawStyleProperty("vertical-align", "middle");
        this.x.append(this.bx);
    }
    get by() {
        return this.bx;
    }
    bn(a, b) {
        super.bn(a, b);
        let c = Math.max(0, a - b - (this.ar + this.at + this.as));
        if (this.b0 != c) {
            this.b0 = c;
            this.bx.setRawStyleProperty("max-width", c.toString() + "px");
        }
    }
    bi(a, b) {
        super.bi(a, b);
        let c = Math.max(0, a - b);
        if (this.bz != c) {
            this.bz = c;
            this.bx.setRawStyleProperty("max-height", c.toString() + "px");
        }
    }
    get_p() {
        return true;
    }
    a9(a, b, c) {
        super.a9(a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.bx.setRawStyleProperty("margin-left", this.ar + this.at + this.as + "px");
        }
    }
}
TextCell.$t = markType(TextCell, 'TextCell', GridCellBase.$);
//# sourceMappingURL=TextCell.js.map