import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ColumnExchanger as ColumnExchanger_internal } from './ColumnExchanger';
import { IgxColumnExchanger as IgxColumnExchanger } from './igx-column-exchanger';
export class IgxColumnExchangersCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxColumnExchanger.$type) {
            IgxColumnExchanger.$type = markType(IgxColumnExchanger, "IgxColumnExchanger");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxColumnExchanger.$type) {
            IgxColumnExchanger.$type = markType(IgxColumnExchanger, "IgxColumnExchanger");
        }
        let coll = new SyncableObservableCollection$2(IgxColumnExchanger.$type, ColumnExchanger_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxColumnExchanger();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-column-exchangers-collection.js.map