var IgxColumnMovingSeparatorComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
export const IgxColumnMovingSeparatorComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxColumnMovingSeparatorComponent) }];
let IgxColumnMovingSeparatorComponent = IgxColumnMovingSeparatorComponent_1 = class IgxColumnMovingSeparatorComponent extends IgxDefinitionBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ColumnMovingSeparator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the separator width for this column.
    */
    get separatorWidth() {
        return this.i.d1;
    }
    set separatorWidth(v) {
        this.i.d1 = +v;
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxColumnMovingSeparatorComponent.prototype, "separatorWidth", null);
IgxColumnMovingSeparatorComponent = IgxColumnMovingSeparatorComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-column-moving-separator',
        template: ``,
        providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(() => IgxColumnMovingSeparatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxColumnMovingSeparatorComponent);
export { IgxColumnMovingSeparatorComponent };
//# sourceMappingURL=igx-column-moving-separator-component.js.map