import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { GridFilterDialogViewModelRow as GridFilterDialogViewModelRow_internal } from './GridFilterDialogViewModelRow';
import { IgxGridFilterDialogViewModelRow as IgxGridFilterDialogViewModelRow } from './igx-grid-filter-dialog-view-model-row';
export class IgxGridFilterDialogViewModelRowCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxGridFilterDialogViewModelRow.$type) {
            IgxGridFilterDialogViewModelRow.$type = markType(IgxGridFilterDialogViewModelRow, "IgxGridFilterDialogViewModelRow");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxGridFilterDialogViewModelRow.$type) {
            IgxGridFilterDialogViewModelRow.$type = markType(IgxGridFilterDialogViewModelRow, "IgxGridFilterDialogViewModelRow");
        }
        let coll = new SyncableObservableCollection$2(IgxGridFilterDialogViewModelRow.$type, GridFilterDialogViewModelRow_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxGridFilterDialogViewModelRow();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-grid-filter-dialog-view-model-row-collection.js.map