import { IgxFilterExpressionCollection } from "igniteui-angular-core";
import { GridFilterExpressionsEventArgs as GridFilterExpressionsEventArgs_internal } from "./GridFilterExpressionsEventArgs";
export class IgxGridFilterExpressionsEventArgs {
    createImplementation() {
        return new GridFilterExpressionsEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get filterExpressions() {
        if (this.i.a == null) {
            return null;
        }
        if (!this.i.a.externalObject) {
            let e = new IgxFilterExpressionCollection();
            e._implementation = this.i.a;
            this.i.a.externalObject = e;
        }
        return this.i.a.externalObject;
    }
    set filterExpressions(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
}
//# sourceMappingURL=igx-grid-filter-expressions-event-args.js.map