import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { CellRange as CellRange_internal } from './CellRange';
import { IgxCellRange as IgxCellRange } from './igx-cell-range';
export class IgxGridSelectedCellRangesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxCellRange.$type) {
            IgxCellRange.$type = markType(IgxCellRange, "IgxCellRange");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxCellRange.$type) {
            IgxCellRange.$type = markType(IgxCellRange, "IgxCellRange");
        }
        let coll = new SyncableObservableCollection$2(IgxCellRange.$type, CellRange_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxCellRange();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-grid-selected-cell-ranges-collection.js.map