import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ResponsivePhase as ResponsivePhase_internal } from './ResponsivePhase';
import { IgxResponsivePhase as IgxResponsivePhase } from './igx-responsive-phase';
export class IgxResponsivePhasesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxResponsivePhase.$type) {
            IgxResponsivePhase.$type = markType(IgxResponsivePhase, "IgxResponsivePhase");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxResponsivePhase.$type) {
            IgxResponsivePhase.$type = markType(IgxResponsivePhase, "IgxResponsivePhase");
        }
        let coll = new SyncableObservableCollection$2(IgxResponsivePhase.$type, ResponsivePhase_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxResponsivePhase();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-responsive-phases-collection.js.map