import { ResponsiveStateExitedEventArgs as ResponsiveStateExitedEventArgs_internal } from "./ResponsiveStateExitedEventArgs";
/**
 * Information about the exited state.
*/
export class IgxResponsiveStateExitedEventArgs {
    createImplementation() {
        return new ResponsiveStateExitedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}
//# sourceMappingURL=igx-responsive-state-exited-event-args.js.map