import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ResponsiveState as ResponsiveState_internal } from './ResponsiveState';
import { IgxResponsiveState as IgxResponsiveState } from './igx-responsive-state';
export class IgxResponsiveStatesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxResponsiveState.$type) {
            IgxResponsiveState.$type = markType(IgxResponsiveState, "IgxResponsiveState");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxResponsiveState.$type) {
            IgxResponsiveState.$type = markType(IgxResponsiveState, "IgxResponsiveState");
        }
        let coll = new SyncableObservableCollection$2(IgxResponsiveState.$type, ResponsiveState_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxResponsiveState();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-responsive-states-collection.js.map