import { SummaryData as SummaryData_internal } from "./SummaryData";
/**
 * Object used to store summary information for group headers.
*/
export class IgxSummaryData {
    createImplementation() {
        return new SummaryData_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get summaryName() {
        return this.i.e;
    }
    set summaryName(v) {
        this.i.e = v;
    }
    get summaryValue() {
        return this.i.b;
    }
    set summaryValue(v) {
        this.i.b = v;
    }
    get summaryOperand() {
        return this.i.a;
    }
    set summaryOperand(v) {
        this.i.a = v;
    }
    get formattedText() {
        return this.i.c;
    }
    set formattedText(v) {
        this.i.c = v;
    }
    get formattedValue() {
        return this.i.d;
    }
    set formattedValue(v) {
        this.i.d = v;
    }
}
//# sourceMappingURL=igx-summary-data.js.map