import { IgxCellInfo } from "./igx-cell-info";
import { TextCellModel as TextCellModel_internal } from "./TextCellModel";
/**
 * Backing information for a text cell in the grid.
*/
export class IgxTextCellInfo extends IgxCellInfo {
    createImplementation() {
        return new TextCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the text value for the cell.
    */
    get textValue() {
        return this.i.ij;
    }
    set textValue(v) {
        this.i.ij = v;
    }
}
//# sourceMappingURL=igx-text-cell-info.js.map