/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType } from "igniteui-angular-core";
import { MinSummaryCalculator } from "igniteui-angular-core";
import { MaxSummaryCalculator } from "igniteui-angular-core";
import { SumSummaryCalculator } from "igniteui-angular-core";
import { AverageSummaryCalculator } from "igniteui-angular-core";
import { CountSummaryCalculator } from "igniteui-angular-core";
import { FormatSummaryTextEventArgs } from "./FormatSummaryTextEventArgs";
/**
 * @hidden
 */
var ColumnSummaryDescription = /** @class */ (function (_super) {
    tslib_1.__extends(ColumnSummaryDescription, _super);
    function ColumnSummaryDescription(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.i = false;
        _this.a = 0;
        _this.q = null;
        _this.d = 0;
        _this.b = null;
        _this.o = null;
        _this.p = null;
        _this.m = null;
        _this.j = 10;
        _this.formatText = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0: break;
            case 1:
                {
                    var c = _rest[0];
                    _this.t = c;
                    _this.e = 4;
                }
                break;
            case 2:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this.t = c;
                    _this.e = d;
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(ColumnSummaryDescription.prototype, "t", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnSummaryDescription.prototype, "e", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            switch (this.d) {
                case 0:
                    this.c = new MinSummaryCalculator();
                    break;
                case 1:
                    this.c = new MaxSummaryCalculator();
                    break;
                case 2:
                    this.c = new SumSummaryCalculator();
                    break;
                case 3:
                    this.c = new AverageSummaryCalculator();
                    break;
                case 4:
                    this.c = new CountSummaryCalculator();
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnSummaryDescription.prototype, "c", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnSummaryDescription.prototype, "r", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            this.o = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnSummaryDescription.prototype, "s", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnSummaryDescription.prototype, "n", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            this.m = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnSummaryDescription.prototype, "l", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
        },
        enumerable: true,
        configurable: true
    });
    ColumnSummaryDescription.prototype.equals = function (a) {
        var b = a;
        if (b == null) {
            return _super.prototype.equals.call(this, a);
        }
        return b.t == this.t && b.e == this.e;
    };
    ColumnSummaryDescription.prototype.getHashCode = function () {
        return Base.getHashCodeStatic(this.t) * 17 + this.e;
    };
    ColumnSummaryDescription.prototype.f = function (a, b, c) {
        var _this = this;
        var d = ((function () {
            var $ret = new FormatSummaryTextEventArgs();
            $ret.e = _this.t;
            $ret.b = _this.s;
            $ret.a = a;
            $ret.c = b;
            $ret.d = c;
            return $ret;
        })());
        if (this.formatText != null) {
            this.formatText(this, d);
        }
        return d;
    };
    ColumnSummaryDescription.$t = markType(ColumnSummaryDescription, 'ColumnSummaryDescription');
    return ColumnSummaryDescription;
}(Base));
export { ColumnSummaryDescription };
//# sourceMappingURL=ColumnSummaryDescription.js.map