/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { SectionHeader } from "./SectionHeader";
import { markType } from "igniteui-angular-core";
import { TemplateSectionHeaderCellModel } from "./TemplateSectionHeaderCellModel";
import { TemplateSectionHeaderCellUpdatingEventArgs } from "./TemplateSectionHeaderCellUpdatingEventArgs";
/**
 * @hidden
 */
var TemplateSectionHeader = /** @class */ (function (_super) {
    tslib_1.__extends(TemplateSectionHeader, _super);
    function TemplateSectionHeader() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.cellUpdating = null;
        return _this;
    }
    TemplateSectionHeader.prototype.b8 = function (a, b, c) {
        return "templateSectionHeader";
    };
    TemplateSectionHeader.prototype.l = function (a) {
        return new TemplateSectionHeaderCellModel();
    };
    TemplateSectionHeader.prototype.eu = function (a, b) {
        if (this.cellUpdating != null) {
            this.cellUpdating(this, ((function () {
                var $ret = new TemplateSectionHeaderCellUpdatingEventArgs();
                $ret.cellInfo = a;
                $ret.content = b;
                return $ret;
            })()));
        }
    };
    TemplateSectionHeader.$t = markType(TemplateSectionHeader, 'TemplateSectionHeader', SectionHeader.$);
    return TemplateSectionHeader;
}(SectionHeader));
export { TemplateSectionHeader };
//# sourceMappingURL=TemplateSectionHeader.js.map