/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { GridCellBase } from "./GridCellBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var TextCell = /** @class */ (function (_super) {
    tslib_1.__extends(TextCell, _super);
    function TextCell(a) {
        var _this = _super.call(this, a) || this;
        _this.bx = null;
        _this.b0 = -1;
        _this.bz = -1;
        _this.bx = a.createElement("span");
        _this.x.setRawStyleProperty("text-align", "left");
        _this.bx.setRawStyleProperty("display", "inline-block");
        _this.bx.setRawStyleProperty("line-height", "normal");
        _this.bx.setRawStyleProperty("vertical-align", "middle");
        _this.bx.setRawStyleProperty("overflow", "hidden");
        _this.bx.setRawStyleProperty("white-space", "nowrap");
        _this.bx.setRawStyleProperty("text-overflow", "ellipsis");
        _this.x.setRawStyleProperty("vertical-align", "middle");
        _this.x.append(_this.bx);
        return _this;
    }
    Object.defineProperty(TextCell.prototype, "by", {
        get: function () {
            return this.bx;
        },
        enumerable: true,
        configurable: true
    });
    TextCell.prototype.bn = function (a, b) {
        _super.prototype.bn.call(this, a, b);
        var c = Math.max(0, a - b - (this.ar + this.at + this.as));
        if (this.b0 != c) {
            this.b0 = c;
            this.bx.setRawStyleProperty("max-width", c.toString() + "px");
        }
    };
    TextCell.prototype.bi = function (a, b) {
        _super.prototype.bi.call(this, a, b);
        var c = Math.max(0, a - b);
        if (this.bz != c) {
            this.bz = c;
            this.bx.setRawStyleProperty("max-height", c.toString() + "px");
        }
    };
    TextCell.prototype.get_p = function () {
        return true;
    };
    TextCell.prototype.a9 = function (a, b, c) {
        _super.prototype.a9.call(this, a, b, c);
        if (a == "Indent" || a == "IsCollapsable") {
            this.bx.setRawStyleProperty("margin-left", this.ar + this.at + this.as + "px");
        }
    };
    TextCell.$t = markType(TextCell, 'TextCell', GridCellBase.$);
    return TextCell;
}(GridCellBase));
export { TextCell };
//# sourceMappingURL=TextCell.js.map