import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ColumnMovingSeparator } from "./ColumnMovingSeparator";
export var IgxColumnMovingSeparatorComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxColumnMovingSeparatorComponent; }) }];
var IgxColumnMovingSeparatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxColumnMovingSeparatorComponent, _super);
    function IgxColumnMovingSeparatorComponent() {
        return _super.call(this) || this;
    }
    IgxColumnMovingSeparatorComponent_1 = IgxColumnMovingSeparatorComponent;
    IgxColumnMovingSeparatorComponent.prototype.createImplementation = function () {
        return new ColumnMovingSeparator();
    };
    Object.defineProperty(IgxColumnMovingSeparatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnMovingSeparatorComponent.prototype, "separatorWidth", {
        /**
         * Gets or sets the separator width for this column.
        */
        get: function () {
            return this.i.d1;
        },
        set: function (v) {
            this.i.d1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    var IgxColumnMovingSeparatorComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxColumnMovingSeparatorComponent.prototype, "separatorWidth", null);
    IgxColumnMovingSeparatorComponent = IgxColumnMovingSeparatorComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-column-moving-separator',
            template: "",
            providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxColumnMovingSeparatorComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxColumnMovingSeparatorComponent);
    return IgxColumnMovingSeparatorComponent;
}(IgxDefinitionBaseComponent));
export { IgxColumnMovingSeparatorComponent };
//# sourceMappingURL=igx-column-moving-separator-component.js.map