import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ColumnPropertySetter as ColumnPropertySetter_internal } from './ColumnPropertySetter';
import { IgxColumnPropertySetter as IgxColumnPropertySetter } from './igx-column-property-setter';
var IgxColumnPropertySettersCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxColumnPropertySettersCollection, _super);
    function IgxColumnPropertySettersCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxColumnPropertySetter.$type) {
            IgxColumnPropertySetter.$type = markType(IgxColumnPropertySetter, "IgxColumnPropertySetter");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxColumnPropertySettersCollection.prototype._createInnerColl = function () {
        if (!IgxColumnPropertySetter.$type) {
            IgxColumnPropertySetter.$type = markType(IgxColumnPropertySetter, "IgxColumnPropertySetter");
        }
        var coll = new SyncableObservableCollection$2(IgxColumnPropertySetter.$type, ColumnPropertySetter_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxColumnPropertySetter();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxColumnPropertySettersCollection;
}(IgCollection));
export { IgxColumnPropertySettersCollection };
//# sourceMappingURL=igx-column-property-setters-collection.js.map