import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { ColumnResizingSeparator } from "./ColumnResizingSeparator";
export var IgxColumnResizingSeparatorComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxColumnResizingSeparatorComponent; }) }];
var IgxColumnResizingSeparatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxColumnResizingSeparatorComponent, _super);
    function IgxColumnResizingSeparatorComponent() {
        return _super.call(this) || this;
    }
    IgxColumnResizingSeparatorComponent_1 = IgxColumnResizingSeparatorComponent;
    IgxColumnResizingSeparatorComponent.prototype.createImplementation = function () {
        return new ColumnResizingSeparator();
    };
    Object.defineProperty(IgxColumnResizingSeparatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxColumnResizingSeparatorComponent.prototype, "separatorWidth", {
        /**
         * Gets or sets the separator width for this column.
        */
        get: function () {
            return this.i.d1;
        },
        set: function (v) {
            this.i.d1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    var IgxColumnResizingSeparatorComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxColumnResizingSeparatorComponent.prototype, "separatorWidth", null);
    IgxColumnResizingSeparatorComponent = IgxColumnResizingSeparatorComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-column-resizing-separator',
            template: "",
            providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxColumnResizingSeparatorComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxColumnResizingSeparatorComponent);
    return IgxColumnResizingSeparatorComponent;
}(IgxDefinitionBaseComponent));
export { IgxColumnResizingSeparatorComponent };
//# sourceMappingURL=igx-column-resizing-separator-component.js.map