import { FormatGroupTextEventArgs as FormatGroupTextEventArgs_internal } from "./FormatGroupTextEventArgs";
var IgxFormatGroupTextEventArgs = /** @class */ (function () {
    function IgxFormatGroupTextEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxFormatGroupTextEventArgs.prototype.createImplementation = function () {
        return new FormatGroupTextEventArgs_internal();
    };
    Object.defineProperty(IgxFormatGroupTextEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxFormatGroupTextEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxFormatGroupTextEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxFormatGroupTextEventArgs.prototype, "groupName", {
        /**
         * Gets the group name.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatGroupTextEventArgs.prototype, "groupValue", {
        /**
         * Gets the original value before formatting.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatGroupTextEventArgs.prototype, "formattedValue", {
        /**
         * Gets the group value as text, formatted based on the GroupDescription's ValueFormat.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatGroupTextEventArgs.prototype, "formattedText", {
        /**
         * Gets or sets the final text that will be displayed in the group header.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxFormatGroupTextEventArgs;
}());
export { IgxFormatGroupTextEventArgs };
//# sourceMappingURL=igx-format-group-text-event-args.js.map