import { FormatSummaryTextEventArgs as FormatSummaryTextEventArgs_internal } from "./FormatSummaryTextEventArgs";
var IgxFormatSummaryTextEventArgs = /** @class */ (function () {
    function IgxFormatSummaryTextEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxFormatSummaryTextEventArgs.prototype.createImplementation = function () {
        return new FormatSummaryTextEventArgs_internal();
    };
    Object.defineProperty(IgxFormatSummaryTextEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxFormatSummaryTextEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxFormatSummaryTextEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxFormatSummaryTextEventArgs.prototype, "propertyPath", {
        /**
         * Gets the summary property name.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatSummaryTextEventArgs.prototype, "displayName", {
        /**
         * Gets the summary display name.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatSummaryTextEventArgs.prototype, "summaryResult", {
        /**
         * Gets the original value before formatting.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatSummaryTextEventArgs.prototype, "formattedResult", {
        /**
         * Gets or sets the summary value as formatted text.  Setting this property will only affect summary cells.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFormatSummaryTextEventArgs.prototype, "formattedText", {
        /**
         * Gets or sets the final text that will be displayed in the group header.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxFormatSummaryTextEventArgs;
}());
export { IgxFormatSummaryTextEventArgs };
//# sourceMappingURL=igx-format-summary-text-event-args.js.map