import { IgxColumnGroupDescriptionCollection } from "./igx-column-group-description-collection";
import { GridGroupDescriptionsChangedEventArgs as GridGroupDescriptionsChangedEventArgs_internal } from "./GridGroupDescriptionsChangedEventArgs";
/**
 * Information about the current grouping applied to the grid.
*/
var IgxGridGroupDescriptionsChangedEventArgs = /** @class */ (function () {
    function IgxGridGroupDescriptionsChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridGroupDescriptionsChangedEventArgs.prototype.createImplementation = function () {
        return new GridGroupDescriptionsChangedEventArgs_internal();
    };
    Object.defineProperty(IgxGridGroupDescriptionsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridGroupDescriptionsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxGridGroupDescriptionsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridGroupDescriptionsChangedEventArgs.prototype, "groupDescriptions", {
        get: function () {
            if (this.i.groupDescriptions == null) {
                return null;
            }
            if (!this.i.groupDescriptions.externalObject) {
                var e = new IgxColumnGroupDescriptionCollection();
                e._implementation = this.i.groupDescriptions;
                this.i.groupDescriptions.externalObject = e;
            }
            return this.i.groupDescriptions.externalObject;
        },
        set: function (v) {
            v == null ? this.i.groupDescriptions = null : this.i.groupDescriptions = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGridGroupDescriptionsChangedEventArgs;
}());
export { IgxGridGroupDescriptionsChangedEventArgs };
//# sourceMappingURL=igx-grid-group-descriptions-changed-event-args.js.map