import { IgxColumnSortDescriptionCollection } from "./igx-column-sort-description-collection";
import { GridSortDescriptionsChangedEventArgs as GridSortDescriptionsChangedEventArgs_internal } from "./GridSortDescriptionsChangedEventArgs";
/**
 * Information about the current sorting applied to the grid.
*/
var IgxGridSortDescriptionsChangedEventArgs = /** @class */ (function () {
    function IgxGridSortDescriptionsChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGridSortDescriptionsChangedEventArgs.prototype.createImplementation = function () {
        return new GridSortDescriptionsChangedEventArgs_internal();
    };
    Object.defineProperty(IgxGridSortDescriptionsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridSortDescriptionsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxGridSortDescriptionsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGridSortDescriptionsChangedEventArgs.prototype, "sortDescriptions", {
        get: function () {
            if (this.i.sortDescriptions == null) {
                return null;
            }
            if (!this.i.sortDescriptions.externalObject) {
                var e = new IgxColumnSortDescriptionCollection();
                e._implementation = this.i.sortDescriptions;
                this.i.sortDescriptions.externalObject = e;
            }
            return this.i.sortDescriptions.externalObject;
        },
        set: function (v) {
            v == null ? this.i.sortDescriptions = null : this.i.sortDescriptions = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGridSortDescriptionsChangedEventArgs;
}());
export { IgxGridSortDescriptionsChangedEventArgs };
//# sourceMappingURL=igx-grid-sort-descriptions-changed-event-args.js.map