import { GroupData as GroupData_internal } from "./GroupData";
/**
 * Object used to store group information for group headers.
*/
var IgxGroupData = /** @class */ (function () {
    function IgxGroupData() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxGroupData.prototype.createImplementation = function () {
        return new GroupData_internal();
    };
    Object.defineProperty(IgxGroupData.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxGroupData.prototype.onImplementationCreated = function () {
    };
    IgxGroupData.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxGroupData.prototype, "groupName", {
        /**
         * The grouping key.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGroupData.prototype, "groupValue", {
        /**
         * The group value.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGroupData.prototype, "formattedText", {
        /**
         * The value as formatted text.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxGroupData;
}());
export { IgxGroupData };
//# sourceMappingURL=igx-group-data.js.map