import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ResponsivePhase as ResponsivePhase_internal } from './ResponsivePhase';
import { IgxResponsivePhase as IgxResponsivePhase } from './igx-responsive-phase';
var IgxResponsivePhasesCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxResponsivePhasesCollection, _super);
    function IgxResponsivePhasesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxResponsivePhase.$type) {
            IgxResponsivePhase.$type = markType(IgxResponsivePhase, "IgxResponsivePhase");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxResponsivePhasesCollection.prototype._createInnerColl = function () {
        if (!IgxResponsivePhase.$type) {
            IgxResponsivePhase.$type = markType(IgxResponsivePhase, "IgxResponsivePhase");
        }
        var coll = new SyncableObservableCollection$2(IgxResponsivePhase.$type, ResponsivePhase_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxResponsivePhase();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxResponsivePhasesCollection;
}(IgCollection));
export { IgxResponsivePhasesCollection };
//# sourceMappingURL=igx-responsive-phases-collection.js.map