import { ResponsiveStateExitedEventArgs as ResponsiveStateExitedEventArgs_internal } from "./ResponsiveStateExitedEventArgs";
/**
 * Information about the exited state.
*/
var IgxResponsiveStateExitedEventArgs = /** @class */ (function () {
    function IgxResponsiveStateExitedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxResponsiveStateExitedEventArgs.prototype.createImplementation = function () {
        return new ResponsiveStateExitedEventArgs_internal();
    };
    Object.defineProperty(IgxResponsiveStateExitedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxResponsiveStateExitedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxResponsiveStateExitedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return IgxResponsiveStateExitedEventArgs;
}());
export { IgxResponsiveStateExitedEventArgs };
//# sourceMappingURL=igx-responsive-state-exited-event-args.js.map