import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { ResponsiveState as ResponsiveState_internal } from './ResponsiveState';
import { IgxResponsiveState as IgxResponsiveState } from './igx-responsive-state';
var IgxResponsiveStatesCollection = /** @class */ (function (_super) {
    tslib_1.__extends(IgxResponsiveStatesCollection, _super);
    function IgxResponsiveStatesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxResponsiveState.$type) {
            IgxResponsiveState.$type = markType(IgxResponsiveState, "IgxResponsiveState");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxResponsiveStatesCollection.prototype._createInnerColl = function () {
        if (!IgxResponsiveState.$type) {
            IgxResponsiveState.$type = markType(IgxResponsiveState, "IgxResponsiveState");
        }
        var coll = new SyncableObservableCollection$2(IgxResponsiveState.$type, ResponsiveState_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxResponsiveState();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxResponsiveStatesCollection;
}(IgCollection));
export { IgxResponsiveStatesCollection };
//# sourceMappingURL=igx-responsive-states-collection.js.map