import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { SectionFooter } from "./SectionFooter";
/**
 * Used to configure the appearance of the section footer cells.
*/
export var IgxSectionFooterComponent_PROVIDERS = [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxSectionFooterComponent; }) }];
var IgxSectionFooterComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxSectionFooterComponent, _super);
    function IgxSectionFooterComponent() {
        return _super.call(this) || this;
    }
    IgxSectionFooterComponent_1 = IgxSectionFooterComponent;
    IgxSectionFooterComponent.prototype.createImplementation = function () {
        return new SectionFooter();
    };
    Object.defineProperty(IgxSectionFooterComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    var IgxSectionFooterComponent_1;
    IgxSectionFooterComponent = IgxSectionFooterComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-section-footer',
            template: "",
            providers: [{ provide: IgxDefinitionBaseComponent, useExisting: forwardRef(function () { return IgxSectionFooterComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxSectionFooterComponent);
    return IgxSectionFooterComponent;
}(IgxDefinitionBaseComponent));
export { IgxSectionFooterComponent };
//# sourceMappingURL=igx-section-footer-component.js.map