import * as tslib_1 from "tslib";
import { IgxTemplateCellInfo } from "./igx-template-cell-info";
import { TemplateHeaderCellModel as TemplateHeaderCellModel_internal } from "./TemplateHeaderCellModel";
import { ensureBool } from "igniteui-angular-core";
/**
 * Backing information for the template header cells.
*/
var IgxTemplateHeaderCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTemplateHeaderCellInfo, _super);
    function IgxTemplateHeaderCellInfo() {
        return _super.call(this) || this;
    }
    IgxTemplateHeaderCellInfo.prototype.createImplementation = function () {
        return new TemplateHeaderCellModel_internal();
    };
    Object.defineProperty(IgxTemplateHeaderCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTemplateHeaderCellInfo.prototype, "isFilterUIVisible", {
        /**
         * Sets or gets whether the filter UI should be visible in the header.
        */
        get: function () {
            return this.i.im;
        },
        set: function (v) {
            this.i.im = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgxTemplateHeaderCellInfo;
}(IgxTemplateCellInfo));
export { IgxTemplateHeaderCellInfo };
//# sourceMappingURL=igx-template-header-cell-info.js.map