import * as tslib_1 from "tslib";
import { IgxCellInfo } from "./igx-cell-info";
import { TextCellModel as TextCellModel_internal } from "./TextCellModel";
/**
 * Backing information for a text cell in the grid.
*/
var IgxTextCellInfo = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTextCellInfo, _super);
    function IgxTextCellInfo() {
        return _super.call(this) || this;
    }
    IgxTextCellInfo.prototype.createImplementation = function () {
        return new TextCellModel_internal();
    };
    Object.defineProperty(IgxTextCellInfo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTextCellInfo.prototype, "textValue", {
        /**
         * Sets or gets the text value for the cell.
        */
        get: function () {
            return this.i.ij;
        },
        set: function (v) {
            this.i.ij = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgxTextCellInfo;
}(IgxCellInfo));
export { IgxTextCellInfo };
//# sourceMappingURL=igx-text-cell-info.js.map