import { Base, Type } from "igniteui-angular-core";
import { INativeCell } from "./INativeCell";
import { DomRenderer, NormalizedEvent } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { TextBlock } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { FontInfo } from "igniteui-angular-core";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { Brush } from "igniteui-angular-core";
import { CellModel } from "./CellModel";
import { ICellActionManager } from "./ICellActionManager";
/**
 * @hidden
 */
export declare class CanvasGridCellBase extends Base implements INativeCell {
    static $t: Type;
    private a;
    private q;
    private o;
    protected x: boolean;
    ch(a: () => void): void;
    private k;
    protected b2(): void;
    readonly isCanvasBased: boolean;
    private bj;
    readonly bk: DomRenderer;
    private bw;
    ci(a: string): void;
    constructor(a: DomRenderer);
    readonly templateContext: any;
    private l;
    t: boolean;
    protected get_z(): boolean;
    readonly z: boolean;
    b9(a: Brush, b: number, c: number, d: number, e: number): void;
    private an;
    ca(a: number): void;
    private ar;
    readonly a9: number;
    private at;
    readonly bb: number;
    private as;
    readonly ba: number;
    private aq;
    readonly a8: number;
    private cs;
    private af;
    readonly a4: number;
    private ah;
    readonly a6: number;
    private ag;
    readonly a5: number;
    private ae;
    readonly a3: number;
    private cz;
    private cw;
    private cy;
    private cx;
    private cv;
    private ax;
    protected readonly bd: number;
    private az;
    protected readonly bf: number;
    private a0;
    private a1;
    protected readonly bg: number;
    private bl;
    private j;
    private aj;
    private ai;
    private al;
    private ak;
    protected get_aa(): boolean;
    protected readonly aa: boolean;
    by(a: RenderingContext, b: number, c: number, d: number, e: number, f: number): void;
    readonly resized: boolean;
    private s;
    ensureCorrectSize(): boolean;
    protected bz(a: RenderingContext, b: number, c: number, d: number, e: number, f: number, g: boolean, h: boolean, i: boolean): void;
    b3(): void;
    cg(a: number): void;
    renderStandardContent(): void;
    renderStandardBackground(): void;
    protected b4(a: RenderingContext): void;
    protected b0(): void;
    private u;
    private bc;
    cf(a: number, b: number, c: number, d: number): void;
    private ay;
    be: number;
    private cr;
    private cu;
    cj(a: Color): void;
    protected get_y(): boolean;
    readonly y: boolean;
    private r;
    ab: boolean;
    private ap;
    readonly a7: number;
    private a2;
    readonly bi: number;
    cc(a: number): void;
    cl(a: number): void;
    bx(): void;
    private ct;
    private m;
    b8(a: Color): void;
    private g;
    private c;
    private e;
    private bv;
    ce(a: number): void;
    private aw;
    private av;
    private static bs;
    cp(a: number): void;
    b1(a: number, b: number, c: number, d: number): void;
    private i;
    private p;
    private bo;
    cb(a: FontInfo): void;
    co(a: CellModel): void;
    cm(a: CellContentHorizontalAlignment, b: CellContentVerticalAlignment): void;
    cn(a: Brush): void;
    b7(a: ICellActionManager): void;
    private bt;
    private bu;
    private n;
    private bm;
    private static bp;
    private b;
    protected readonly d: CellContentHorizontalAlignment;
    cd(a: CellContentHorizontalAlignment): void;
    private ao;
    private h;
    private bq;
    private cq;
    private am;
    protected bh(a: TextBlock, b: string, c: number, d: RenderingContext): number;
    private f;
    ck(a: CellContentVerticalAlignment): void;
    protected ad(a: ICellActionManager): boolean;
    private static bn;
    private au;
    onContactStarted(a: NormalizedEvent, b: boolean): void;
    onContactMoved(a: NormalizedEvent, b: boolean): void;
    onContactCompleted(a: NormalizedEvent, b: boolean): void;
}
