import { Type } from "igniteui-angular-core";
/**
 * Identifies the operator type of a column comparison condition.
 */
export declare enum ColumnComparisonConditionOperatorType {
    Contains = 0,
    DoesNotContain = 1,
    DoesNotEndWith = 2,
    DoesNotStartWith = 3,
    EndsWith = 4,
    Equals = 5,
    GreaterThan = 6,
    GreaterThanOrEqualTo = 7,
    LessThan = 8,
    LessThanOrEqualTo = 9,
    NotEquals = 10,
    StartsWith = 11,
    IsNotNull = 12,
    IsNull = 13
}
/**
 * @hidden
 */
export declare let ColumnComparisonConditionOperatorType_$type: Type;
