import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-angular-core";
import { DomWrapper, DomRenderer } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { GridFilterDialogViewModelRow } from "./GridFilterDialogViewModelRow";
import { DataSourceSchemaPropertyType } from "igniteui-angular-core";
import { GridFilterDialogOpeningEventArgs } from "./GridFilterDialogOpeningEventArgs";
import { ColumnComparisonConditionOperatorType } from "./ColumnComparisonConditionOperatorType";
import { ColumnComparisonFilterCondition } from "./ColumnComparisonFilterCondition";
import { GridFilterDialogFilterChangeEventArgs } from "./GridFilterDialogFilterChangeEventArgs";
import { GridFilterDialogViewModelGroupingLevel } from "./GridFilterDialogViewModelGroupingLevel";
import { GridFilterDialogViewModelGrouping } from "./GridFilterDialogViewModelGrouping";
import { GridFilterDialogViewModelGroupingLevelCollection } from "./GridFilterDialogViewModelGroupingLevelCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class GridFilterDialogView extends Base {
    static $t: Type;
    constructor(a: GridFilterDialog);
    a: GridFilterDialog;
    private x;
    private i;
    private h;
    t(): void;
    private q;
    private m;
    private c;
    private l;
    private f;
    private e;
    private g;
    r(a: any): void;
    private n;
    private o;
    u(): void;
    private k;
    private j;
    s(a: number, b: number): void;
    w(): Brush;
    private d;
    v(a: GridFilterDialogViewModel): void;
    private b;
    p(): void;
}
/**
 * @hidden
 */
export declare class GridFilterDialogPanel extends Base {
    static $t: Type;
    constructor(a: DomWrapper, b: DomRenderer);
    private r;
    private v;
    private s;
    a: GridFilterDialog;
    i: DomWrapper;
    d: DomRenderer;
    h: DomWrapper;
    k: DomWrapper;
    b: GridFilterDialogViewModel;
    g: DomWrapper;
    f: DomWrapper;
    j: DomWrapper;
    e: DomWrapper;
    x(a: GridFilterDialogViewModel): void;
    o(): void;
    p(): void;
    private c;
    private aa;
    private z;
    private y;
    private q;
    private t;
    private n;
    private u;
    private w;
    private l;
    private m;
}
/**
 * @hidden
 */
export declare class GridFilterDialog extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private x;
    y: any;
    private o;
    p: boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private s;
    u: number;
    private r;
    t: number;
    protected ak(a: string, b: any, c: any): void;
    protected an(a: string, b: any, c: any): void;
    constructor();
    ao(a: any): void;
    am(): void;
    private as;
    aj(a: GridFilterDialogViewModel, b: boolean): void;
    private ar;
    private aq;
    private f;
    private ap;
    private e;
    private q;
    private g;
    private w;
    private h;
    private d;
    private c;
    private al;
    private m;
    private af;
    private n;
    static v(a: ColumnComparisonConditionOperatorType): number;
    static z(a: number, b: ColumnComparisonConditionOperatorType, c: ColumnComparisonFilterCondition): any;
    static aa(a: number, b: ColumnComparisonConditionOperatorType, c: ColumnComparisonFilterCondition): any;
    static b(a: ColumnComparisonConditionOperatorType[]): number[];
    static a(a: ColumnComparisonConditionOperatorType[]): string[];
    static ac(a: ColumnComparisonConditionOperatorType): string;
    dialogOpening: (sender: any, args: GridFilterDialogOpeningEventArgs) => void;
    filterChanging: (sender: any, args: GridFilterDialogFilterChangeEventArgs) => void;
    filterChanged: (sender: any, args: GridFilterDialogFilterChangeEventArgs) => void;
    ai(a: number, b: number): void;
    ah(a: number, b: number, c: Path): void;
    ag(a: GridFilterDialogViewModel, b: boolean): void;
    protected l: GridFilterDialogView;
}
/**
 * @hidden
 */
export declare class GridFilterDialogViewModel extends Base {
    static $t: Type;
    a: DataSourceSchemaPropertyType;
    e: GridFilterDialogViewModelGroupingLevelCollection;
    k: boolean;
    n(): void;
    constructor();
    private u;
    private t;
    private r;
    private w;
    private s;
    private q;
    private v;
    private p;
    b(a: number): GridFilterDialogViewModelGrouping;
    c(a: number): GridFilterDialogViewModelGroupingLevel;
    m: number;
    h(a: number, b: number): boolean;
    private i;
    private j;
    private d;
    aa(a: number, b: number): void;
    private x;
    private y;
    l(a: number, b: number): boolean;
    z(a: number, b: number): void;
    o(a: number, b: number, c: boolean): void;
    f: GridFilterDialogViewModelRowCollection;
    onModified: (vm: GridFilterDialogViewModel) => void;
}
/**
 * @hidden
 */
export declare class GridFilterDialogViewModelRowCollection extends ObservableCollection$1<GridFilterDialogViewModelRow> {
    static $t: Type;
    constructor();
    private ah;
    ae: GridFilterDialogViewModel;
    private ai;
    private af;
    ag: (arg1: GridFilterDialogViewModel) => void;
}
