import { GridCellBase } from "./GridCellBase";
import { DomWrapper, DomRenderer } from "igniteui-angular-core";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { Type } from "igniteui-angular-core";
import { ImageResourceType } from "./ImageResourceType";
import { ImageStretchOptions } from "./ImageStretchOptions";
/**
 * @hidden
 */
export declare class ImageCell extends GridCellBase {
    static $t: Type;
    private b3;
    private bx;
    private by;
    private b5;
    private bz;
    private b0;
    private b2;
    readonly b4: DomWrapper;
    b1: number;
    constructor(a: DomRenderer);
    private b8;
    b9(a: string, b: ImageResourceType): void;
    private b7;
    cc(a: ImageStretchOptions): void;
    private cd;
    b6(): void;
    ca(a: CellContentHorizontalAlignment): void;
    cb(a: CellContentVerticalAlignment): void;
    protected get_p(): boolean;
    protected a9(a: string, b: any, c: any): void;
}
