import { CellRange as CellRange_internal } from "./CellRange";
/**
 * An indentifier for a specific cell in the grid.
*/
export declare class IgxCellRange {
    protected createImplementation(): CellRange_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: CellRange_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the start column of the range.
    */
    startColumn: number;
    /**
     * Gets or sets the end column of the range.
    */
    endColumn: number;
    /**
     * Gets or sets the start row of the range.
    */
    startRow: number;
    /**
     * Gets or sets the end row of the range.
    */
    endRow: number;
}
