import { IgxColumnGroupDescription } from "./igx-column-group-description";
import { ColumnGroupDescriptionCollection as ColumnGroupDescriptionCollection_internal } from "./ColumnGroupDescriptionCollection";
/**
 * Represents a collection of grouping elements that are applied to a data source or provider.
*/
export declare class IgxColumnGroupDescriptionCollection {
    protected createImplementation(): ColumnGroupDescriptionCollection_internal;
    protected _implementation: any;
    readonly i: ColumnGroupDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgxColumnGroupDescription): IgxColumnGroupDescription;
    readonly count: number;
    toArray(): IgxColumnGroupDescription[];
    [Symbol.iterator](): IterableIterator<any>;
    add(item: IgxColumnGroupDescription): boolean;
    insert(index: number, item: IgxColumnGroupDescription): void;
    clear(): void;
    indexOf(item: IgxColumnGroupDescription): number;
    remove(item: IgxColumnGroupDescription): boolean;
    removeAt(index: number): IgxColumnGroupDescription;
}
