import { ColumnPropertySetter as ColumnPropertySetter_internal } from "./ColumnPropertySetter";
/**
 * Indicates that a specified column should have a specified property set to a value.
*/
export declare class IgxColumnPropertySetter {
    protected createImplementation(): ColumnPropertySetter_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ColumnPropertySetter_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The name or key of the column to change the property of
    */
    columnName: string;
    /**
     * The name of the property to change
    */
    propertyName: string;
    /**
     * The new value of the property
    */
    value: any;
}
