import { IgxColumnSortDescription } from "./igx-column-sort-description";
import { ColumnSortDescriptionCollection as ColumnSortDescriptionCollection_internal } from "./ColumnSortDescriptionCollection";
/**
 * Represents a collection of sort elements that are applied to a data source or provider.
*/
export declare class IgxColumnSortDescriptionCollection {
    protected createImplementation(): ColumnSortDescriptionCollection_internal;
    protected _implementation: any;
    readonly i: ColumnSortDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgxColumnSortDescription): IgxColumnSortDescription;
    readonly count: number;
    toArray(): IgxColumnSortDescription[];
    [Symbol.iterator](): IterableIterator<any>;
    add(item: IgxColumnSortDescription): boolean;
    insert(index: number, item: IgxColumnSortDescription): void;
    clear(): void;
    indexOf(item: IgxColumnSortDescription): number;
    remove(item: IgxColumnSortDescription): boolean;
    removeAt(index: number): IgxColumnSortDescription;
}
