import { IgxCellInfo } from './igx-cell-info';
import { DataBindingEventArgs as DataBindingEventArgs_internal } from "./DataBindingEventArgs";
/**
 * Information about the data binding taking place.
*/
export declare class IgxDataBindingEventArgs {
    protected createImplementation(): DataBindingEventArgs_internal;
    protected _implementation: any;
    readonly i: DataBindingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The backing information for the current cell.
    */
    readonly cellInfo: IgxCellInfo;
    /**
 * The resolved value for the cell.
*/
    resolvedValue: any;
    /**
     * The data for the row in which the cell is contained.
    */
    rowObject: any;
}
