import { IgxCellInfo } from './igx-cell-info';
import { IgxLiveGridComponent } from './igx-live-grid-component';
import { GridCellEventArgs as GridCellEventArgs_internal } from "./GridCellEventArgs";
/**
 * Information about the cell in context.
*/
export declare class IgxGridCellEventArgs {
    protected createImplementation(): GridCellEventArgs_internal;
    protected _implementation: any;
    readonly i: GridCellEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The backing information for the current cell.
    */
    readonly cellInfo: IgxCellInfo;
    /**
 * Gets the grid owning the cell.
*/
    grid: IgxLiveGridComponent;
}
