import { IgxGridSelectedCellRangesCollection } from "./igx-grid-selected-cell-ranges-collection";
import { GridSelectedCellRangesChangedEventArgs as GridSelectedCellRangesChangedEventArgs_internal } from "./GridSelectedCellRangesChangedEventArgs";
/**
 * Information about the change to the selected cell ranges in the grid.
*/
export declare class IgxGridSelectedCellRangesChangedEventArgs {
    protected createImplementation(): GridSelectedCellRangesChangedEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridSelectedCellRangesChangedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    private _addedRanges;
    /**
     * The cell ranges added to the selection.
    */
    addedRanges: IgxGridSelectedCellRangesCollection;
    private _removedRanges;
    /**
     * The cell ranges removed from the selection.
    */
    removedRanges: IgxGridSelectedCellRangesCollection;
    private _updatedRanges;
    /**
     * The cell ranges that have been updated by the grid.
    */
    updatedRanges: IgxGridSelectedCellRangesCollection;
}
