import { IgxGridSelectedKeysCollection } from "./igx-grid-selected-keys-collection";
import { GridSelectedKeysChangedEventArgs as GridSelectedKeysChangedEventArgs_internal } from "./GridSelectedKeysChangedEventArgs";
/**
 * Information about the change to the selected keys in the grid.
*/
export declare class IgxGridSelectedKeysChangedEventArgs {
    protected createImplementation(): GridSelectedKeysChangedEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GridSelectedKeysChangedEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    private _addedKeys;
    /**
     * The keys added to the selection.
    */
    addedKeys: IgxGridSelectedKeysCollection;
    private _removedKeys;
    /**
     * The keys removed from the selection.
    */
    removedKeys: IgxGridSelectedKeysCollection;
}
