import { GroupData as GroupData_internal } from "./GroupData";
/**
 * Object used to store group information for group headers.
*/
export declare class IgxGroupData {
    protected createImplementation(): GroupData_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: GroupData_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The grouping key.
    */
    groupName: string;
    /**
     * The group value.
    */
    groupValue: any;
    /**
     * The value as formatted text.
    */
    formattedText: string;
}
