import { IgxCellInfo } from "./igx-cell-info";
import { SummaryCellModel as SummaryCellModel_internal } from "./SummaryCellModel";
/**
 * Backing information for a section header cell in the grid.
*/
export declare class IgxSummaryCellInfo extends IgxCellInfo {
    protected createImplementation(): SummaryCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: SummaryCellModel_internal;
    constructor();
    /**
     * Sets or gets the resolved summary text for the summary cell.
    */
    resolvedSummaryText: string;
    /**
     * Sets or gets the resolved summary value for the sumamry cell.
    */
    resolvedSummaryValue: string;
    /**
     * Gets or sets the color of the text for the summary name in the cell.
    */
    summaryNameTextColor: string;
}
