import { SummaryData as SummaryData_internal } from "./SummaryData";
import { SummaryOperand } from "igniteui-angular-core";
/**
 * Object used to store summary information for group headers.
*/
export declare class IgxSummaryData {
    protected createImplementation(): SummaryData_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: SummaryData_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    summaryName: string;
    summaryValue: any;
    summaryOperand: SummaryOperand;
    formattedText: string;
    formattedValue: string;
}
