import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { IgxTextCellInfo } from "./igx-text-cell-info";
import { TextHeaderCellModel as TextHeaderCellModel_internal } from "./TextHeaderCellModel";
/**
 * Backing information for a text header cell.
*/
export declare class IgxTextHeaderCellInfo extends IgxTextCellInfo {
    protected createImplementation(): TextHeaderCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: TextHeaderCellModel_internal;
    constructor();
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    isFilterUIVisible: boolean;
    sortIndicatorStyle: SortIndicatorStyle;
}
