import { Type } from '@angular/core';
import { IgxHeaderComponent } from "./igx-header-component";
import { IgxDefinitionBaseComponent } from "./igx-definition-base-component";
import { TextHeader } from "./TextHeader";
/**
 * Represents a class used to configure the appearance of a text column header cells.
*/
export declare const IgxTextHeaderComponent_PROVIDERS: {
    provide: typeof IgxDefinitionBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTextHeaderComponent extends IgxHeaderComponent {
    protected createImplementation(): TextHeader;
    /**
                                 * @hidden
                                 */
    readonly i: TextHeader;
    constructor();
}
