import { IgxCellInfo } from "./igx-cell-info";
import { VerticalSeparatorCellModel as VerticalSeparatorCellModel_internal } from "./VerticalSeparatorCellModel";
/**
 * Represents backing information for vertical separators.
*/
export declare class IgxVerticalSeparatorCellInfo extends IgxCellInfo {
    protected createImplementation(): VerticalSeparatorCellModel_internal;
    /**
                                 * @hidden
                                 */
    readonly i: VerticalSeparatorCellModel_internal;
    constructor();
    /**
     * Gets or sets whether the vertical separator is hit test visible.
    */
    isHitTestVisible: boolean;
}
